/**
 * 公共构造类
 * 
 * @return
 */
var Class = function() {
    var klass = function() {
        this.init.apply(this, arguments);
    };
    
    klass.prototype.init = function() {};
    
    klass.fn = klass.prototype;
    klass.fn.parent = klass;
    
    klass.extend = function(obj) {
        var extended = obj.extended;
        for (var i in obj) {
            klass[i] = obj[i];
        }
        if (extended) extended(klass);
    };
    
    klass.include = function(obj) {
        var included = obj.included;
        for (var i in obj) {
            klass.fn[i] = obj[i];
        }
        if (included) included(klass);
    };
    
    return klass;
};
//jquery扩展
(function($){
	// 生成随机验证码
	$.fn.setRandomCode = function() {
		var code=""+Math.round(Math.random()*9)+Math.round(Math.random()*9)+Math.round(Math.random()*9)+Math.round(Math.random()*9);
		this.data("randomCode", code);
		this.each(function() {
			$(this).css("background","url("+sdmtv.BASEPATH+"wapts/jsp/login/image.jsp?code="+code+") no-repeat");
//			$(this).css("background","url("+sdmtv.BASEPATH+"wapts/jsp/login/image.jsp?"+Math.random()+") no-repeat");
		});
		return this;
	};
	// 倒计时
	// finished字段表示计时结束
	$.fn.countDown = function(minites, func) {
		if (minites > 0) {
			var m = minites;
			var self = this;
			// 清除已有interval
			if (!self.countDownFinished()) {
				window.clearInterval(self.data("interval"));
			}
			var interval = window.setInterval(function() {
				m-=1;
				self.each(function() {
					$(this).html(m+"s");
				});
				if (m<=0) {
					// 结束倒计时，设置标识
					window.setTimeout(function(){
						window.clearInterval(interval);
						self.removeData("interval");
						if (typeof func == "function") {
							func.call(self);
						}
					},0);
				}
			}, 1000);
			self.data("interval", interval);
		}
		return this;
	};
	// 返回倒计时是否结束
	$.fn.countDownFinished = function() {
		return this.data("interval") === undefined;
	}
	
	// 方法扩展
	var fltr_mobi = /^0{0,1}(13[3-9]|15[7-9]|15[0-3]|18[5-9]|13[0-2]|15[5-6]|18[0]|14[7])[0-9]{8}$/;
	var fltr_mail = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	var fltr_post = /^\d{6}$/;
	$.isMailAddress = function(s) {
		return fltr_mail.test(s);
	};
	$.isPhoneNumber = function(s) {
		return fltr_mobi.test(s);
	};
	$.isPostCode = function(s) {
		return fltr_post.test(s);
	}
	// 获取邮箱网址
	$.getMailURL = function(mail) {
		var url = "";
		if ($.isMailAddress(mail))
		{
			var m = mail.substring(mail.indexOf("@")+1);
			if (m.indexOf("vip.") == 0) {
				url = "http://mail." + m.substring(4);
			} else if (m == "gmail.com") {
				url = "http://" + m;
			} else {
				url = "http://mail." + m;
			}
		}
		return url;
	};
})(jQuery);

/**
 * 检查用户输入信息
 */
jQuery.fn.extend({
    // 检查用户名,非空
    checkUsername: function() {
		if ($.trim($(this).val()) == "") {
			alert("请输入帐号");
			return false;
		}
		return true;
	},
    // 检查用户名，手机号或邮箱
    checkAccount: function() {
		if ($.trim($(this).val()) == "") {
			alert("请输入帐号");
			return false;
		} else if (!$.isMailAddress($(this).val()) && !$.isPhoneNumber($(this).val())) {
			alert("帐号格式不匹配");
			return false;
		}
		return true;
	},
	// 检查手机号
    checkPhoneNumber: function() {
		if ($.trim($(this).val()) == "") {
			alert("请输入手机号");
			return false;
		} else if ($(this).val().length != 11) {
			alert("手机号长度不匹配");
			return false;
		} else if (!$.isPhoneNumber($(this).val())) {
			alert("手机号格式不匹配");
			return false;
		}
		return true;
	},
	// 检查邮箱
	checkEmail: function() {
		if ($.trim($(this).val()) == "") {
			alert("请输入注册邮箱");
			return false;
		} else if (!$.isMailAddress($(this).val())) {
			alert("输入邮箱格式错误");
			return false;
		}
		return true;
	},
    // 检查验证码
    checkRandomCode : function($obj) {
    	if ($.trim($(this).val()) == "") {
    		alert("请输入验证码");
    		return false;
    	} else if ($(this).val().length != 4) {
    		alert("验证码长度不匹配");
    		return false;
    	} else if ($obj.data("randomCode") != $(this).val()) {
    		alert("验证码输入错误");
    		return false;
    	}
    	return true;
    },
    // 检查验证码
    checkSmsCode : function() {
    	if ($.trim($(this).val()) == "") {
    		alert("请输入验证码");
    		return false;
    	} else if ($(this).val().length != 6) {
    		alert("验证码长度不匹配");
    		return false;
    	}
    	return true;
    },
    // 检查密码
    checkPassword: function() {
    	if ($(this).val() == "") {
    		alert("请输入密码");
    		return false;
    	} else if ($(this).val().length < 6 || $(this).val().length > 16) {
    		alert("密码为6-15个数字、字母或符号");
    		return false;
    	} else if (!/(^[\x20-\x7e]{6,16}$)/.test($(this).val())) {
    		alert("密码仅支持6-15个数字、字母或符号");
    		return false;
    	}
    	return true;
    },
    // 检查确认密码
    checkRePassword: function(pass) {
    	if ($(this).val() == "") {
    		alert("请输入确认密码");
    		return false;
    	} else if ($(this).val()!=pass.val()) {
    		alert("密码输入不一致");
    		return false;
    	}
    	return true;
    },
    // 检查昵称
    checkCustomerName : function() {
    	if ($.trim($(this).val()) == "") {
    		alert("请输入昵称");
    		return false;
    	} else if ($(this).val().length < 2 || $(this).val().length > 10) {
    		alert("昵称为2-10个字母、数字或汉字");
    		return false;
    	}
    	return true;
    },
    // 检查当前密码
    checkOldPassword: function() {
    	if ($.trim($(this).val()) == "") {
    		alert("请输入当前密码");
    		return false;
    	} else if (!/(^[\x20-\x7e]{6,16}$)/.test($(this).val())) {
    		alert("当前密码格式错误");
    		return false;
    	}
    	return true;
    },
    // 判断用户是否勾选了同意
    checkFuwu : function() {
    	if(!$(this).is(":checked")){
    		alert("请同意用户注册协议。");
    		return false;
    	}
    	return true;
    },
    // 获取光标在输入框中位置
    getCursorPosition: function() {
        var el = $(this).get(0);
        var pos = 0;
        if('selectionStart' in el) {
            pos = el.selectionStart;
        } else if('selection' in document) {
            el.focus();
            var Sel = document.selection.createRange();
            var SelLength = document.selection.createRange().text.length;
            Sel.moveStart('character', -el.value.length);
            pos = Sel.text.length - SelLength;
        }
        return pos;
    },
    // 设置光标在输入框中位置
    setCursorPosition: function(pos) {
        if ($(this).get(0).setSelectionRange) {
            $(this).get(0).setSelectionRange(pos, pos);
        } else if ($(this).get(0).createTextRange) {
            var range = $(this).get(0).createTextRange();
            range.collapse(true);
            range.moveEnd('character', pos);
            range.moveStart('character', pos);
            range.select();
        }
    }
});

/**
 * 创建嵌入式窗口，主要用于图书阅读器
 */
(function($){
	// 获取窗口，没有则创建
	var getWin = function() {
		var win = $("#common_iframe_div");
		if (win.length == 0) {
			win = $('<div id="common_iframe_div" class="common_iframe_div"></div>');
			$('body').append(win);
		}
		return win;
	}
	// 打开嵌入式窗口
	$.openImbeddedWindow = function(url, func) {
		if (!url) {
			return false;
		}
		var win = getWin();
		win.css("display", "block");
		$.get(url, function(result){
			$("#common_iframe_div").html(result);
		}, "html");
		if (typeof func == "function") {
			func.call(self);
		}
		return true;
	};
	// 关闭嵌入式窗口
	$.closeImbeddedWindow = function() {
		var win = getWin();
		win.children().remove();
		win.css("display", "none");
		return true;
	};
})(jQuery);


/**
 * 自定义密码输入框，解决android白色背景问题
 */
var ResetPassword = new Class();
ResetPassword.extend({
	dots: function(times) {
		return common_repeatChar("•", times);
	},
	getPassInput: function(id, placeholder, value) {
		if(id=="login_password_tmppass"){
			return '<input type="text"  style="margin-left: 10px;padding-left:10px;width:80%;color:#4C4D50;"   id="' + id + '" value="' + value + '" data-role="none" maxlength="16" size="18px" placeholder="' + placeholder + '" />';
		} else if(id=="qiluLogin_password_tmppass"){
			return '<input type="text"  style="color:#4C4D50;float:right;width:180px;margin-top:5px;margin-right:25px;"   id="' + id + '" value="' + value + '" data-role="none" maxlength="16" size="18px" placeholder="' + placeholder + '" />';
		}else {
			return '<input type="text"  style="color:#4C4D50;float:right;width:170px;margin-top:5px;margin-right:15px;"   id="' + id + '" value="' + value + '" data-role="none" maxlength="16" size="18px" placeholder="' + placeholder + '" />';
		}
	}
});
ResetPassword.include({
	id: "",
	tmpid: "",
	task: null,
	init: function(id, placeholder) {
		this.id = "#" + id;
		this.tmpid = "#" + id + "_tmppass";
		if (0 == $(this.id).siblings(this.tmpid).size()){
// var newPassInput = $(this.id).clone().attr("id", id +
// "_tmppass").attr("name", id + "_tmppassName");
			var newPassInput = ResetPassword.getPassInput(id + "_tmppass", placeholder, ResetPassword.dots($(this.id).val().length));
			$(this.id).css("display", "none").after(newPassInput);
		}
	},
	// 将输入框中数据除了最后一个都置为*，最后一个半秒中之后置为*
	reset: function() {
		var that = this,
			password = $(this.id).val(),
			pw = $(this.tmpid).val(),
			curPos = $(this.tmpid).getCursorPosition();
		if (curPos >= pw.length) { // 光标在输入框数据的末尾
			if (this.task != null) {
				window.clearTimeout(this.task);
			}
			if (pw.length > password.length) { // 增加数据
				password += pw.substring(password.length, pw.length);
				$(this.tmpid).val(ResetPassword.dots(password.length-1) + password.substring(password.length - 1, password.length));
				this.task = window.setTimeout(function(){that.setPasswordToDot();}, 500);
			} else if (pw.length < password.length) { // 减少数据
				password = password.substring(0, pw.length);
			}
		} else { // 光标在输入框数据的中间或开头
			var diffLen = pw.length - password.length;
			if (diffLen > 0) { // 增加数据
				password = password.substring(0, curPos - diffLen) + pw.substring(curPos - diffLen, curPos) + password.substring(curPos - diffLen, password.length);
				$(this.tmpid).val(ResetPassword.dots(password.length));
				$(this.tmpid).setCursorPosition(curPos);
			} else if (diffLen < 0){ // 减少数据
				password = password.substring(0, curPos) + password.substring(curPos - diffLen, password.length);
			}
		}
		
		$(this.id).val(password);
	},
	// 将输入框数据值为*
	setPasswordToDot: function() {
		$(this.tmpid).val(ResetPassword.dots($(this.id).val().length));
	},
	// 开始监听input框事件
	start: function() {
		var that = this;
		$(this.tmpid).bind("keyup paste", function(){
			that.reset();
		});
		$(this.tmpid).bind("focus", function() {
			if ($(that.id).val() == "") {
				$(that.tmpid).val("");
			}
		});
	}
});
/**
 * 等待一段时间
 * Waiting.start("abc");
 * Waiting.waited("abc");//返回“abc”等待的时间
 * */
var Waiting = new Class();
Waiting.extend({
	start: function(id) {
		window.localStorage.setItem("waiting__" + id, new Date().getTime());
	},
	waited: function(id) {
		var start = window.localStorage.getItem("waiting__" + id);
		if (start && (typeof start == "string")) {
			return parseInt((new Date().getTime() - parseInt(start)) / 1000);
		} else {
			return -1;
		}
	},
	check: function(id, seconds) {
		var t = Waiting.waited(id);
		if (t>=0 && t< seconds) {
			alert('操作过于频繁，请' + (seconds-t) + '秒后再试');
			return false;
		}
		return true;
	}
});
/**
 * html模板生成
 */
var doTHelper = {};
//根据获取html模板
doTHelper.tmplPagefn = function(elem, tmplType, data, def) {
	var self = this;
	var htmlTmp;
	if (!this[tmplType]) {
		$.ajax({
			type: "POST",
			url: "../../views/"+tmplType+".jst",
			async: false,
			dataType: "text",
			success: function(result) {
				self[tmplType] = doT.template(result, undefined, def);
				htmlTmp = $(self[tmplType](data||{}));
			}
		});
	} else {
		htmlTmp = $(this[tmplType](data||{}));
	}
	$(elem).append(htmlTmp);
	return htmlTmp;
};
