/*function list_generateList(elementId, type, mode, middleContentTop, middleContent,
		middleContentBottom, imgUrl) {*/
/**
 * 方法说明：此方法为生成节目列表的统一调用函数
 * 
 * @param param
 *            param.elementId 页面添加列表的位置的ID param.type
 *            列表的类型：book,tvLive,bdLive,tvDemand,bdDemand,subject,editor param.mode
 *            列表中间部分采用的样式类型，默认提供突出顶部类型,类型分别有 
 *            modeTvLive 如:内容一 
 *            				内容二（放大） 
 *            				内容三
 *            ------------------------------------------- 
 *            modeDemand1	如:内容一（放大且占2行） 
 *            				   内容二 
 *            				   内容三 
 *            -------------------------------------------
 *            modeDemand2 如:内容一（放大） 
 *            				 内容二（占2行） 
 *            				 内容三
 *            ------------------------------------------- 
 *            modeDemand3如:内容一（放大且占2行） 
 *            				内容二（占2行） 
 *            -------------------------------------------
 *            modeBdLive 如:内容一（放大居中） 
 *            -------------------------------------------
 *            modeBook 图书的样式列表 
 *            -------------------------------------------
 *            param.middleContentTop 中间顶部内容 param.middleContent 中间中部内容
 *            param.middleContentBottom 中间底部内容 param.imgUrl 左侧图片
 * @param first_functionName
 *            列表左侧（图片和文字区域点击调用的方法名）
 * @param frist_functionParameter
 *            列表左侧（图片和文字区域点击调用需要传递的参数，为object类型）
 * @param Second_functionName
 *            列表右侧播放按钮调用的函数名称：此处应写 broadcast_unifiedPlayer
 * @param Second_functionParameter
 *            列表右侧播放按钮调用的函数的参数，object类型，具体类型如下，没有的请填写null
 *            Second_functionParameter type 播放类型：电视直播liveVideo 广播直播liveAudio
 *            电视点播video 广播点播audio Second_functionParameter id 播放的ID
 *            Second_functionParameter name 影片名称 Second_functionParameter m3u8
 *            视频地址 Second_functionParameter rtsp 视频地址 Second_functionParameter
 *            customerCollectionId 收藏ID Second_functionParameter channel 频道ID
 *            Second_functionParameter program 栏目ID
 */

var functionObj ;
var tableName ;
var divObj;
var functionParam ;
function list_generateList(param,first_functionName,frist_functionParameter,Second_functionName,Second_functionParameter) {
	var elementId = param.elementId;
	var type = param.type; 
	var mode = param.mode;
	var middleContentTop = param.middleContentTop;
	var middleContent = param.middleContent;
	var middleContentBottom = param.middleContentBottom;
	var imgUrl = param.imgUrl;
	
	
	var ElementDiv = document.getElementById(elementId);
	// 左侧内容区域，包括图片，中间文字
	var Connection = document.createElement("a");
	Connection.href = "javascript:void(0)";
	
	// 设置左侧a标签的事件
	if($.isFunction(first_functionName)){
		Connection.onclick = function() {
			first_functionName(frist_functionParameter,this);
		}
	}
	var div = document.createElement("div");
	var conTable = document.createElement("table");
	conTable.className = "list_tableLeft";
	var conTbody = document.createElement("tbody");
	var conTr = document.createElement("tr");
	var conTd1 = document.createElement("td");
	var bgImgDiv = document.createElement("div");
	conTd1.setAttribute("align", "center");
	if (type == "book" || type == "editorbook") {
		conTd1.className = "list_tableLeftBookTd";
		bgImgDiv.className = "list_bgImgBookDiv";
	} else if(type == "game"){
		conTd1.className = "list_tableLeftGameTd";
		bgImgDiv.className = "list_bgImgGameDiv";
	}else {
		conTd1.className = "list_tableLeftTd";
		bgImgDiv.className = "list_bgImgDiv";
	}
		bgImgDiv.innerHTML = "<img class='imgLazyLoad' src='../../images/empty_1x1.png' data-original='"
			+ sdmtv.IMG_BASEPATH + imgUrl
			+ "' onerror=\"this.style.display='none'\">";
	conTd1.appendChild(bgImgDiv);
	var conTd2 = document.createElement("td");
	conTd2.className = "list_tableMidTd";

	var listMiddleContentTable = document.createElement("table");
	if (type == "book" || type == "editorbook") {
		listMiddleContentTable.className = "list_MiddleBookContent";
	} else {
		listMiddleContentTable.className = "list_MiddleContent";
	}
	var listMiddleContentTbody = document.createElement("tbody");
	// 以下内容根据不同的列表展示，创建不同的内容
	var listTr1 = document.createElement("tr");
	var listTd1 = document.createElement("td");
	
	var listTr2 = document.createElement("tr");
	var listTd2 = document.createElement("td");

	var listTr3 = document.createElement("tr");
	var listTd3 = document.createElement("td");
	if (mode == "modeTvLive") {
		listTd1.setAttribute("nowrap", "nowrap");
		listTd1.className = "list_MiddleContentTop";
		listTd1.innerHTML = middleContentTop;
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);
		
		listTd2.setAttribute("nowrap", "nowrap");
		listTd2.className = "list_MiddleContentMid";
		listTd2.innerHTML = middleContent;
		listTr2.appendChild(listTd2);
		listMiddleContentTbody.appendChild(listTr2);
		
		listTd3.setAttribute("nowrap", "nowrap");
		listTd3.className = "list_MiddleContentBottom";
		listTd3.innerHTML = middleContentBottom;
		listTr3.appendChild(listTd3);
		listMiddleContentTbody.appendChild(listTr3);
	} else if (mode == "modeBdLive") {
		// listTd1.setAttribute("nowrap", "nowrap");
		listTd1.className = "list_MiddleContentBdLive";
		listTd1.innerHTML = middleContentTop;
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);
	} else if (mode == "modeDemand1") {
		listTd1.className = "list_middleDemand1Top";
		var limitDiv = document.createElement("div");
		limitDiv.className = "list_limitDiv";
		limitDiv.innerHTML = middleContentTop;
		listTd1.appendChild(limitDiv);
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);
		
		listTd2.setAttribute("nowrap", "nowrap");
		listTd2.className = "list_middleDemand1";
		listTd2.innerHTML = middleContent;
		listTr2.appendChild(listTd2);
		listMiddleContentTbody.appendChild(listTr2);
		
		listTd3.className = "list_middleDemand1";
		listTd3.innerHTML = middleContentBottom;
		listTr3.appendChild(listTd3);
		listMiddleContentTbody.appendChild(listTr3);
	} else if (mode == "modeDemand2") {
		listTd1.className = "list_middleDemand2Top";
		listTd1.innerHTML = middleContentTop;
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);

		listTd2.className = "list_middleDemand2mid";
		listTd2.innerHTML = middleContent;
		listTr2.appendChild(listTd2);
		listMiddleContentTbody.appendChild(listTr2);

		listTd3.className = "list_middleDemand2Bottom";
		listTd3.innerHTML = middleContentBottom;
		listTr3.appendChild(listTd3);
		listMiddleContentTbody.appendChild(listTr3);
	} else if (mode == "modeDemand3") {
		listTd1.className = "list_middleDemand3Top";
		var limitSubDiv = document.createElement("div");
		limitSubDiv.className = "list_limitSubDiv";
		limitSubDiv.innerHTML = middleContentTop;
		listTd1.appendChild(limitSubDiv);
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);
		
		var limitSubDivbottom = document.createElement("div");
		limitSubDivbottom.className = "list_limitSubDivBottom";
		limitSubDivbottom.innerHTML =middleContent;
		listTd2.className = "list_middleDemand3";
		listTd2.appendChild(limitSubDivbottom);
		listTr2.appendChild(listTd2);
		listMiddleContentTbody.appendChild(listTr2);
	} else if (mode == "modeDemand4") {
		listTd1.className = "list_middleDemand4Top";
		listTd1.innerHTML = middleContentTop;
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);

		listTd2.className = "list_middleDemand4";
		listTd2.innerHTML = middleContent;
		listTr2.appendChild(listTd2);
		listMiddleContentTbody.appendChild(listTr2);
	} else if (mode == "modeDemand5") {
		listTd1.className = "list_middleDemand5Top";
		var limitSubDiv = document.createElement("div");
		limitSubDiv.className = "list_limitSubDiv5";
		limitSubDiv.innerHTML = middleContentTop;
		listTd1.appendChild(limitSubDiv);
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);
		
		var limitSubDivbottom = document.createElement("div");
		limitSubDivbottom.className = "list_limitSubDivBottom5";
		limitSubDivbottom.innerHTML =middleContent;
		listTd2.className = "list_middleDemand3";
		listTd2.appendChild(limitSubDivbottom);
		listTr2.appendChild(listTd2);
		listMiddleContentTbody.appendChild(listTr2);
	} else if(mode == "game"){
		listTd1.className = "list_middleDemand5Top";
		var limitSubDiv = document.createElement("div");
		limitSubDiv.className = "list_limitGameSubDiv5";
		limitSubDiv.innerHTML = middleContentTop;
		listTd1.appendChild(limitSubDiv);
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);
		
		var limitSubDivbottom = document.createElement("div");
		limitSubDivbottom.className = "list_limitSubDivBottom5";
		limitSubDivbottom.innerHTML =middleContent;
		listTd2.className = "list_middleDemand3";
		listTd2.appendChild(limitSubDivbottom);
		listTr2.appendChild(listTd2);
		listMiddleContentTbody.appendChild(listTr2);
	}else if (mode == "modeBook") {
		listTd1.className = "list_middleBookTop";
		var limitBookDiv = document.createElement("div");
		limitBookDiv.className = "list_bookdiv";
		limitBookDiv.innerHTML = middleContentTop;
		listTd1.appendChild(limitBookDiv);
		listTr1.appendChild(listTd1);
		listMiddleContentTbody.appendChild(listTr1);
		listTd2.className = "list_middleBookBottom";
		listTd2.innerHTML = "<table>" + "<tr>"
				+ "<td class='middleBookBottom_top'>" + middleContent + "</td>"
				+ "</tr>" + "<tr>" + "<td class='middleBookBottom_bottom'><div class = 'list_limitBookDiv'>"
				+ middleContentBottom + "</div></td>" + "</tr>" + "</table>";
		listTr2.appendChild(listTd2);
		listMiddleContentTbody.appendChild(listTr2);
	}
	listMiddleContentTable.appendChild(listMiddleContentTbody);
	conTd2.appendChild(listMiddleContentTable);
	conTr.appendChild(conTd1);
	conTr.appendChild(conTd2);
	conTbody.appendChild(conTr);
	conTable.appendChild(conTbody);
	Connection.appendChild(conTable);
	// 以下为创建主的列表框架
	var tableMain = document.createElement("table");
	if (type == "book" || type == "editorbook") {
		tableMain.className = "list_BookTable";
	} else {
		tableMain.className = "list_Table";
	}
	var tbodyMain = document.createElement("tbody");
	var trMain = document.createElement("tr");
	var tdMain_1 = document.createElement("td");
	tdMain_1.appendChild(Connection);
	trMain.appendChild(tdMain_1);
	if (type == "book") {
		var tdMain_2 = document.createElement("td");
		tdMain_2.className = "list_Line";
		trMain.appendChild(tdMain_2);
		var tdMain_3 = document.createElement("td");
		tdMain_3.className = "list_Play";
		trMain.appendChild(tdMain_3);
	} else if(type == "microblog"){
		var tdMain_3 = document.createElement("td");
		tdMain_3.className = "nolist_Play";
		trMain.appendChild(tdMain_3);
	}else if(type == "subject"){
		var tdMain_2 = document.createElement("td");
		tdMain_2.className = "list_Line";
		trMain.appendChild(tdMain_2);
		var tdMain_3 = document.createElement("td");
		tdMain_3.className = "list_Play";
		trMain.appendChild(tdMain_3);
	}else if(type == "editor"){  //带删除按钮的列表（非图书）
		var tdMain_2 = document.createElement("td");
		tdMain_2.className = "list_Play";
		var editorButton = document.createElement("a");
		editorButton.href = "javascript:void(0)";
		editorButton.innerHTML = "<img id='editorImg' class='editorImgHid' src='../grgl/images/del.png'>";
		if($.isFunction(Second_functionName)){
			editorButton.onclick = function() {
				functionObj = Second_functionName ;
				tableName = tableMain ;
				divObj = div;
				functionParam = Second_functionParameter;
				sdmtv.checkNet("removeKeep");
//				Second_functionName(Second_functionParameter,tableMain,div);
			}
		}
		tdMain_2.appendChild(editorButton);
		trMain.appendChild(tdMain_2);
	}else if(type == "editorbook"){  //带删除按钮的列表（图书）
		var tdMain_2 = document.createElement("td");
		tdMain_2.className = "list_Play";
		var editorButton = document.createElement("a");
		editorButton.href = "javascript:void(0)";
		editorButton.innerHTML = "<img id='editorImg' class='editorImgHid' src='../grgl/images/del.png'>";
		if($.isFunction(Second_functionName)){
			editorButton.onclick = function() {
				functionObj = Second_functionName ;
				tableName = tableMain ;
				divObj = div;
				functionParam = Second_functionParameter;
				sdmtv.checkNet("removeKeep");
//				Second_functionName(Second_functionParameter,tableMain,div);
			}
		}
		tdMain_2.appendChild(editorButton);
		trMain.appendChild(tdMain_2);
	} else if(type == "game"){
		var tdMain_2 = document.createElement("td");
		tdMain_2.className = "list_down";
		var playElement = document.createElement("a");
		playElement.href="javascript:void(0)";
		playElement.innerHTML = "<img src='../../img/button_Youxiyingyong_Download.png'>";
		// 给下载按钮添加下载事件
		if($.isFunction(Second_functionName)){
			playElement.onclick = function() {
				Second_functionName(Second_functionParameter);
			}
		}
		tdMain_2.appendChild(playElement);
		trMain.appendChild(tdMain_2);
	}else {
		var tdMain_2 = document.createElement("td");
		tdMain_2.className = "list_Line";
		tdMain_2.innerHTML = "<img src='../tvLive/images/playfenge.png'>";
		trMain.appendChild(tdMain_2);
		var tdMain_3 = document.createElement("td");
		tdMain_3.className = "list_Play";
		var playElement = document.createElement("a");
		playElement.href="javascript:void(0)";
		playElement.innerHTML = "<img src='../tvLive/images/play.png'>";
		// 给播放按钮添加播放事件
		if($.isFunction(Second_functionName)){
			playElement.onclick = function() {
				Second_functionName(Second_functionParameter);
			}
		}
		tdMain_3.appendChild(playElement);
		trMain.appendChild(tdMain_3);
	}
	tbodyMain.appendChild(trMain);
	tableMain.appendChild(tbodyMain);
	ElementDiv.appendChild(tableMain);
	div.className = "List_Cont_recommend_div";
	ElementDiv.appendChild(div);
	// 图片懒加载
	window.setTimeout(function() {
		$(tableMain).find("img.imgLazyLoad").lazyload({
			effect: "fadeIn",
			load:function() {
				$(this).removeClass("imgLazyLoad");
			}
		});
	}, 300)
}
 
window.test = function(){
	functionObj(functionParam,tableName,divObj);
}
/**
 * 改变删除按钮的显示或隐藏状态
 * @param pageId
 * @return
 */
function editor_imgChangeStu(pageId,isShow){
	if(isShow){
		var editorImgHid = document.getElementById(pageId).querySelectorAll(".editorImgHid");
		if(editorImgHid.length>0){
			for(var i = 0;i<editorImgHid.length;i++){
				editorImgHid[i].className = "editorImgShow";
			}
		}
	}else{
		var editorImgShow = document.getElementById(pageId).querySelectorAll(".editorImgShow");
		if(editorImgShow.length>0){
			for(var i = 0;i<editorImgShow.length;i++){
				editorImgShow[i].className = "editorImgHid";
			}
		}
	}
}

/**
 * 统一播放调用方法
 * 
 * @param type
 *            播放类型：电视直播liveVideo 广播直播liveAudio 电视点播video 广播点播audio
 * @param id
 *            播放的ID
 * @param name
 *            影片名称
 * @param m3u8
 *            视频地址
 * @param rtsp
 *            视频地址
 * @param customerCollectionId
 *            收藏ID
 * @param channel
 *            频道ID
 * @param program
 *            栏目ID
 * @return
 */
// function
// broadcast_unifiedPlayer(type,id,name,m3u8,rtsp,customerCollectionId,channel,program){
function broadcast_unifiedPlayer(param){
	var type = param.type;
	var id = param.id;
	var name = param.name;
	var m3u8 = param.m3u8;
	var rtsp = param.rtsp;
	var customerCollectionId = param.customerCollectionId;
	var channel = param.channel;
	var program = param.program;
	var customerId = window.sessionStorage.getItem("customerId");
	if (chk_to_page()) {
		sdmtv.playMedia(customerId,type,id,name,customerCollectionId,m3u8,rtsp);
		var broadcastParams = {
				"cls" : "CustomerVisit_add",
				"visitType" : type,
				"visitValue":id,
			};
		if(channel!=null){
			broadcastParams.channelId = channel;
		}
		if(program!=null){
			broadcastParams.tvColumnId = program;
		}
		new $sdmtv_ajax(broadcastParams,broadcastParamsCallBack);
	}
}

function broadcastParamsCallBack(ajaxObj){
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var activePage = $("body>div.ui-page-active");
		$(activePage).trigger("refresh");
	}
}
/**
 * 调用
 * 
 * @param div
 *            弹出层最外层DIV的ID
 * @param obj
 *            点击的图片的obj
 * @param pageId
 *            整个页面的pageID
 * @return
 */
function float_popLayer(div,obj,pageId,params,callBack,condiv,imgType){
	var divElement = document.getElementById(div+"mask");
	if(divElement==null){
		float_openLayer(div,obj,pageId,imgType);
		// 获得频道列表
		var divcon = document.getElementById(condiv);
		if(divcon.innerHTML==""){
			new $sdmtv_ajax(params, callBack);
		}
		return true;
	}else{
		float_hideLayer(div,obj,imgType);
		return false;
	}
}
/**
 * 打开浮动层
 * 
 * @param div_id
 * @param obj
 * @param pageId
 * @param imgType 图片类型 1为默认 选择频道图片；2为选择分类图片
 * @return
 */
function float_openLayer(div_id,obj,pageId,imgType) { 
	if(imgType == 2){
		obj.src = "../../images/selectCategory_ButtonL.png";
	}else if(imgType == 3){
		obj.src = "../../../local/jsp/book/images/selectpindaoL.png";
	}else if(imgType == 4){
		obj.src = "../../images/tvDemand/Button_Updated_Current.PNG";
	}else{
		obj.src = "../../images/tvDemand/selectpindaoL.png";
	}
    var div_obj = $("#"+div_id);  
    var windowWidth = document.body.clientWidth;       
    var windowHeight = document.body.scrollHeight; 
    var popupHeight = div_obj.height();       
    var popupWidth = div_obj.width(); 
    var tableclassTable = document.getElementById("classTable");
    tableclassTable.width = windowWidth-10;
    // 添加并显示遮罩层
    $("<div id='"+div_id+"mask'></div>").addClass("mask")   
                              .width(windowWidth)   
                              .height(windowHeight)   
                              .touchstart(function() {float_hideLayer(div_id,obj,imgType); })   
                              .appendTo("body")   
                              .fadeIn(200); 
    $('#'+pageId).live('scrollstart',function(event, ui){
    	　float_hideLayer(div_id,obj,imgType);
    	});
    div_obj.css({"position": "fixed"})   
           .animate({left: 0,    
                     top: 46, opacity: "show" }, 100);   
}   
/**
 * 隐藏浮动层
 * 
 * @param div_id
 * @param obj
 * @return
 */
function float_hideLayer(div_id,obj,imgType) { 
	if(imgType == 2){
		obj.src = "../../images/selectCategory_ButtonN.png";
	}else if(imgType == 3){
		obj.src = "../../../local/jsp/book/images/selectpindaoN.png";
	}else if(imgType == 4){
		obj.src = "../../images/tvDemand/Button_Updated_Normal.PNG";
	}else{
		obj.src = "../../images/tvDemand/selectpindaoN.png";
	}
    $("#"+div_id+"mask").remove();   
    $("#" + div_id).animate({left: 0, top: 46, opacity: "hide" }, 100); 
    return false;
} 

/**
 * 生成频道html
 * 
 * @param elementId
 *            页面指定位置id
 * @param name
 *            频道名称
 * @param initName
 *            初始化高亮名称
 * @param floatDivId
 *            页面浮动层最外层div的id
 * @param selectChannelImgId
 *            选择频道按钮的id
 * @return
 */
function float_creatHtml(elementId,name,initName,floatDivId,selectChannelImgId){
	var ul = document.getElementById(elementId);
	var a = document.createElement("a");
	a.href="javascript:void(0)";
	var div = document.createElement("div");
	var id = elementId+"bgdiv";
	div.setAttribute("align", "center");
	div.className = "float_table";
	var bgdiv = document.createElement("div");
	bgdiv.setAttribute("id",id);
	if(initName==name){
		bgdiv.className = "float_bgDiv";
	}else{
		bgdiv.className = "float_noBgDiv";
	}
	bgdiv.innerHTML= name;
	bgdiv.onclick = function() {
		var item = ul.querySelectorAll("#"+id);
		for(var i = 0; i < item.length; i++) { 
			item[i].className = "float_noBgDiv";
		} 
		this.className = "float_bgDiv";
		float_hideLayer(floatDivId,document.getElementById(selectChannelImgId));
	}
	a.appendChild(bgdiv);
	div.appendChild(a);
	ul.appendChild(div);
	return a;
}

/**
 * 向左移动
 * 
 * @param type
 *            向左/向右 left/right
 * @param speed
 *            移动速度
 * @param step
 *            移动步长
 * @param distance
 *            目标距离
 * @param divid
 *            移动对象的ID
 * @return
 */
function move_div(type,speed,step,distance,divid){
	var div = document.getElementById(divid);
	if(div.style.left == ""){
		div.style.left = div.offsetLeft+"px";
	}
	var move_cycle ;
	if(type == "left"){
		move_cycle=setInterval(function(){
			move_left(distance,div,move_cycle,step);
		}, speed);
	}else if(type == "right"){
		move_cycle=setInterval(function(){
			move_right(distance,div,move_cycle,step);
		}, speed);
	}
}
/**
 * 向左移动
 * 
 * @param distance
 *            目标位置
 * @param div
 *            移动对象
 * @param move_cycle
 *            setInterval对象
 * @param step
 *            移动步长
 * @return
 */
function move_left(distance,div,move_cycle,step){
	var nowleft=parseInt(div.style.left);
	if(nowleft<distance)
	{
		clearInterval(move_cycle);
	}else{
		div.style.left=(nowleft-step)+"px";
	}
}
/**
 * 向右移动
 * 
 * @param distance
 *            目标位置
 * @param div
 *            移动对象
 * @param move_cycle
 *            setInterval对象
 * @param step
 *            移动步长
 * @return
 */
function move_right(distance,div,move_cycle,step){
	var nowleft=parseInt(div.style.left);
	if(nowleft>distance)
	{
		clearInterval(move_cycle);
	}else{
		div.style.left=(nowleft+step)+"px";
	}
}
/**
 * 加载更多
 */
// 检查是否显示更多按钮，参数：开始NUM，步长num,总数量，对象名称（string）,回调函数，页面上标签ID
function checkLoadMore(params, callBackFunction,loadmoreId) {
	if (params.beginNum + params.step >= params.totalCount) {
		document.getElementById(loadmoreId).style.display = "none";
	} else {
		document.getElementById(loadmoreId).style.display = "block";
		var loadmore = document.getElementById(loadmoreId);
		loadmore.innerHTML = "<div href='javascript:void(0)' class='load_more_button'>加载更多</div>";
		loadmore.firstChild.onclick = function() {
			params.beginNum = params.beginNum + params.step;
			new $sdmtv_ajax(params, callBackFunction);
		}
	}
}
// 隐藏加载更多按钮
function hideLoadMore(typeName){
	document.getElementById(typeName).style.display = "none";
}
/**
 * 加载更多
 */


function judgmentModel(){
	var isAndroid = (/android/i).test(navigator.appVersion); //安卓手机
    var isIDevice = (/iphone|ipad/i).test(navigator.appVersion); //IOS手机
    var isPlaybook = (/playbook/i).test(navigator.appVersion);
    if(isAndroid){
    	return 'android';
    }else if(isIDevice){
    	return 'iphone';
    }
}







/**
 * 运行广告
 */
//运行广告
function runAd(showTypeLimit,adname){
	var captionall=document.querySelectorAll(".caption");
	if(captionall.length>0){
		captionall[0].innerHTML=adname[0];
		$('#slides').slides({
			preload: true,
			preloadImage: '../../img/index/loading.gif',
			play: showTypeLimit*1000,
			pause: 1, //暂停后停留时间
			hoverPause: true,
			animationStart: function(current){
				captionall[current].innerHTML="";
			},
			animationComplete: function(current){
				captionall[current-1].innerHTML=adname[current-1];
			}
		});
		//设置广告滑动事件
		$("#slides").wipetouch({
			tapToClick : false, // if user taps the screen, triggers a click
								// event
			wipeLeft : function(result) {
				  var e = document.createEvent('MouseEvent');
			      e.initEvent('click', false, false);
			      document.getElementById("next").dispatchEvent(e);
			},wipeRight : function(result) {
				  var e = document.createEvent('MouseEvent');
			      e.initEvent('click', false, false);
			      document.getElementById("prev").dispatchEvent(e);
			}
		});
	}else{
		var index_ad = document.getElementById('slides_container');
		index_ad.innerHTML = "<div class='slides_control'><div><div class='caption' style='bottom:0'></div></div></div>";
	//	$('#applist').css('margin-top','-15px');
	}
}
/**
 * 运行广告
 */

/**
 * index.html
 */
var showTypeLimit = 5000;

var wl = window.localStorage;
var ws = window.sessionStorage;
var indexAdImgArray = new Array();


/**
 * 首页初始化，添加检测网络
 */
var index_pageOk = false;
function index_netInit(){
	if(!index_pageOk){// 重新加载
		index_inIt();
	}
}
$("#indexPage").live("pageshow",function(){
	index_netInit();
});
/**
 * 推荐页初始化，添加检测网络
 */
var recommend_pageIsOk = false;
function recommend_netInit(){
	if(!recommend_pageIsOk){// 重新加载
		recommend_inIt();
	}
}
$("#recommendPage").live("pageshow",function(){
	recommend_netInit();
});



var index_isPlusPvBoolean = true;
function index_userInit() {
	// 用户登录的判断
	if (window.localStorage.getItem("auto_login") == "1"
			&& !window.sessionStorage.getItem('customerId')) {
			var userName = window.localStorage.getItem("username_");
			var newBase = window.localStorage.getItem("encrypPass");
			if(null == newBase || null == userName){
			    //alert("自动登录失败，获取预留信息错误。");
			    window.localStorage.setItem("auto_login", "0");// 取消自动登录
				window.localStorage.removeItem("customerId_");// 移除用户id
			    return;
			}
			//base64解码
			var oldoldBaseOne = base64decode(newBase);
			var v = new Array;
			v = oldoldBaseOne.split(":");
			if(v.length == 2){
				if(userName.toLowerCase() != v[0].toLowerCase()){
					alert("自动登录失败，用户名和密码错误。");
					window.localStorage.setItem("auto_login", "0");// 取消自动登录
					window.localStorage.removeItem("customerId_");// 移除用户id
				    return;
				}
			    var param = {
			    	"cls" : "Customer_verifiLand",
					"username" : v[0],
					"md5KeyPassword" : v[1]
			    }
			    index_isPlusPvBoolean = false;// 只记录一次pv
			    
			    new $sdmtv_ajax(param, function(ajaxObj) {
			    	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
						var objs = ajaxObj.objs;
						var customerId = "";
						var platformRecordId = "";
						var score = "";
						$(objs).each(function() {
									customerId = this.get("customerId");
									platformRecordId = this.get("platformRecordId");
									score = this.get("score");
								})
						if (customerId != "") {
						    window.sessionStorage.setItem('name',window.localStorage.getItem("customerName")||window.localStorage.getItem("username_"));
							window.sessionStorage.setItem('customerId',customerId);
							window.sessionStorage.setItem("platformRecordId",platformRecordId);// 本次登录id
							window.sessionStorage.setItem('loginType', '');
							// 发送数据到native
							sdmtv.memoryBaseInfo(window.sessionStorage.getItem("customerId"), 
									window.localStorage.getItem("virtualId"),
									window.localStorage.getItem("platformRecordId"));
						    //积分请求
							if (score != "") {
								alert("每日登录成功 （+" + score + "积分）");
								//提示后延迟跳转
								setTimeout(function() {
							  		
								}, 1500)
							}
						
						} else {
							alert("自动登录失败，用户名和密码错误。");
							window.localStorage.setItem("auto_login", "0");// 取消自动登录
							window.localStorage.removeItem("customerId_");// 移除用户id
						}
					}else{
						alert(ajaxObj.message);
					}
			    });
			}else{
				//alert("自动登录失败，获取预留信息错误。");
				window.localStorage.setItem("auto_login", "0");// 取消自动登录
				window.localStorage.removeItem("customerId_");// 移除用户id
			}
	} else {
		
	}
}

// 首页初始化
function index_inIt(){
	var index_paramsNotice = {
			"cls" : "Announcement_queryNewAnnouncementList",
			"totalCount" : 0,
			"beginNum" : 0,
			"step" : 5,
			"sort" : "beginTime",
			"dir" : "desc",
		};
	new $sdmtv_ajax(index_paramsNotice, Get_Notice);
	
	// 获取首页顶部广告
	var index_paramAD = {
			"cls" : "Advertisement_list",
			"position":"ad_main_tp",
			
		};
	//显示底部菜单
	if(judgmentModel()=="android"){
		clientMenu.showBottomMenu();//显示底部导航
		clientMenu.closeFullAd();//关闭全屏广告
	}
	new $sdmtv_ajax(index_paramAD, Get_TopAd);
	// 初始化自动登录
	index_userInit();
	document.getElementById("applist").style.display = "block";
}

// 获取公告信息
function Get_Notice(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		var virtualId = ajaxObj.params.virtualId;
		if (virtualId != null && virtualId != "") {
			window.localStorage.setItem("virtualId", virtualId);
		}
		if(objs.length==0){
			announcementHelper.hide();
		}else{
			var divLight = document.getElementById("light");
			$(divLight).unbind().html("");
			var data = {ids: [], titles: []};
			$(objs).each(function(i) {
				data.ids.push(this.get("announcementId"));
				data.titles.push(this.get("title"));
			});
			// 多添加一个构成循环
			announcementHelper.elementSize = objs.length;
			if (objs.length>1) {
				data.ids.push(data.ids[0]);
				data.titles.push(data.titles[0]);
			}
			
			// 绑定事件
			$(divLight).on("click", ".announcement_title", function() {
				GoToNotice($(this).attr("data-clickParam"), this);
			});
			$(divLight).on("click", ".announcement_close", function() {
				announcementHelper.hide();
			});
			window.setTimeout(function() {
                doTHelper.tmplPagefn(divLight, "announcement", data);
                announcementHelper.show();  // 展示公告
                
                }, 500);
		}
	}
	index_pageOk = true;
}
/*
 * 
 * 公告轮播
 * 
 */
var announcementHelper = {
		interval : 5000,// 两次滚动之间的时间间隔
		stepsize : 35,// 滚动一次的长度
		scrollspeed : 0.5,// 滚动动画时长的毫秒数
		objInterval : undefined, 
		elementSize : 1,
		curElem : 0
};
//启动定时器，开始滚动
announcementHelper.startScroll = function() {
	if (announcementHelper.elementSize > 1) {
		announcementHelper.stopScroll();
		announcementHelper.objInterval = setInterval(function() {
			announcementHelper.verticalloop();
		}, announcementHelper.interval);
	}
};
// 清除定时器，停止滚动
announcementHelper.stopScroll = function() {
	window.clearInterval(announcementHelper.objInterval);
};
// 控制滚动
announcementHelper.verticalloop = function() {
	// 不在indexPage页面时，不移动announcement div
	if ($("body>div.ui-page-active").attr("id") != "indexPage") {
		return;
	}

	announcementHelper.curElem += 1;
	var scrollTop = announcementHelper.stepsize *announcementHelper.curElem;
	var scrollspeed = announcementHelper.scrollspeed;
	
	// 使用translate创建滚动时的动画效果
	$("#top").css({"-webkit-transition":scrollspeed+"s linear", "webkitTransform":"translate(0px, -"+scrollTop+"px)"});

	// 回到顶部
	if (announcementHelper.curElem >= announcementHelper.elementSize) {
		announcementHelper.curElem = 0;
		window.setTimeout(function() {
			$("#top").css({"-webkit-transition":"0s linear", "webkitTransform":"translate(0px, 0px)"});
		}, 1000);
	}
};
// 公告显示
announcementHelper.show = function() {
	 var light=document.getElementById("light");
	 light.style.display='block';
	 announcementHelper.startScroll();
};
// 公告隐藏
announcementHelper.hide = function() {
	 var light=document.getElementById("light");
	 light.style.display="none";
	 announcementHelper.stopScroll();
};

// 跳转到公告详情页
function GoToNotice(noticeID, obj) {
	window.sessionStorage.setItem('Look_Notice_Id', noticeID);
	obj.href = "ann.html";
}

// 获取首页顶部广告
function Get_TopAd(Obj){
	if(Obj.code == Obj.constants.SUCCESS){
		var objs = Obj.objs;
		var maxNum = 0;
		var showTypeLimit = "";
		var adname = new Array();
		var wiht = document.getElementById("indexPage");
		// 先删除广告DOM
		$("#slides").unbind().remove();
	    $("#adds_container").html('<div id="slides">'+
	                              '<div id="slides_container" class="slides_container"></div>'+
	                              '<a href="#" class="prev" id="prev"></a>'+
	                              '<a href="#" class="next" id="next"></a>'+
	                              '</div>');
		
		$(objs).each(function(){
			if(maxNum<=5){
				var advertisementId = this.get("advertisementId");
				var advName  = this.get("advName");
				var targetUrl  = this.get("targetUrl");
				var targetType = this.get("targetType");
				var adveUrl  = this.get("adveUrl");
				showTypeLimit  = this.get("showTypeLimit");
				var position = this.get("positions");
				if(advName.length>24){
					advName = advName.substr(0,21)+"...";
				}
				topAdToHtml(advertisementId, advName, targetUrl, targetType, adveUrl,
					showTypeLimit,position); // 组成广告HTML
				adname[maxNum] = advName;
			}
			maxNum++;
		})
		var pointwidth = (maxNum*7+(maxNum-1)*10)/2;
		var indexwidth = wiht.clientWidth/2;
		runAd(showTypeLimit,adname); // 运行广告
		$(".pagination").css({left:indexwidth-pointwidth});
	}else{
		handErrorMsg(Obj.message);
	}
}

// 组成广告的HTML
function topAdToHtml(advertisementId,advName,targetUrl,targetType,adveUrl,showTypeLimit,position){
	var div = document.getElementById("slides_container");
	var divad  = document.createElement("div");
	var wiht = document.getElementById("indexPage");
	divad.innerHTML="<a title='"+advName+"'>"
	  +"<img src='"+sdmtv.IMG_BASEPATH+targetUrl+"' onerror=\"this.src='../../img/indexad_bg.png'\" width="+wiht.clientWidth+" height='145' >"
	  +"</a>"
	  +"<div class='caption' style='bottom:0'>"
	  +"</div>";
	div.appendChild(divad);
	$(divad).bind("click", function() {
		goUrl(adveUrl,targetType, advertisementId , position );
	});
}
/*
 * 广告点击记录插入数据库
 */
var index_adRecordsParams={
		"cls" : "Advertisement_addsClick",
		"position" : "",
		"advertisementId" : "",
		"count" : 1
}
// 广告url
function goUrl(adveUrl, targetType,advertisementId,position){
	// 点击时 将点击记录插入数据库
	index_adRecordsParams.position=position;
	index_adRecordsParams.advertisementId=advertisementId;
	new $sdmtv_ajax(index_adRecordsParams);
	if (targetType == "1") {
		if (adveUrl.indexOf("?") > 0) {
			var url = adveUrl.substring(0, adveUrl.indexOf("?")); 
			var paraString = adveUrl.substring(adveUrl.indexOf("?")+1,adveUrl.length).split("&"); 
			for (i=0; j=paraString[i]; i++){ 
				window.sessionStorage.setItem(j.substring(0,j.indexOf("=")), j.substring(j.indexOf("=")+1,j.length));
			}			$.mobile.changePage(url);
		} else {
			$.mobile.changePage(adveUrl);
		}
	} else {
		sdmtv.popURL(adveUrl);
	}
}
//// 获取用户应用列表
//function Get_AppList(ajaxObj) {
//	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
//		var objs = ajaxObj.objs;
//		var scroller = document.getElementById("applist");
//		var endapplist = document.getElementById("endapplist");
//		$(objs).each(function(){
//			var indexProgramId = this.get("indexProgramId");
//			var title = this.get("title");
//			var img = this.get("img");
//			var url = this.get("url");
//			var div  = document.createElement("div");
//			div.className = "d1";
//			div.innerHTML="<a href='../../jsp"+url+"' ><div class='d2'>"+
//			   				   "<img class='m1' src='"+sdmtv.IMG_BASEPATH+img+"' width='43px' height='39px' onerror='this.src='/sdmtv/img/defult/app.png'' />"+
//			   				   "</div> </a><a href='../../jsp"+url+"' ><div class='d3'>"+title+"</div></a>";
//			scroller.appendChild(div);
//			
//		})
//		var addAppHtml = "<div class='d1'>"+
//						 "<a href='javascript:void(0)'  ontouchstart=\"javascript:chk_to_page('addApp.html');\"><div class='d2'>"+
//						 "<img class='m1' src='../../img/index/add.png'  width='43px' height='39px'  onerror='this.src='/sdmtv/img/defult/app.png'' />"+
//						 "</div></a>"+
//						 "<a href='javascript:void(0)'  onclick=\"javascript:chk_to_page('addApp.html');\"><div class='d3'>"+
//						 "添加应用</div></a>";
//		endapplist.innerHTML=addAppHtml;
//		window.sessionStorage.setItem('changeApp',"0");
//	}else{
//		handErrorMsg(ajaxObj.message);
//	}
//}
//
//function pageToAddapp(obj){
//	obj.href='addApp.html';
//}
//// 刷新应用列表
//function rehAppList(){
//	var changeApp = window.sessionStorage.getItem('changeApp');
//	if(changeApp=="1"){
//			/*var index_paramsApp = {
//				"cls" : "IndexProgram_publishlist",
//				
//			};
//			var scroller = document.getElementById("applist");
//			var endapplist = document.getElementById("endapplist");
//			scroller.innerHTML=null;
//			endapplist.innerHTML=null;
//			new $sdmtv_ajax(index_paramsApp, Get_AppList);*/
//	}
//}

// 其它页返回刷新功能列表
// 刷新应用列表
function OtherPageBackGetAppList(){
			/*var index_paramsApp = {
				"cls" : "IndexProgram_publishlist",
				
			};
			var scroller = document.getElementById("applist");
			var endapplist = document.getElementById("endapplist");
			scroller.innerHTML=null;
			endapplist.innerHTML=null;
			new $sdmtv_ajax(index_paramsApp, Get_AppList);*/
}

// 回调
function gohistory(){
	history.back();
}



/**
 * index.html
 */

/**
 * recommend.html
 */
// 获得电视直播节目列表
var recommend_paramsTvLive = {
			"cls" : "LiveVideo_list",
			"programType" : "recommend",
			"beginNum" : 0,
			"step" : 3,
			"sort":"orders",
			"dir":"asc",
			"recommendType":"liveVideo",
			
		};
// 获得广播节目列表
var recommend_paramsBdLive = {            
			"cls" : "LiveVideo_liveAudioList",
			"programType" : "recommend",
			"beginNum" : 0,
			"step" : 3,
			"sort":"orders",
			"dir":"asc",
			"recommendType":"liveAudio",
			
		};
// 获得电视点播推荐列表
var recommend_paramsTvDemand = {            
			"cls" : "Video_list",
			"status":"publish",
			"beginNum":0,
			"step":3,
			"sort":"orders",
			"recommendType":"video",
			"dir":"asc"
		};
// 获得广播点播推荐列表
var recommend_paramsBdDemand = {            
			"cls" : "Audio_list",
			"status":"publish",
			"beginNum":0,
			"step":3,
			"sort":"orders",
			"dir":"asc",
			"recommendType":"audio",
			
		};

// 获得图书点播推荐列表
var recommend_paramsBook = {            
			"cls" : "Book_list",					
			"status":"recommend",
			"beginNum":0,
			"step":3,
			"sort":"orders",
			"dir":"asc",
			"recommendType":"book",
			
		};
// 获得专题列表
var recommend_paramsSubject = {
	"cls" : "Subject_list",
	"status" : "publish",
	"totalCount" : 10,
	"beginNum" : 0,
	"step" : 3,
	"sort" : "orders",
	"dir" : "asc",
	"recommendType":"subject",
	
};
// 推荐广告
var recommend_paramsAd = {
		"cls" : "Advertisement_list",
		"position":"recommend",
		
}
//获得第一视听内容
var recommend_paramsMicroblog = {
			"cls" : "Microblogging_recommendList",
			"status" : "publish",
			"beginNum" : 0,
			"step" : 3,
			"sort":"orders",
			"dir":"asc",
			"recommendType":"microblog",
			
		};
//获得网络视频推荐列表
var recommend_paramsNetWork = {            
			"cls" : "Video_netWorkList",					
			"status":"publish",
			"beginNum":0,
			"step":3,
			"sort":"orders",
			"dir":"asc",
			"recommendType":"netVideo",
			
		};
//获得音乐推荐列表
var recommend_paramsMusic = {
			"cls" : "Audio_musicRecomList02",
			"status" :"publish",
			"beginNum":0,
			"step":3,
			"sort":"orders",
			"dir":"asc",
			"recommendType":"music",
			
		};

/*
 * //内容加载 
 */
function recommend_inIt(finishedCallback){
	// 通过多接口获取
	new $multipleSdmtvAjax([recommend_paramsTvLive,recommend_paramsTvDemand, 
					recommend_paramsBdLive ,recommend_paramsAd,recommend_paramsNetWork], 
			[call_recommend_tvLive_function,call_recommend_tvDemand_function,
			call_recommend_bdLive_function, call_recommend_ad_function,call_recommend_netVideo_function ]);
	// 通过多接口获取
	new $multipleSdmtvAjax([recommend_paramsBdDemand,recommend_paramsBook,
	recommend_paramsSubject,recommend_paramsMicroblog,recommend_paramsMusic], 
			[call_recommend_bdDemand_function, call_recommend_book_function,
			call_recommend_subject_function,call_recommend_microblog_function,call_recommend_music_function], undefined, {finishedCallback:finishedCallback});
}

//网络视频回调函数
function call_recommend_netVideo_function(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$("#rec_netVideo").html("<div style='background-image:-webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38))," +
				"color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table width='100%'  style=';height: 35px;;padding-left: 17px;" +
				"padding-right: 12px;'><tr><td align='left' style='font-size: 17px;font-family: 黑体;color: #ffffff'>网络视频" +
				"</td><td align='right'><a  href='javascript:void(0)' onclick='recom_netVideoMore(this);menuGoMid();' " +
				"style='text-decoration: none;font-size: 15px;font-family: 黑体;color: #cecece'>更多></a></td></tr>" +
				"</table></div><div align='center' id='recommend_netVideo'></div>");	
		$(objs).each(function(){
			var videoId = this.get("videoId");
			var videoName = this.get("videoName");
			var videoUrl= this.get("videoUrl");
			var videoImg = this.get("videoImg");
			var customerCollectionId = this.get("customerCollectionId");
			var programName = this.get("programName");
			var channel = this.get("channel");
			var isMounth = this.get("isMounth");
			var program = this.get("program");
			var realName = this.get("realName");
			var param = {
					"elementId" : "recommend_netVideo",
					"type":"tvDemand",
					"mode":"modeDemand1",
					"middleContentTop":realName,
					"middleContent":"所属栏目："+programName,
					"middleContentBottom":"",
					"imgUrl":videoImg
			};
			var function_param = {
					"CTPId" :program,
					"CTPIdName":programName,
					"programId":videoId
			};
			var broadcast_param = {
					"type" :"netVideo",
					"id" :videoId,
					"name" :realName,
					"m3u8" :videoUrl,
					"rtsp" :videoUrl,
					"customerCollectionId" :customerCollectionId,
					"channel" :channel,
					"program" :program
			};
			list_generateList(param,netVideoCallBack,function_param,broadcast_unifiedPlayer,broadcast_param);
		})
	}else{
		handErrorMsg(ajaxObj.message);
	}
}
// 网络视频列表
function recom_netVideoMore(obj){
	obj.href='../netVideo/netVideo_List.html';
}

/*"audioId", "audioName", "audioUrl","audioLong",
"audioImg","programType","programTypeId" */
// 推荐音乐 回调
function call_recommend_music_function(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$("#rec_music").html("<div style='background-image:-webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38))," +
				"color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table width='100%'  style=';height: 35px;;padding-left: 17px;" +
				"padding-right: 12px;'><tr><td align='left' style='font-size: 17px;font-family: 黑体;color: #ffffff'>音乐" +
				"</td><td align='right'><a  href='javascript:void(0)' onclick='recom_musicMore(this);menuGoMid();' " +
				"style='text-decoration: none;font-size: 15px;font-family: 黑体;color: #cecece'>更多></a></td></tr>" +
				"</table></div><div align='center' id='recommend_music'></div>");	
		$(objs).each(function(){
			var audioId = this.get("audioId");
			var audioName = this.get("audioName");
			var audioUrl= this.get("audioUrl");
			var audioImg = this.get("audioImg");
			var customerCollectionId = this.get("customerCollectionId");
			var programType = this.get("programType");
			var programTypeId = this.get("programTypeId");
			var audioLong = this.get("audioLong");
			var param = {
					"elementId" : "recommend_music",
					"type":"bdDemand",
					"mode":"modeDemand1",
					"middleContentTop":audioName,
					"middleContent":"所属栏目："+programType,
					"middleContentBottom":"<span style='margin-right:23px;'>时</span>长："+audioLong,
					"imgUrl":audioImg
			};
			var function_param = {
					"CTPId_music" :programTypeId
			};
			var broadcast_param = {
					"type" :"audio",
					"id" :audioId,
					"name" :audioName,
					"m3u8" :audioUrl,
					"rtsp" :audioUrl,
					"customerCollectionId" :customerCollectionId,
					"channel" :programType,
			};
			list_generateList(param,ChannelToPart_music,function_param,broadcast_unifiedPlayer,broadcast_param);
		})
	}else{
		handErrorMsg(ajaxObj.message);
	}
}
// 跳转到更多  音乐列表页
function recom_musicMore(obj){
	obj.href='../music/music_List.html';
}

// 电视直播推荐内容回调函数
function call_recommend_tvLive_function(ajaxObj) {
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$("#rec_tvLive").html("<div style='background-image:-webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38))," +
				"color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table width='100%'  style=';height: 35px;;padding-left: 17px;" +
				"padding-right: 12px;'><tr><td align='left' style='font-size: 17px;font-family: 黑体;color: #ffffff'>电视直播" +
				"</td><td align='right'><a  href='javascript:void(0)' onclick='tvLive_more(this);menuGoMid();' " +
				"style='text-decoration: none;font-size: 15px;font-family: 黑体;color: #cecece'>更多></a></td></tr>" +
				"</table></div><div align='center' id='recommend_tvLive'></div>");
		$(objs).each(function(){
			var liveVideoId = this.get("liveVideoId");
			var programName= this.get("programName");
			var flagImg = this.get("flagImg");
			var m3u8 = this.get("m3u8");
			var rtsp = this.get("rtsp");
			var nowBroadcast = this.get("nowBroadcast");
			var nextBroadcast = this.get("nextBroadcast");
			var customerCollectionId = this.get("customerCollectionId");
			var realName = this.get("realName");  //推荐节目的真名
			var param = {
					"elementId" : "recommend_tvLive",
					"type":"tvLive",
					"mode":"modeTvLive",
					"middleContentTop":realName,
					"middleContent":"正在："+nowBroadcast,
					"middleContentBottom":"即将："+nextBroadcast,
					"imgUrl":flagImg
			};
			var function_param = {
					"liveVideoId" :liveVideoId
			};
			var broadcast_param = {
					"type" :"liveVideo",
					"id" :liveVideoId,
					"name" :realName,
					"m3u8" :m3u8,
					"rtsp" :rtsp,
					"customerCollectionId" :customerCollectionId
			};
			list_generateList(param,JumpToDetails_recommend_z,function_param,broadcast_unifiedPlayer,broadcast_param);
		})
	}else{
		handErrorMsg(ajaxObj.message);
	}
}
// 跳转去电视直播详情页
function JumpToDetails_recommend_z(function_param,obj){
	window.sessionStorage.setItem('liveVideoId',function_param.liveVideoId);
	obj.href = "../tvLive/tvLive_Details.html";
}
// 跳转到电视直播更多
function tvLive_more(obj){
	obj.href='../tvLive/tvLive_List.html';
}
// 广播直播内容推荐回调
function call_recommend_bdLive_function(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$("#rec_bdLive").html("<div style='background-image:-webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38)),color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table width='100%'  style=';height: 35px;;padding-left: 14px;padding-right: 12px;'><tr><td align='left' style='font-size: 17px;font-family: 黑体;color: #ffffff'>广播直播</td><td align='right'><a  href='javascript:void(0)' onclick='bdLive_more(this);menuGoMid();' style='text-decoration: none;font-size: 15px;font-family: 黑体;color: #cecece'>更多></a></td></tr></table></div><div align='center' id='recommend_bdLive'></div>");
		$(objs).each(function(){
			var liveVideoId = this.get("liveVideoId");
			var programName= this.get("programName");
			var flagImg = this.get("flagImg");
			var m3u8 = this.get("m3u8");
			var rtsp = this.get("rtsp");
			var customerCollectionId = this.get("customerCollectionId");
			var realName = this.get("realName");  //推荐节目的真名
			var param = {
					"elementId" : "recommend_bdLive",
					"type":"bdLive",
					"mode":"modeBdLive",
					"middleContentTop":realName,
					"imgUrl":flagImg
			};
			var function_param = {
					"liveAudio" :liveVideoId
			};
			var broadcast_param = {
					"type" :"liveAudio",
					"id" :liveVideoId,
					"name" :realName,
					"m3u8" :m3u8,
					"rtsp" :rtsp,
					"customerCollectionId" :customerCollectionId
			};
			list_generateList(param,JumpToDetails_bdLive_recommend,function_param,broadcast_unifiedPlayer,broadcast_param);
		})
		
	}else{
		handErrorMsg(ajaxObj.message);
	}
}
// 跳转至广播详情页
function JumpToDetails_bdLive_recommend(function_param,obj){
	window.sessionStorage.setItem('liveAudio',function_param.liveAudio);
	obj.href = "../bdLive/bdLive_Details.html";
}
// 广播直播更多
function bdLive_more(obj){
	obj.href='../bdLive/bdLive_List.html';
}
// 电视点播回调
function call_recommend_tvDemand_function(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$("#rec_tvDemand").html("<div style='background-image:-webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38)),color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table width='100%'  style=';height: 35px;;padding-left: 14px;padding-right: 12px;'><tr><td align='left' style='font-size: 17px;font-family: 黑体;color: #ffffff'>电视点播</td><td align='right'><a  href='javascript:void(0)' onclick='tvDeman_more(this);menuGoMid();' style='text-decoration: none;font-size: 15px;font-family: 黑体;color: #cecece'>更多></a></td></tr></table></div><div align='center' id='recommend_tvDemand'></div>");
		$(objs).each(function(){
			var videoId = this.get("videoId");
			var videoName= this.get("videoName");
			var videoImg= this.get("videoImg");
			var videoUrl= this.get("videoUrl");
			var playtime = this.get("playTime");
			var programName = this.get("programName");
			var channel = this.get("channel");
			var program = this.get("program");
			var customerCollectionId = this.get("customerCollectionId");
			var realName = this.get("realName");
			var param = {
					"elementId" : "recommend_tvDemand",
					"type":"tvDemand",
					"mode":"modeDemand1",
					"middleContentTop":realName,
					"middleContent":"所属栏目："+programName,
					"middleContentBottom":"更新时间："+playtime,
					"imgUrl":videoImg
			};
			var function_param = {
					"videoId" :videoId
			};
			var broadcast_param = {
					"type" :"video",
					"id" :videoId,
					"name" :videoName,
					"m3u8" :videoUrl,
					"rtsp" :videoUrl,
					"customerCollectionId" :customerCollectionId,
					"channel" :channel,
					"program" :program
			};
			list_generateList(param,PageToTvDemand_Details_recommend_z,function_param,broadcast_unifiedPlayer,broadcast_param);
		})
	}else{
		handErrorMsg(ajaxObj.message);
	}
}
// 进入电视点播详情页面
function PageToTvDemand_Details_recommend_z(function_param,obj){
//	var name =document.getElementById("tvDemand_PartList_title");
	window.sessionStorage.setItem('tvDemand_videoId',function_param.videoId);
	obj.href="../tvDemand/tvDemand_Details.html";
}
// 电视点播更多
function tvDeman_more(obj){
	obj.href="../tvDemand/tvDemand_List.html";
}
// 广播点播回调函数
function call_recommend_bdDemand_function(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		
		var objs = ajaxObj.objs;
		$("#rec_bdDemand").html("<div style='background-image: -webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38)),color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table width='100%'  style=';height: 35px;;padding-left: 14px;padding-right: 12px;'><tr><td align='left' style='font-size: 17px;font-family: 黑体;color: #ffffff'>广播点播</td><td align='right'><a  href='javascript:void(0)' onclick='bdDeman_more(this);menuGoMid();' style='text-decoration: none;font-size: 15px;font-family: 黑体;color: #cecece'>更多></a></td></tr></table></div><div align='center' id='recommend_bdDemand'></div>");
		$(objs).each(function(){
			var audioId = this.get("audioId");
			var audioName= this.get("audioName");
			var audioImg = this.get("audioImg");
			var audioUrl  = this.get("audioUrl");
			var audioLong = this.get("audioLong");
			var sonTypeString = this.get("sonTypeString");
			var belongType = this.get("belongType");// 频道id
			var sonType = this.get("sonType");
			var realName = this.get("realName"); //推荐真名
			var customerCollectionId = this.get("customerCollectionId");
			var param = {
					"elementId" : "recommend_bdDemand",
					"type":"bdDemand",
					"mode":"modeDemand1",
					"middleContentTop":realName,
					"middleContent":"所属栏目："+sonTypeString,
					"middleContentBottom":"<span style='margin-right:23px;'>时</span>长："+audioLong,
					"imgUrl":audioImg
			};
			var function_param = {
					"programId" :audioId,
					"CTPIdName_bdDemand":sonTypeString,
					"CTPId_bdDemand":sonType
			};
			var broadcast_param = {
					"type" :"audio",
					"id" :audioId,
					"name" :realName,
					"m3u8" :audioUrl,
					"rtsp" :audioUrl,
					"customerCollectionId" :customerCollectionId,
					"channel" :belongType,
					"program" :sonType
			};
			list_generateList(param,recommend_bdDemand2Detalis,function_param,broadcast_unifiedPlayer,broadcast_param);
		})
	}else{
		handErrorMsg(ajaxObj.message);
	}
}
//频道进入详情页
function recommend_bdDemand2Detalis(param,obj){
	//window.sessionStorage.setItem('CTPId_bdDemand',param.CTPId_bdDemand);
	//window.sessionStorage.setItem('CTPIdName_bdDemand',param.CTPIdName_bdDemand);
	window.sessionStorage.setItem("programId",param.programId);
	obj.href="../bdDemand/bdDemand_Details.html";
}
// 广播点播更多
function bdDeman_more(obj){
	obj.href='../bdDemand/bdDemand_List.html';
}
// 图书阅读回调函数
function call_recommend_book_function(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$("#rec_read").html("<div style='background-image: -webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38)),color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table class='recTable'><tr><td align='left' class='recTd'>阅读</td><td align='right'><a  href='javascript:void(0)' onclick='book_more(this);menuGoMid();' class='recA' style='color:#cecece'>更多></a></td></tr></table></div><div align='center'  id='recommend_book'></div>");
		$(objs).each(function(){
			var bookId = this.get("bookId");
			var bookName = this.get("bookName");
			var subTitle= this.get("subtitle");
			var bookImg = this.get("bookImg");
			var author = this.get("author");
			var bookClassId = this.get("belongType");
			var bookClassName = this.get("belongTypeName");
			var realname = this.get("realName");
			var param = {
					"elementId" : "recommend_book",
					"type":"book",
					"mode":"modeBook",
					"middleContentTop":realname,
					"middleContent":"作者："+author,
					"middleContentBottom":subTitle,
					"imgUrl":bookImg
			};
			var function_param = {
					"bookId" :bookId,
					"bookClassId" :bookClassId,
					"bookClassName" :bookClassName
			};
			list_generateList(param,mainJumpToContent,function_param);
		})
	}else{
		handErrorMsg(ajaxObj.message);
	}
}
/*
 * 跳到图书详情
 */
function mainJumpToContent(function_param,obj){
	window.sessionStorage.setItem("bookId",function_param.bookId);
	window.sessionStorage.setItem("bookFenlei",function_param.bookClassName);
	window.sessionStorage.setItem("programId",function_param.bookId);
	$.mobile.changePage("../book/bookContent.html",{ transition: "none"});
}
// 图书更多
function book_more(obj){
	obj.href="../book/bookList.html";
}
/**
 * 专题
 * 
 * @param {}
 *            ajaxObj
 */
function call_recommend_subject_function(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$("#rec_subject").html("<div style='background-image: -webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38)),color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table class='recTable'><tr><td align='left' class='recTd'>专题</td><td align='right'><a  href='javascript:void(0)'  onclick='subject_more(this);menuGoMid();' class='recA' style='color:#cecece'>更多></a></td></tr></table></div><div align='center' id='recommend_subject'></div>");
		$(objs).each(function() {
			var subjectId = this.get("subjectId");
			var subjectTypeName = this.get("subjectTypeName");
			var recommendName = this.get("recommendName");
			var subjectName = this.get("subjectName");
			var flagImg = this.get("flagImg");
			var description = this.get("description");
			// 追加html
			var param = {
					"elementId" : "recommend_subject",
					"type":"microblog",
					"mode":"modeDemand3",
					"middleContentTop":subjectName,
					"middleContent":description,
					"imgUrl":flagImg
			};
			var function_param = {
					"subjectId" :subjectId,
					"subjectTypeName" :subjectTypeName,
					"subjectName" :subjectName
			};
			list_generateList(param,JumpToSubjectDetails,function_param);
		})
	} else {
		handErrorMsg(ajaxObj.message);
	}
}
function getWordByLength(words, length) {
	if (words.length > length) {
		return words.substr(0, length-1) + "...";
	}
	return words;
}
function JumpToSubjectDetails(function_param,obj) {
	window.sessionStorage.setItem('subjectId', function_param.subjectId);
	window.sessionStorage.setItem('subjectType', function_param.subjectTypeName);
	window.sessionStorage.setItem("subjectName", function_param.subjectName);
	$.mobile.changePage("../subject/subjectDetail.html");
}
// 专题更多
function subject_more(obj){
	$.mobile.changePage("../subject/subjectList.html");
}
// 广告回调函数
function call_recommend_ad_function(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		var k=0;
		// 获取页面广告的个数
		$(objs).each(function(){
			var advertisementId = this.get("advertisementId");
			var advName = this.get("advName");
			var targetUrl= this.get("targetUrl");
			var targetType = this.get("targetType");
			var adveUrl = this.get("adveUrl");
			var position = this.get("positions");
			CompositionHTML_recommend_ad(advertisementId,advName,targetUrl,targetType,adveUrl,position);
			k++;
		})
	}else{
		handErrorMsg(ajaxObj.message);
	}
}
// 广告HTML
function CompositionHTML_recommend_ad(advertisementId,advName,targetUrl,targetType,adveUrl,position){
//	var r = document.body.querySelectorAll("thoub");
	var divPosition = document.getElementById(position.substring(2));	
	divPosition.innerHTML="<div><img  src='"+sdmtv.IMG_BASEPATH+targetUrl+"' height='60px' width='100%'/></div>";
	$(divPosition).bind("click", function() {
		goUrl(adveUrl,targetType, advertisementId , position );
	});
}


/**
 * 第一视听回调
 * @param ajaxObj
 * @return
 */
function call_recommend_microblog_function(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$("#rec_microblog").html("<div style='background-image: -webkit-gradient(linear,left top,left bottom,color-stop(0, rgba(16, 16, 18, 0.38)),color-stop(1, rgba(16, 16, 18, 0.71)));' align='center'><table class='recTable'><tr><td align='left' class='recTd'>第一视听</td><td align='right'><a  href='javascript:void(0)' onclick='microblog_more(this);menuGoMid();' class='recA' style='color:#cecece'>更多></a></td></tr></table></div><div align='center' id='recommend_bdDemand'></div>");
		$(objs).each(function(){
			var microblogId = this.get("microblogId");
			var microblogName = this.get("microblogName");
			var microblogType = this.get("microblogType");
			var createTime = this.get("createTime");
			var microblogContent = common_htmlFlagFilter(this.get("microblogContent")).substring(0, 40);
			var flagImgBak = this.get("flagImgBak");
			var realName = this.get("realName");
			var param = {
					"elementId" : "rec_microblog",
					"type":"microblog",
					"mode":"modeDemand5",
					"middleContentTop":realName,
					"middleContent":microblogContent,
					"imgUrl":flagImgBak
			};
			var function_param = {
					"microblogId" :microblogId,
					"microblogName" :microblogName,
					"createTime":createTime
			};
			list_generateList(param,recommend_jumpToMicroblogDetails,function_param);
		})
	}
	recommend_pageIsOk = true;
}
/**
 * 进入第一视听详情页
 * @param param
 * @param obj
 * @return
 */
function recommend_jumpToMicroblogDetails(param,obj){
	window.sessionStorage.setItem('microblogId', param.microblogId);
	window.sessionStorage.setItem('microblogName', param.microblogName);
	window.sessionStorage.setItem('microblogCreateTime',param.createTime);
	obj.href="../microblog/microblog_Details.html";
}
function microblog_more(obj){
	obj.href="../microblog/microblog_List.html";
}
// 播放插入数据库后，返回
function plauBack(ajaxObj) {
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
	}
}
/**
 * recommend.html
 */

/**
 * tvLive_List.html
 */

// 获得节目列表
var tvLiveList_params = {
			"cls" : "LiveVideo_list",
			"programType" : "liveVideo",
			"totalCount":0,
			"beginNum" : 0,
			"step" : 10,
			"liveVideoType":"",
			"sort":"orders",
			"dir":"asc"
		};
//直播分类参数
var tvLive_classListParams={
		"cls":"ProgramType_list",
		"parentCode":"zbfl",
		
};
// 内容加载
function tvLiveList_inIt(){
	tvLive_classListDetail("","");
	// 获取直播分类
	common_channelList(tvLive_classListParams, $("#tvLiveList"), tvLive_classListDetail);
}

//选择某个频道
function tvLive_classListDetail(programTypeId,itemsName){
	tvLiveList_params.beginNum = 0;
	tvLiveList_params.totalCount = 0;
	tvLiveList_params.liveVideoType=programTypeId;
	var divlist = document.getElementById("tvLive_List_Con");
	divlist.innerHTML="";
	new $sdmtv_ajax(tvLiveList_params, tvLive_List);
    $("#tvLive_classLoadmore").css("display", "none");
	var titleName = document.getElementById("tvLive_classListTitle");
	titleName.innerHTML=itemsName||"电视直播";	
}
// 循环获得结果
function tvLive_List(ajaxObj) {
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		if(objs.length == 0){
			tvLiveList_noContent();
		}else{
			$(objs).each(function(){
				var liveVideoId = this.get("liveVideoId");
				var programName= this.get("programName");
				var flagImg = this.get("flagImg");
				var m3u8 = this.get("m3u8");
				var rtsp = this.get("rtsp");
				var nowBroadcast = this.get("nowBroadcast");
				var nextBroadcast = this.get("nextBroadcast");
				var customerCollectionId = this.get("customerCollectionId");
				var showBroadcast = this.get("showBroadcast");
				if(showBroadcast == 1){
					var param = {
							"elementId" : "tvLive_List_Con",
							"type":"tvLive",
							"mode":"modeTvLive",
							"middleContentTop":programName,
							"middleContent":"正在："+nowBroadcast,
							"middleContentBottom":"即将："+nextBroadcast,
							"imgUrl":flagImg
					};
				} else {
					var param = {
							"elementId" : "tvLive_List_Con",
							"type":"bdLive",
							"mode":"modeBdLive",
							"middleContentTop":programName,
							"imgUrl":flagImg
					};
				}
				var function_param = {
						"liveVideoId" :liveVideoId,
						"programName" : programName
				};
				var broadcast_param = {
						"type" :"liveVideo",
						"id" :liveVideoId,
						"name" :programName,
						"m3u8" :m3u8,
						"rtsp" :rtsp,
						"customerCollectionId" :customerCollectionId
				};
				list_generateList(param,JumpToDetails,function_param,broadcast_unifiedPlayer,broadcast_param);
			})
			initTntAd();
		}
		// 判断是否显示加载更多按钮
		checkLoadMore(tvLiveList_params,tvLive_List,"tvLive_classLoadmore");
	}else{
		handRequestError(ajaxObj.message);
	}
};

function tvLiveList_noContent(){
	$("#tvLive_List_Con").append("<div class='ListOrContent_nofound'>当前还没有内容</div>");
};
function JumpToDetails(param,obj){
	window.sessionStorage.setItem('liveVideoId',param.liveVideoId);
	obj.href="tvLive_Details.html";
}
function goback(){
//	var isGoTuijain = window.sessionStorage.getItem("tuijianmore");
//	float_hideLayer("tvLive_classListDiv",document.getElementById("tvLive_classListImg"),3);
	history.back();
//	if(isGoTuijain!=null&&isGoTuijain=="1"){
//		menuGoTuijian();
//	}
}

////直播分类浮动层
//var tvLive_typeIden=false;
//function tvLive_openPop(obj,tvLive_classDiv){
//	document.getElementById("tvLive_classListImg").src="../../jsp/tvLive/images/Button_SelectCategory_Current.PNG";
//	float_popLayer('tvLive_classListDiv',obj,'tvLiveList',tvLive_classListParams,tvLive_classListBack,tvLive_classDiv,3);
//}
////浮动层回调
//function tvLive_classListBack(ajaxObj){
//	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
//		var objs = ajaxObj.objs;
//		var name = document.getElementById("tvLive_classListTitle").innerText;
//		if(name=="电视直播"){
//			var div  = float_creatHtml("tvLive_classList","全部","全部","tvLive_classListDiv","tvLive_classListImg");
//			div.onclick = function() {
//				document.getElementById("tvLive_classLoadmore").innerHTML="";
//				tvLive_classListDetail("all","电视直播");
//			}
//		}else{
//			var div  = float_creatHtml("tvLive_classList","全部",null,"tvLive_classListDiv","tvLive_classListImg");
//			div.onclick = function() {
//				document.getElementById("tvLive_classLoadmore").innerHTML="";
//				tvLive_classListDetail("all","电视直播");
//			}
//		}
//		$(objs).each(function(){
//			var programTypeId = this.get("programTypeId");
//			var itemsName= this.get("itemsName");
//			var div  = float_creatHtml("tvLive_classList",itemsName,name,"tvLive_classListDiv","tvLive_classListImg");
//			div.onclick = function() {
//				document.getElementById("tvLive_classLoadmore").innerHTML="";
//				window.sessionStorage.setItem("liveVideoType",programTypeId);
//				tvLive_classListDetail(programTypeId,itemsName);
//			}
//		})
//	}
//}

/**
 * tvLive_List.html
 */

/**
 * tvLive_Details.html
 */

// 节目名称
var programName_tvLive = null;
var cusCollId = null;
var param_tvLive_Details = {
	"cls" : "LiveVideo_view",
	"programType" : "liveVideo",
	"liveVideoId" : ""
};
// 点评参数
var tvLiveDetails_pammDianpin = {
	"cls" : "Commit_list",
	"totalCount" : 0,
	"programId" : "",
	"programType" : "liveVideo",
	"beginNum" : 0,
	"step" : 10,
	"sort" : "createTime",
	"dir" : "desc",
	
};
// 内容加载
function tvLiveDetails_inIt(){
	// 获得节目列表
	var tvLiveDetails_liveVideoId = window.sessionStorage.getItem('liveVideoId');
	param_tvLive_Details.liveVideoId = tvLiveDetails_liveVideoId;
	tvLiveDetails_pammDianpin.programId = tvLiveDetails_liveVideoId;
	
	addtop();
	new $sdmtv_ajax(param_tvLive_Details, tvLive_view);
}
// 加载头部信息
function addtop(){
	var top ="<tr>"+
			 "<td align='left' style='vertical-align: top;width: 132px'>"+
			 "<div align='center' style='vertical-align: middle;margin:12px 20px 12px 20px;width:92px;height:62px;background-image: url(images/livebg.png)'>"+
			 "<img id='tvLiveDetailsImg' style='width: 87px;height: 57px;margin-top:2px;margin-left:-1px' onerror=\"this.style.display='none'\"/>"+
			 "</div>"+
			 "</td>"+
			 "<td align='left'>"+
			 "<div style='vertical-align: middle;max-height:57px;color: #ffffff;font-family: 黑体;display:block;overflow:hidden' id='tvLiveDetailsName'>"+
			 "</div></td></tr>";
	$("#toptvLive").html(top);
}

// 获得详细信息
function tvLive_view(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$(objs)
				.each(
						function() {
							var liveVideoId = this.get("liveVideoId");
							var programName = this.get("programName");
							var flagImg = this.get("flagImg");
							var m3u8 = this.get("m3u8");
							var rtsp = this.get("rtsp");
							var isCollected = this.get("isCollected");
							programName_tvLive = programName;
							var customerCollectionId = this
									.get("customerCollectionId");
							var description = this.get("description");
							var showBroadcast = this.get("showBroadcast");
							if(showBroadcast!= 1){
								document.getElementById("tvLiveDetails_tabNameLeft").innerHTML = "频道介绍";
								document.getElementById("tvLiveDetails_tabNameRight").innerHTML = "网友点评";
								if(description == null || "" == description){
									$("#tvNotice").html("暂时还没有该频道的介绍");	 
								} else {
									$("#tvNotice").html(description);	 
								}
								$("#tvNotice").removeClass().addClass("channelDescription");
							} else {
								document.getElementById("tvLiveDetails_tabNameLeft").innerHTML = "节目预告";
								document.getElementById("tvLiveDetails_tabNameRight").innerHTML = "网友点评";
								var parm = {
										"cls" : "Broadcast_list",
										"liveVideoId" : liveVideoId,
										"programType" : "liveVideo",
										
									};
										new $sdmtv_ajax(parm, Trailer);
							}
							CompositionHTML_view(liveVideoId, programName,
									flagImg, isCollected, customerCollectionId,
									m3u8, rtsp);
						})
	} else {
		handRequestError(ajaxObj.message);
	}
}
// 组成详细信息的HTML
function CompositionHTML_view(id, name, flagImg, isCollected,
		customerCollectionId, m3u8, rtsp) {
	var tvLiveDetailsImg = document.getElementById("tvLiveDetailsImg");
	tvLiveDetailsImg.src = sdmtv.IMG_BASEPATH + flagImg;
	document.getElementById("tvLiveDetailsName").innerText = name;
	var CollectedText = document.getElementById("skull");
	collectionReset(CollectedText, "liveVideo", id, customerCollectionId);
	
	var playButton = document.getElementById("tvLive_Details_playbutton");
	playButton.onclick = function() {
		if (chk_to_page()) {
			// 节目播放
			var broadcast_param = {
					"type" :"liveVideo",
					"id" :id,
					"name" :name,
					"m3u8" :m3u8,
					"rtsp" :rtsp,
					"customerCollectionId" :customerCollectionId
			};
			if (window.localStorage.getItem('cusCollId') !=null) {
				broadcast_param.customerCollectionId = window.localStorage.getItem('cusCollId');
			} else if(window.localStorage.getItem('cusCollId')==null) {
				broadcast_param.customerCollectionId = customerCollectionId;
			}
			broadcast_unifiedPlayer(broadcast_param);
		}
	}
}
// 节目预告
function Trailer(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		if(objs.length==0){
			$("#tvNotice").html("<div class='ListOrContent_nofound'>暂无节目预告</div>");
		}else{
			$(objs).each(
					function() {
						var broadcastProgramRealationId = this
								.get("broadcastProgramRealationId");
						var liveTime = this.get("liveTime");
						var programName = this.get("programName");
						var isNowBroadcast = this.get("isNowBroadcast");
						var isNextBroadcast = this.get("isNextBroadcast");
						var isCanTip = this.get("isCanTip");
						var isTip = this.get("isTip");
						var customeTipId = this.get("customeTipId");
						var tipLimit = this.get("tipLimit");
						var param = {
								"broadcastProgramRealationId":broadcastProgramRealationId,
								"liveTime":liveTime,
								"liveid":window.sessionStorage.getItem('liveVideoId'),
								"programName":programName,
								"isNowBroadcast":isNowBroadcast,
								"isNextBroadcast":isNextBroadcast,
								"isCanTip":isCanTip,
								"isTip":isTip,
								"customeTipId":customeTipId,
								"tipLimit":tipLimit,
								"programType":"liveVideo",
								"detailsName":document.getElementById("tvLiveDetailsName").innerText,
								"elementId":"tvNotice"
						};
						trailerCompositionHTML(param);
					})
		}
	} else {
		handErrorMsg(ajaxObj.message);
	}
}

// 书签效果
function change_Details(nameId) {
	var name = nameId;
	if (name == "tvNotice") {
		document.getElementById("tvNotice").style.display = "block";
		document.getElementById("tvDianpin").style.display = "none";
	} else if (name == "tvDianpin") {
		document.getElementById("tvNotice").style.display = "none";
		document.getElementById("tvDianpin").style.display = "block";
		// 加载用户点评
		var ul = document.getElementById("tvDianpinCont");
		if (ul.innerHTML != "") {

		} else {
			new $sdmtv_ajax(tvLiveDetails_pammDianpin, CommentCont_dianping);
		}
	}
}
// 获得网友点评
function CommentCont_dianping(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		if(objs.length==0){
			reviewsNoComment("tvDianpinCont");
		}else{
			$(objs).each(
					function() {
						var customerCommitId = this.get("customerCommitId");
						var customerName = this.get("customerName");
						var gradeName = this.get("gradeName");
						var createTime = this.get("createTime");
						var content = this.get("content");
						var sex = this.get("sex");
						var clickParam = this.get("customerId");
						// 生成点评内容
						reviewsCompositionHTML({
							elementId : "tvDianpinCont",
							customerName : customerName,
							gradeName:gradeName,
							createTime : createTime,
							content : content,
							sex: sex,
							clickParam : clickParam
						});
			});
			// 绑定单击事件
			$("#tvDianpinCont").on("click", "a[data-clickParam]", function() {
				var cId = $(this).attr("data-clickParam");
				if (cId == window.sessionStorage.getItem("customerId")) {
					window.sessionStorage.setItem("taCustomerId", -100);// 个人中心左上角图标改为返回按钮
				//	$.mobile.changePage("../../jsp/grgl/home.html");
					sdmtv.changePage("grgl/home", {"taCustomerId" : -100});
				} else {
					window.sessionStorage.setItem("taCustomerId", cId);
				//	$.mobile.changePage("../../jsp/grgl/mainPage.html");
					sdmtv.changePage("grgl/home", {"taCustomerId" : cId});
				}
			});
			// 判断是否显示加载更多按钮
			checkLoadMore(tvLiveDetails_pammDianpin, CommentCont_dianping,
							"loadmore_tvLive_Details");
		}
	} else {
		handErrorMsg(ajaxObj.message);
	}
}

function Trailer_second(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$(objs).each(
				function() {
					var broadcastProgramRealationId = this
							.get("broadcastProgramRealationId");
					var liveTime = this.get("liveTime");
					var programName = this.get("programName");
					var isNowBroadcast = this.get("isNowBroadcast");
					var isNextBroadcast = this.get("isNextBroadcast");
					var isCanTip = this.get("isCanTip");
					var isTip = this.get("isTip");
					var customeTipId = this.get("customeTipId");
					var tipLimit = this.get("tipLimit");
					var param = {
							"broadcastProgramRealationId":broadcastProgramRealationId,
							"liveTime":liveTime,
							"programName":programName,
							"isNowBroadcast":isNowBroadcast,
							"isNextBroadcast":isNextBroadcast,
							"isCanTip":isCanTip,
							"isTip":isTip,
							"customeTipId":customeTipId,
							"tipLimit":tipLimit,
							"programType":"liveVideo",
							"detailsName":document.getElementById("tvLiveDetailsName").innerText,
							"elementId":"tvNotice"
					};
					trailerCompositionHTML(param);
				})
	} else {
		handErrorMsg(ajaxObj.message);
	}
}
// 标签
var tag = function(obj) {
	$(obj).siblings().filter(".tab_down").removeClass("tab_down").addClass("tab_up");
	$(obj).removeClass("tab_up").addClass("tab_down");
};
// 由原生返回时需要查看是否收藏页面
function comeBackCheckCollection(){
	var activePage = $("body>div.ui-page-active");
	var pageName = activePage.attr("id");
	//var CollectedText = null;
	if(pageName=="tvLiveDetalis"){
		//CollectedText = document.getElementById("skull");
		param_tvLive_Details.liveVideoId = window.sessionStorage.getItem('liveVideoId');
		new $sdmtv_ajax(param_tvLive_Details, CheckCollection);
	}else if(pageName=="bdLiveDetalis"){
		//CollectedText = document.getElementById("isskull");
		bdLiveDetails_Param.liveVideoId =window.sessionStorage.getItem('liveAudio');
		new $sdmtv_ajax(bdLiveDetails_Param, bdLive_CheckCollection);
	}else if(pageName=="tvDemand_Details"){
		//CollectedText = document.getElementById("tvDemand_DetailsSkull");
		var tvDemandDetails_videoId = window.sessionStorage.getItem('tvDemand_videoId');
		tvDemandDetails_params.videoId = tvDemandDetails_videoId;
		new $sdmtv_ajax(tvDemandDetails_params, CheckCollection_tvDemand_Details);
	}else if(pageName=="bdDemandDetails"){
		//CollectedText = document.getElementById("bdDemand_isskull");
		var programId = window.sessionStorage.getItem("programId");
		bdDemandDetails_param.audioId = programId;
		new $sdmtv_ajax(bdDemandDetails_param, CheckCollection_bdDemandDetails);
	}else if(pageName=="musicDetails"){
		//CollectedText = document.getElementById("music_isskull");
		var musicBack_param = {
			"cls":"Audio_view",
			"audioId":""
		}
		//节目的id
		var programId = window.sessionStorage.getItem("musicBackProgramId");
		musicBack_param.audioId = programId;
		new $sdmtv_ajax(musicBack_param, musicBack_param_function);
	}else if(pageName=="netVideoDetails"){
		//CollectedText = document.getElementById("netVideo_DetailsSkull");
		var programId = window.sessionStorage.getItem("netVideoBackId");
		netVideoDetails_params.videoId = programId;
		netVideoDetails_pammDianpin.programId = programId;
		netVideoDetails_pammLast.videoId = programId;
		addNetVideoDetailsTop();
	    addNetVideoDetailsTab();
		new $sdmtv_ajax(netVideoDetails_params,netVideo_Details_view);
		//new $sdmtv_ajax(netVideoDetails_pammLast, netVideo_Details_last);
	}
	//$(CollectedText).attr("noShow","true");
	//$(CollectedText).trigger("click");
}
// 检查是否收藏的回调
// 获得详细信息
function CheckCollection(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$(objs)
				.each(
						function() {
							var liveVideoId = this.get("liveVideoId");
							var customerCollectionId = this
									.get("customerCollectionId");
								var CollectedText = document.getElementById("skull");
								collectionReset(CollectedText, "liveVideo", liveVideoId, customerCollectionId);
						})
	} else {
		handErrorMsg(ajaxObj.message);
	}
}
// 点评
function tvLive_Details_dianpin(obj){
	var tvLiveDetails_liveVideoId = window.sessionStorage.getItem('liveVideoId');
	window.sessionStorage.setItem("reviewProgramId",tvLiveDetails_liveVideoId);
	window.sessionStorage.setItem("reviewProgramType","liveVideo");
	obj.href = '../../../local/jsp/common/review.html';
}
// 分享跳转页面
function go_share_tvLive(){
	var tvLiveDetails_liveVideoId = window.sessionStorage.getItem('liveVideoId');
	window.sessionStorage.setItem("share_programId",tvLiveDetails_liveVideoId);
	window.sessionStorage.setItem("share_programType","liveVideo");
	window.sessionStorage.setItem("programName",document.getElementById("tvLiveDetailsName").innerText);
	common_shareProgram();
}
//  返回电视直播列表页
function tvLive_detailsToList(){
	tvLiveDetails_pammDianpin.beginNum = 0;
	tvLiveDetails_pammDianpin.totalCount = 0;
	history.back();
}

/**
 * tvLive_Details.html
 */

/**
 * bdLive_List.html
 */
// 获得广播节目列表
var bdLiveList_params = {            
			"cls" : "LiveVideo_liveAudioList",
			"programType" : "liveAudio",
			"totalCount":0,
			"beginNum" : 0,
			"step" : 10,
			"sort":"orders",
			"dir":"asc"
		};
// 内容加载
function bdLiveList_inIt(){
	bdLiveList_params.totalCount = 0;
	bdLiveList_params.beginNum = 0;
	new $sdmtv_ajax(bdLiveList_params, bdLive_List);
}
// 循环获得结果
function bdLive_List(ajaxObj) {
if(ajaxObj.code == ajaxObj.constants.SUCCESS){
	var objs = ajaxObj.objs;
	if(objs.length == 0){
		bdLiveList_noContent();
	}else{
		$(objs).each(function(){
			var liveAudioId = this.get("liveVideoId");
			var programName= this.get("programName");
			var flagImg = this.get("flagImg");
			var m3u8 = this.get("m3u8");
			var rtsp = this.get("rtsp");
			var customerCollectionId = this.get("customerCollectionId");
			var param = {
					"elementId" : "bdLive_List_Con",
					"type":"bdLive",
					"mode":"modeBdLive",
					"middleContentTop":programName,
					"imgUrl":flagImg
			};
			var function_param = {
					"liveAudio" :liveAudioId
			};
			var broadcast_param = {
					"type" :"liveAudio",
					"id" :liveAudioId,
					"name" :programName,
					"m3u8" :m3u8,
					"rtsp" :rtsp,
					"customerCollectionId" :customerCollectionId
			};
			list_generateList(param,JumpToDetails_bdLive,function_param,broadcast_unifiedPlayer,broadcast_param);
		})
		// 判断是否显示加载更多按钮
		checkLoadMore(bdLiveList_params,bdLive_List,"loadmore_bdLive_List");
		//添加广告
		initTntAd();
	}
}else{
	handRequestError(ajaxObj.message);
}
};

function bdLiveList_noContent(){
	$("#bdLive_List_Con").append("<div class='ListOrContent_nofound'>当前还没有内容</div>");
};

function JumpToDetails_bdLive(param,obj){
	window.sessionStorage.setItem('liveAudio',param.liveAudio);
	obj.href = "bdLive_Details.html";
}
function gobackbdLive(){
//	var isGoTuijain = window.sessionStorage.getItem("tuijianmore");
	history.back();
//	if(isGoTuijain!=null&&isGoTuijain=="1"){
//		menuGoTuijian();
//	}
}
/**
 * bdLive_List.html
 */

/**
 * bdLive_Details.html
 */
var bdLiveDetails_cusCollId = null;
//节目名称
var bdLiveDetails_programName = null;
var bdLiveDetails_Param = {
	"cls" : "LiveVideo_view",
	"programType" : "liveAudio",
	"liveVideoId" : ""
};

//内容加载
function bdLiveDetails_inIt(){
	var bdLiveDetails_liveAudioId = window.sessionStorage.getItem('liveAudio');
	bdLiveDetails_Param.liveVideoId = bdLiveDetails_liveAudioId;
	new $sdmtv_ajax(bdLiveDetails_Param, bdLive_view);
	//获取播放节目列表
	var parm = {
			"cls" : "Broadcast_list",
			"liveVideoId" : bdLiveDetails_liveAudioId,
			"programType" : "liveAudio",
			
		};
	new $sdmtv_ajax(parm, bdLiveDetails_promo);
}
//广播直播节目预告列表
function bdLiveDetails_promo(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		if(objs.length == 0){
			bdLiveList_noContent();
		}else{
		$(objs).each(
				function() {
					var broadcastProgramRealationId = this
							.get("broadcastProgramRealationId");
					var liveTime = this.get("liveTime");
					var programName = this.get("programName");
					var isNowBroadcast = this.get("isNowBroadcast");
					var isNextBroadcast = this.get("isNextBroadcast");
					var isCanTip = this.get("isCanTip");
					var isTip = this.get("isTip");
					var customeTipId = this.get("customeTipId");
					var tipLimit = this.get("tipLimit");
					var param = {
							"broadcastProgramRealationId":broadcastProgramRealationId,
							"liveTime":liveTime,
							"liveid":window.sessionStorage.getItem('liveAudio'),
							"programName":programName,
							"isNowBroadcast":isNowBroadcast,
							"isNextBroadcast":isNextBroadcast,
							"isCanTip":isCanTip,
							"isTip":isTip,
							"customeTipId":customeTipId,
							"tipLimit":tipLimit,
							"programType":"liveAudio",
							"detailsName":document.getElementById("bdLiveDetailsName").innerText,
							"elementId":"tvDianpin"
					};
					trailerCompositionHTML(param);
				})
		}
	} else {
		handErrorMsg(ajaxObj.message);
	}
}
function bdLiveList_noContent(){
	$("#tvDianpin").append("<div class='bdLiveDetails_ListOrContentNofound'>暂无节目预告</div>");
};

//循环获得结果
function bdLive_view(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$(objs)
				.each(
						function() {
							var liveVideoId = this.get("liveVideoId");
							var programName = this.get("programName");
							var flagImg = this.get("flagImg");
							var m3u8 = this.get("m3u8");
							var rtsp = this.get("rtsp");
							var customerCollectionId = this
									.get("customerCollectionId");
							bdLiveDetails_programName = programName;
							var description = this.get("description");
							CompositionHTML_bdLive_view(liveVideoId,
									programName, flagImg, customerCollectionId,
									description, m3u8, rtsp);
						})
	} else {
		handRequestError(ajaxObj.message);
	}
}
//组成HTML
function CompositionHTML_bdLive_view(id, name, flagImg, customerCollectionId,
		description, m3u8, rtsp) {
	var tvLiveDetailsImg = document.getElementById("bdLiveDetailsImg");
	tvLiveDetailsImg.src =sdmtv.IMG_BASEPATH + flagImg;
	document.getElementById("bdLiveDetailsName").innerText = name;
	var CollectedText = document.getElementById("isskull");
	collectionReset(CollectedText, "liveAudio", id, customerCollectionId);

	var playButton = document.getElementById("bdLive_Details_playbutton");
	playButton.onclick = function() {
		if (chk_to_page()) {
				// 节目播放
				var broadcast_param = {
						"type" :"liveAudio",
						"id" :id,
						"name" :name,
						"m3u8" :m3u8,
						"rtsp" :rtsp,
						"customerCollectionId" :customerCollectionId
				};
				
				if (window.localStorage.getItem("cusCollId") != null) {
					broadcast_param.customerCollectionId = window.localStorage.getItem("cusCollId");
				} else if(bdLiveDetails_cusCollId==null){
					broadcast_param.customerCollectionId = customerCollectionId;
				}
				broadcast_unifiedPlayer(broadcast_param);
			}
	}
}
//获得详细信息
function bdLive_CheckCollection(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$(objs)
				.each(
						function() {
							var liveVideoId = this.get("liveVideoId");
							var customerCollectionId = this.get("customerCollectionId");
							var CollectedText = document.getElementById("isskull");
							collectionReset(CollectedText, "liveAudio", liveVideoId, customerCollectionId);
						})
	} else {
		handErrorMsg(ajaxObj.message);
	}
}
//分享跳转页面
function go_share_bdLive(){
	var bdLiveDetails_liveAudioId = window.sessionStorage.getItem('liveAudio');
	window.sessionStorage.setItem("share_programId",bdLiveDetails_liveAudioId);
	window.sessionStorage.setItem("share_programType","liveAudio");
	window.sessionStorage.setItem("programName",document.getElementById("bdLiveDetailsName").innerText);
	common_shareProgram();
}
/**
 * bdLive_Details.html
 */

/**
 * tvDemand_List.html
 */
//所有频道参数
var tvDemandList_paramsChannelList = {
					"cls" : "ProgramType_list",
					"parentCode" : "video_pin_dao",
					
				};
//所有栏目内容列表
var tvDemandList_paramsPartList = {
		"cls" : "ProgramType_videoProgramTypelist",
		"totalCount" : 0,
		"beginNum" : 0,
		"step" : 10,
		"sort" : "playTime",
		"dir" : "desc" 
	};
//内容加载
function tvDemandList_Init(){
	selectChanndl("", "");
	// 获取点播频道列表
	common_channelList(tvDemandList_paramsChannelList, $("#tvDemand_List"), selectChanndl);
}
//选择某个频道
function selectChanndl(id,name){
	tvDemandList_paramsPartList.channelId=id;
	tvDemandList_paramsPartList.beginNum = 0;
	tvDemandList_paramsPartList.totalCount = 0;
	window.sessionStorage.setItem('ChannldId',id);
	var divlist = document.getElementById("partList");
	divlist.innerHTML="";
	new $sdmtv_ajax(tvDemandList_paramsPartList, tvDemand_PartList);
	var titleName = document.getElementById("tvDemand_List_title");
	titleName.innerHTML=name||"电视点播";
}
////调用公共浮动层
//var tvDemand_listChangeImg=false; //判断显示按钮样式
//function floatingOpen(obj,condiv){
//	float_popLayer('pop-div',obj,'tvDemand_List',tvDemandList_paramsChannelList,tvDemandList_floatBack,condiv,1);
//}
//function tvDemandList_floatBack(ajaxObj){
//	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
//		var objs = ajaxObj.objs;
//		var name = document.getElementById("tvDemand_List_title").innerText;
//		if(name=="电视点播"){
//			var div  = float_creatHtml("tvDemandList_float","全部","全部","pop-div","selectPindao_tvDemand_List");
//			div.onclick = function() {
//				selectChanndl("all","电视点播");
//			}
//		}else{
//			var div  = float_creatHtml("tvDemandList_float","全部",null,"pop-div","selectPindao_tvDemand_List");
//			div.onclick = function() {
//				selectChanndl("all","电视点播");
//			}
//		}
//		$(objs).each(function(){
//			var programTypeId = this.get("programTypeId");
//			var itemsName= this.get("itemsName");
//			var div  = float_creatHtml("tvDemandList_float",itemsName,name,"pop-div","selectPindao_tvDemand_List");
//			div.onclick = function() {
//				selectChanndl(programTypeId,itemsName);
//			}
//		})
//	}
//};
//获得所有栏目列表函数
function tvDemand_PartList(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		//如果totalCount查询结果为0,隐藏掉加载更多按钮
		if(objs.length == 0){
			hideLoadMore("loadmore_tvDemand_List");
			tvDemandList_noContent();
		}else{
		$(objs).each(function(){
				var programTypeId = this.get("programTypeId");
				var itemsName= this.get("itemsName");
				var flagImg = this.get("flagImg");
				var programName = this.get("programName");
				var programUrl  = this.get("programUrl");
				var playTime = this.get("playTime");
				var param = {
						"elementId" : "partList",
						"type":"microblog",
						"mode":"modeDemand2",
						"middleContentTop":itemsName,
						"middleContent":"最新节目："+programName,
						"middleContentBottom":"更新时间："+playTime,
						"imgUrl":flagImg
				};
				var function_param = {
						"CTPId" :programTypeId,
						"CTPIdName":itemsName
				};
				list_generateList(param,ChannelToPart,function_param);
			})
			// 判断是否显示加载更多按钮
			checkLoadMore(tvDemandList_paramsPartList,tvDemand_PartList,"loadmore_tvDemand_List");
			window.sessionStorage.setItem("IsToChannldList","false");
			//添加广告
			initTntAd();
		}
	}else{
		handErrorMsg(ajaxObj.message);
	}
};

function tvDemandList_noContent(){
	$("#partList").append("<div class='ListOrContent_nofound'>当前还没有内容</div>");
};


//频道进入栏目
function ChannelToPart(param,obj){
	window.sessionStorage.setItem('CTPId',param.CTPId);
	window.sessionStorage.setItem('CTPIdName',param.CTPIdName);
	window.sessionStorage.setItem('selectedname',document.getElementById("tvDemand_List_title").innerText);
	obj.href="tvDemand_PartList.html";
}
//function backSelect(){
//	//获得选择频道的ID和name
//	var istrue = window.sessionStorage.getItem('IsToChannldList');
//	var selectChannldId = window.sessionStorage.getItem('ChannldId');
//	var selectChannldName = window.sessionStorage.getItem('ChannldName');
//	if(istrue!=null&&istrue=="true"){
//		var divlist = document.getElementById("partList");
//		divlist.innerHTML="";
//		if(selectChannldId!=null){
//			if(selectChannldId=="all"){
//				tvDemandList_paramsPartList.beginNum = 0;
//				tvDemandList_paramsPartList.channelId="";
//				tvDemandList_paramsPartList.totalCount = 0;
//				new $sdmtv_ajax(tvDemandList_paramsPartList, tvDemand_PartList);
//				document.getElementById("tvDemand_List_title").innerHTML=selectChannldName;
//			}else{
//				tvDemandList_paramsPartList.channelId = selectChannldId;
//				tvDemandList_paramsPartList.beginNum = 0;
//				tvDemandList_paramsPartList.totalCount = 0;
//				new $sdmtv_ajax(tvDemandList_paramsPartList, tvDemand_PartList);
//				document.getElementById("tvDemand_List_title").innerHTML=selectChannldName;
//			}
//		}
//	}
//}
function gobacktvDemand(){
//	var isGoTuijain = window.sessionStorage.getItem("tuijianmore");
//	float_hideLayer("pop-div",document.getElementById("selectPindao_tvDemand_List"));
	tvDemandList_paramsPartList.totalCount=0;
	tvDemandList_paramsPartList.beginNum=0;
	history.back();
//	if(isGoTuijain!=null&&isGoTuijain=="1"){
//		menuGoTuijian();
//	}
}
/**
 * tvDemand_List.html
 */

/**
 * tvDemand_PartList.html
 */
//所有频道参数
var tvDemandPartList_ParamsChannelList = {
					"cls" : "ProgramType_list",
					"parentCode" : "video_pin_dao",
					
				};
//所有栏目参数
var tvDemandPartList_paramsLanmuList = {
					"cls" : "Video_list",
					"program" : "",
					"status" : "publish",
					"totalCount" : 0,
					"beginNum" : 0,
					"step" : 10,
					"sort" : "playTime",
					"dir" : "desc"
				};

//时间列表参数
var tvDemandPartList_timeParams={
		"cls":"Video_timeList",
		"programId":""
}
//内容加载
function tvDemandPartList_inIt(){
	//获得选择的栏目的ID
	var CTPId = window.sessionStorage.getItem('CTPId');
	tvDemandPartList_paramsLanmuList.program = CTPId;
	tvDemandPartList_timeParams.programId = CTPId;
	//加载所有栏目列表
	var CTPIdName = window.sessionStorage.getItem('CTPIdName');
	var tempname = CTPIdName;
	if(CTPIdName.length>5){
		tempname = CTPIdName.substring(0, 4) + "..";
	}
	document.getElementById("tvDemand_PartList_title").innerHTML=tempname;
//	document.getElementById("hidePrompt").innerHTML=tempname;
//	$("#tvDemand_PartList_title").attr("name",tempname);
	//获取所有栏目内容
	new $sdmtv_ajax(tvDemandPartList_paramsLanmuList, PartListCallBack);
	//判断是否显示更新时间按钮
//	new $sdmtv_ajax(tvDemandPartList_timeParams, tvDemandPartList_floatBack);
	new $sdmtv_ajax(tvDemandPartList_timeParams, function(ajaxObj) {
		if(ajaxObj.code == ajaxObj.constants.SUCCESS){
			var userData = {itemName : ["全部"],
					itemIndex : [-100],
					curItem : -100};
			var header = $("#tvDemand_PartList").find(".header");
			var objs = ajaxObj.objs;
			console.log(objs.length);
			if(objs.length==0){
				// 不显示按钮
				return;
			} else {
				$(header).removeClass("slide_menu_disable").addClass("slide_menu_hide");;
				$(objs).each(function(i){
					var periodTime=this.get("playTime");
					periodTime=periodTime.substring(0,4)+"年"+periodTime.substring(5,7)+"月";
					userData.itemName.push(periodTime);
					userData.itemIndex.push(i);
				});
			}
			// 绑定事件
			$(header).on("click", ".header_right", function() {
				htmlHelper.createSlideMenu(header, userData, function(newItem) {
					var i = userData.itemName.length-1, name = "all";
					for (;i>0;i-=1) {
						if (userData.itemIndex[i] == newItem) {
							name = userData.itemName[i];
						}
					}
					// 调用处理函数
					tvDemand_classListByTime(name);
				});
			});
		}
	});
}
////调用公共   电视点播月份分类
//function tvDemandPartList_floatingOpen(obj,condiv){
//	float_popLayer('pop-div1',obj,'tvDemand_PartList',tvDemandPartList_timeParams,tvDemandPartList_floatBack,condiv,4);
//}
//function tvDemandPartList_floatBack(ajaxObj){
//	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
//		var objs = ajaxObj.objs;
//		if(objs.length==0){
//			$("#selectPindao_tvDemand_Part").css("display","none");
//		}
////		var selectedname = document.getElementById("tvDemand_PartList_title").innerHTML;
////		var selectedname = $("#hidePrompt").text();
//		var selectedname = $("#tvDemand_PartList_title").attr("name");
//		
//		if(selectedname==window.sessionStorage.getItem('CTPIdName')){
//			var div  = float_creatHtml("tvDemandPartList_float","全部","全部","pop-div1","selectPindao_tvDemand_Part");
//			div.onclick = function() {
//				tvDemand_classListByTime("all",this);
//			}
//		}else{
//			var div  = float_creatHtml("tvDemandPartList_float","全部",selectedname,"pop-div1","selectPindao_tvDemand_Part");
//			div.onclick = function() {
//				tvDemand_classListByTime("all",this);
//			}
//		}
//		$(objs).each(function(){
//			var periodTime=this.get("playTime");
//			periodTime=periodTime.substring(0,4)+"年"+periodTime.substring(5,7)+"月";
//			var div  = float_creatHtml("tvDemandPartList_float",periodTime,selectedname,"pop-div1","selectPindao_tvDemand_Part");
//			div.onclick = function() {
//				document.getElementById("lanmupartList").innerHTML="";
//				document.getElementById("tvDemand_PartList_title").innerHTML=document.getElementById("tvDemand_PartList_title").innerHTML;
////				document.getElementById("hidePrompt").innerHTML=periodTime;
//				$("#tvDemand_PartList_title").attr("name",periodTime);
//				tvDemand_classListByTime(periodTime,this);
//			}
//		})
//	}
//};
//按时间列表查询节目
var tvDemand_listByTimeParams={
		"cls":"Video_queryDetailListByTime",
		"programId":"",
		"status":"publish",
		"demandPeriod":"",
		"totalCount" : 0,
		"beginNum" : 0,
		"step" : 10,
		"sort" : "playTime",
		"dir" : "desc"
}
function tvDemand_classListByTime(periodTime,obj){
//	$("#selectPindao_tvDemand_Part").attr("src","../../images/tvDemand/Button_Updated_Normal.PNG");
	if(periodTime=="all"){
//		document.getElementById("hidePrompt").innerHTML=window.sessionStorage.getItem('CTPIdName');
//		$("#tvDemand_PartList_title").attr("name",window.sessionStorage.getItem('CTPIdName'));
		document.getElementById("lanmupartList").innerHTML="";
		document.getElementById("loadmore_tvDemand_PartList").innerHTML="";
//		document.getElementById("tvDemandPartList_float").innerHTML="";
		tvDemandPartList_paramsLanmuList.totalCount=0;
		tvDemandPartList_paramsLanmuList.beginNum=0;
		new $sdmtv_ajax(tvDemandPartList_paramsLanmuList, PartListCallBack);
	}else{
		document.getElementById("lanmupartList").innerHTML="";
		document.getElementById("loadmore_tvDemand_PartList").innerHTML="";
//		document.getElementById("tvDemandPartList_float").innerHTML="";
		tvDemand_listByTimeParams.totalCount=0;
		tvDemand_listByTimeParams.beginNum=0;
		tvDemand_listByTimeParams.demandPeriod=periodTime.substring(0,4)+"-"+periodTime.substring(5,7);
		tvDemand_listByTimeParams.programId=window.sessionStorage.getItem('CTPId');
		new $sdmtv_ajax(tvDemand_listByTimeParams, tvDemand_PartListCallBackByTime);
	}
}
//获得频道列表返回函数
function PartListCallBack(ajaxObj){
	var CTPId = window.sessionStorage.getItem('CTPId');
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		if(objs.length == 0){
			tvDemandPartList_noContent();
		}else{
			$(objs).each(function(){
				var videoId = this.get("videoId");
				var videoName= this.get("videoName");
				var videoImg= this.get("videoImg");
				var videoUrl= this.get("videoUrl");
				var playtime = this.get("playTime");
				var channel = this.get("channel");
				var customerCollectionId = this.get("customerCollectionId");
				var param = {
						"elementId" : "lanmupartList",
						"type":"tvDemand",
						"mode":"modeDemand3",
						"middleContentTop":videoName,
						"middleContent":"更新时间："+playtime,
						"imgUrl":videoImg
				};
				var function_param = {
						"tvDemand_videoId" :videoId
				};
				var broadcast_param = {
						"type" :"video",
						"id" :videoId,
						"name" :videoName,
						"m3u8" :videoUrl,
						"rtsp" :videoUrl,
						"customerCollectionId" :customerCollectionId,
						"channel" :channel,
						"program" :CTPId
				};
				list_generateList(param,PageToTvDemand_Details,function_param,broadcast_unifiedPlayer,broadcast_param);
			})
			// 判断是否显示加载更多按钮
			checkLoadMore(tvDemandPartList_paramsLanmuList,PartListCallBack,"loadmore_tvDemand_PartList");
			//添加广告
			initTntAd();
		}
	}else{
		handErrorMsg(ajaxObj.message);
	}
};
//根据时间段查询
function tvDemand_PartListCallBackByTime(ajaxObj){
	var CTPId = window.sessionStorage.getItem('CTPId');
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		if(objs.length == 0){
			hideLoadMore("loadmore_tvDemand_PartList");
			tvDemandPartList_noContent();
		}else{
			$(objs).each(function(){
				var videoId = this.get("videoId");
				var videoName= this.get("videoName");
				var videoImg= this.get("videoImg");
				var videoUrl= this.get("videoUrl");
				var playtime = this.get("playTime");
				var channel = this.get("channel");
				var customerCollectionId = this.get("customerCollectionId");
				var param = {
						"elementId" : "lanmupartList",
						"type":"tvDemand",
						"mode":"modeDemand3",
						"middleContentTop":videoName,
						"middleContent":"更新时间："+playtime,
						"imgUrl":videoImg
				};
				var function_param = {
						"tvDemand_videoId" :videoId
				};
				var broadcast_param = {
						"type" :"video",
						"id" :videoId,
						"name" :videoName,
						"m3u8" :videoUrl,
						"rtsp" :videoUrl,
						"customerCollectionId" :customerCollectionId,
						"channel" :channel,
						"program" :CTPId
				};
				list_generateList(param,PageToTvDemand_Details,function_param,broadcast_unifiedPlayer,broadcast_param);
			})
			// 判断是否显示加载更多按钮
			checkLoadMore(tvDemand_listByTimeParams,tvDemand_PartListCallBackByTime,"loadmore_tvDemand_PartList");
		}
	}else{
		handErrorMsg(ajaxObj.message);
	}
};

function tvDemandPartList_noContent(){
//	$("#selectPindao_tvDemand_Part").css("display","none");
	$("#lanmupartList").append("<div class='ListOrContent_nofound'>当前还没有内容</div>");
//	document.getElementById("tvDemandPartList_float").innerHTML="";
};

//选择频道
//function ToSelectChanndl(id,name,obj){
//	window.sessionStorage.setItem('IsToChannldList',"true");
//	window.sessionStorage.setItem('ChannldId',id);
//	window.sessionStorage.setItem('ChannldName',name);
//	obj.href="javascript:history.back();backSelect();";
//}
//进入电视点播详情页面
function PageToTvDemand_Details(param,obj){
	//var name =document.getElementById("tvDemand_PartList_title");
	window.sessionStorage.setItem('tvDemand_videoId',param.tvDemand_videoId);
	obj.href="tvDemand_Details.html";
}
//返回
function tvDemandPartListHistory(){
//	float_hideLayer("pop-div1",document.getElementById("selectPindao_tvDemand_Part"));
//	document.getElementById("lanmupartList").innerHTML="";
//	document.getElementById("loadmore_tvDemand_PartList").innerHTML="";
	
	tvDemandPartList_paramsLanmuList.totalCount=0;
	tvDemandPartList_paramsLanmuList.beginNum=0;
//	document.getElementById("tvDemandPartList_float").innerHTML="";
	history.back();
}
/**
 * tvDemand_PartList.html
 */

/**
 * tvDemand_Details.html
 */
//节目名称
var programName_tvDemand = null;
// 查询详细内容参数
var tvDemandDetails_params = {
	"cls" : "Video_view",
	"videoId" : ""
};
// 点评参数
var tvDemandDetails_pammDianpin = {
	"cls" : "Commit_list",
	"totalCount" : 0,
	"programId" : "",
	"programType" : "video",
	"beginNum" : 0,
	"step" : 10,
	"sort" : "createTime",
	"dir" : "desc",
	
};
// 往期节目参数
var tvDemandDetails_pammLast = {
	"cls" : "Video_thePeriodList",
	"videoId" : "",
	"programType" : "video",
	
};
//内容加载
function tvDemandDetails_inIt(){
	var tvDemandDetails_videoId = window.sessionStorage.getItem('tvDemand_videoId');
	tvDemandDetails_params.videoId = tvDemandDetails_videoId;
	tvDemandDetails_pammDianpin.programId = tvDemandDetails_videoId;
	tvDemandDetails_pammLast.videoId = tvDemandDetails_videoId;
	// 获得具体栏目ID
	//var tvDemandDetails_name = window.sessionStorage.getItem('CTPIdName');
	
	addTvDemandDetailsTop();
	addTvDemandDetailsTab();
	new $sdmtv_ajax(tvDemandDetails_params,tvDemand_Details_view);
	// 加载往期节目
	new $sdmtv_ajax(tvDemandDetails_pammLast, tvDemand_Details_last);
}
//加载内容头部
function addTvDemandDetailsTop(){
	var top = "<tr><td width='132px' align='left' style='vertical-align: top;'>"+
		  "<div align='center' style='vertical-align: middle;margin: 12px 20px 12px 20px;width:92px;height:62px;background-image: url(../tvLive/images/livebg.png)'>"+
		  "<img id='tvDemandDetailsImg'   height='57px' width='87px' style='margin-top:2px;margin-left:-1px' />"+
		  "</div></td>"+"<td align='left' style='vertical-align: top; font-weight: bold;'>"+
		  "<table width='100%' border='0' cellpadding='0' cellspacing='0' style='margin: 12px 10px 12px 0;'>"+
		  "<tr><td style='font-size: 16px;color: #ffffff;font-family: 黑体'><div style='height:33px;width:180px;'><span id='tvDemandDetailsName' style='color: #ffffff;'></span></div></td>"+
		  "</tr><tr>"+
		  "<td style='font-size: 13px;;color: #ffffff;font-family: 黑体;padding-top: 13px;'><span id='tvDemandDetailsTime'></span></td>"+
		  "</tr></table></td></tr>";
	
	$("#toptvdemanddetails").html(top);
}
//加载标签
function addTvDemandDetailsTab(){
	var tab = "<div class='tab' style='width: 94%;'>"+"<div class='tag_down'  style='width:48.5%;border: black solid 1px;padding-left:4px;' onclick='javascript:tvDemandDetails_tag(0);changeTvDemand(\"tvNotice_tvDemand\");'>最近更新</div>"+
			  "<div class='tag_up' style='width:48.5%;border: black solid 1px;' onclick='javascript:tvDemandDetails_tag(1);changeTvDemand(\"tvDianpin_tvDemand\");' >网友点评</div>"+
			  "</div>";
	$("#tvdemanddetailstab").html(tab);
}
// 获得所有栏目列表函数
function tvDemand_Details_view(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$(objs).each(function() {
							var videoId = this.get("videoId");
							var videoName = this.get("videoName");
							window.sessionStorage.setItem("tvDemand_tempVideoName",videoName);
							var videoImg = this.get("videoImg");
							var videoUrl = this.get("videoUrl");
							var videoLong = this.get("videoLong");
							var playtime = this.get("playTime");
							programName_tvDemand = videoName;
							var channel = this.get("channel");
							var program = this.get("program");
							var customerCollectionId = this.get("customerCollectionId");
							var channelName = this.get("channelName");
							var programName = this.get("programName");
							viewToHtml(videoId, videoName, videoImg, videoUrl,
									videoLong, playtime, customerCollectionId,channel,channelName,program,programName);
						})
					
	} else {
		handErrorMsg(ajaxObj.message);
	}
}

// 详细内容转为HTML
function viewToHtml(videoId, videoName, videoImg, videoUrl, videoLong,
		playtime, customerCollectionId,channel,channelName,program,programName) {
	document.getElementById("tvDemandDetailsImg").src = sdmtv.IMG_BASEPATH
			+ videoImg;
	var name = videoName;
	if(videoName.length>20){
		name = videoName.substring(0,18)+"..";
	}
	
	var programtemp = programName;
	if(programName.length>7){
		programtemp = programName.substring(0,5)+"..";
	}
	document.getElementById("tvDemand_Details_title").innerHTML = programtemp;
	document.getElementById("tvDemandDetailsName").innerHTML = name;
	document.getElementById("tvDemandDetailsTime").innerHTML = "更新时间："
			+ playtime;

	var CollectedText = document.getElementById("tvDemand_DetailsSkull");
	collectionReset(CollectedText, "video", videoId, customerCollectionId);
	var playButton = document.getElementById("tvDemand_Details_playbutton");
	playButton.onclick = function() {
		if (chk_to_page()) {
				// 节目播放
				var broadcast_param = {
						"type" :"video",
						"id" :videoId,
						"name" :videoName,
						"m3u8" :videoUrl,
						"rtsp" :videoUrl,
						"customerCollectionId" :customerCollectionId,
						"channel" :channel,
						"program" :program
				};
				if (window.localStorage.getItem('cusCollId') != null) {
					broadcast_param.customerCollectionId = window.localStorage.getItem('cusCollId');;
				} else if(window.localStorage.getItem('cusCollId') == null){
					broadcast_param.customerCollectionId = customerCollectionId;
				}
				broadcast_unifiedPlayer(broadcast_param);
			}
	}
}
// 书签效果
function changeTvDemand(nameId) {
	var name = nameId;
	if (name == "tvNotice_tvDemand") {
		document.getElementById("tvNotice_tvDemand").style.display = "block";
		document.getElementById("tvDianpin_tvDemand").style.display = "none";
	} else if (name == "tvDianpin_tvDemand") {
		document.getElementById("tvNotice_tvDemand").style.display = "none";
		document.getElementById("tvDianpin_tvDemand").style.display = "block";
		// 加载用户点评
		tvDemandDetails_pammDianpin.programId = window.sessionStorage.getItem('tvDemand_videoId');
		var ul = document.getElementById("tvDianpin_tvDemandCont");
		ul.innerHTML = "";
		new $sdmtv_ajax(tvDemandDetails_pammDianpin,
				tvDemand_DetailsCommentCont_dianping);
	}
}
// 获得网友点评
function tvDemand_DetailsCommentCont_dianping(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		if(objs.length==0){
			reviewsNoComment("tvDianpin_tvDemandCont");
		}else{
			$(objs).each(
					function() {
						var customerCommitId = this.get("customerCommitId");
						var customerName = this.get("customerName");
						var gradeName = this.get("gradeName");
						var createTime = this.get("createTime");
						var content = this.get("content");
						var sex = this.get("sex");
						var clickParam = this.get("customerId");
						// 生成点评内容
						reviewsCompositionHTML({
							elementId : "tvDianpin_tvDemandCont",
							customerName : customerName,
							gradeName:gradeName,
							createTime : createTime,
							content : content,
							sex: sex,
							clickParam : clickParam
						});
			});
			// 绑定单击事件
			$("#tvDianpin_tvDemandCont").on("click", "a[data-clickParam]", function() {
				var cId = $(this).attr("data-clickParam");
				if (cId == window.sessionStorage.getItem("customerId")) {
					window.sessionStorage.setItem("taCustomerId", -100);// 个人中心左上角图标改为返回按钮
					$.mobile.changePage("../../jsp/grgl/home.html");
				} else {
					window.sessionStorage.setItem("taCustomerId", cId);
					$.mobile.changePage("../../jsp/grgl/mainPage.html");
				}
			});
			// 判断是否显示加载更多按钮
			checkLoadMore(tvDemandDetails_pammDianpin,
					tvDemand_DetailsCommentCont_dianping,
					"loadmore_tvDemand_Details_dianping");
		}
	} else {
		handErrorMsg(ajaxObj.message);
	}
}
// 往期节目回调函数
function tvDemand_Details_last(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		var ul = document.getElementById("tvDianpin_tvDemandCont_last");
		ul.innerHTML="";
		var i=0;
		if(objs.length==0){
			$("#tvDianpin_tvDemandCont_last").html("<div class='ListOrContent_nofound'>暂无往期节目</div>");
		}else{
			$(objs).each(function() {
				var videoId = this.get("videoId");
				var videoName = this.get("videoName");
				var playTime = this.get("playTime");
				playTime = playTime.substring(5);
				var videoUrl = this.get("videoUrl");
				var channel=this.get("channel");
				var program=this.get("program");
				var customerCollectionId = this.get("customerCollectionId");
				if(i<=10&&videoId!=window.sessionStorage.getItem('tvDemand_videoId')){
					tvDemand_Details_lastToHtml(videoId, videoName,playTime, videoUrl, customerCollectionId,channel,program);
				}
				i++;
			})
		}
	} else {
		handErrorMsg(ajaxObj.message);
	}
}
// 往期节目转为HTML
function tvDemand_Details_lastToHtml(videoId, videoName, playTime, videoUrl,
		customerCollectionId,channel,program) {
	var tvDemandDetails_videoId = window.sessionStorage.getItem('tvDemand_videoId');
	var ul = document.getElementById("tvDianpin_tvDemandCont_last");
	var table = document.createElement("table");
	table.className = "tvDianpin_tvDemandCont_last";
	var name = videoName;
	table.innerHTML = "<tr>" + "<td nowrap='nowrap' class='tvDemand_DetailsName' align='left'>"
			+ name + "</td>" + "<td width='40px' class='tvDemand_DetailsTime' align='right' >" + playTime + "</td>" + "</tr>";
	var div  = document.createElement("div");
	div.className = "List_Cont_recommend_div";
	ul.appendChild(table);
	$(table).click(function() {
		goToLastOne(videoId, videoName, playTime, videoUrl,customerCollectionId,channel,program,this);
	});
	ul.appendChild(div);
}
//查看往期节目
function goToLastOne(videoId, videoName, playTime, videoUrl,customerCollectionId,channel,program,obj){
	// 设置点击的高亮
	$(".tvDianpin_tvDemandCont_last").removeClass().addClass("tvDianpin_tvDemandCont_last");
	$(obj).addClass("changeType");
	document.getElementById("tvDemandDetailsName").innerHTML = videoName;
	document.getElementById("tvDemandDetailsTime").innerHTML = "更新时间："+ playTime;
	tvDemandDetails_params.videoId = videoId;
	// 节目播放
	if (chk_to_page()) {
		new $sdmtv_ajax(tvDemandDetails_params,tvDemand_Details_view);
		var broadcast_params = {
				"type" :"video",
				"id" :videoId,
				"name" :videoName,
				"m3u8" :videoUrl,
				"rtsp" :videoUrl,
				"customerCollectionId" :-1,
				"channel" :channel,
				"program" :program
		};
		broadcast_unifiedPlayer(broadcast_params);
	};
}
//标签
function tvDemandDetails_tag(index){
	var imgs = document.querySelectorAll(".tag_up,.tag_down");
	if(index < 0 || index >= imgs.length) return;
	for(var i=0;i<imgs.length;i++){
		imgs[i].className = i==index?'tag_down':'tag_up';
	}
}
//获得详细信息
function CheckCollection_tvDemand_Details(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$(objs)
				.each(
						function() {
							var videoId = this.get("videoId");
							var customerCollectionId = this
									.get("customerCollectionId");
								var CollectedText = document.getElementById("tvDemand_DetailsSkull");
								collectionReset(CollectedText, "video", videoId, customerCollectionId);
						})
	} else {
		handRequestError(ajaxObj.message);
	}
}
//点评
function tvDemand_Details_dianpin(obj){
	var tvDemandDetails_videoId = window.sessionStorage.getItem('tvDemand_videoId');
	window.sessionStorage.setItem("reviewProgramId",tvDemandDetails_videoId);
	window.sessionStorage.setItem("reviewProgramType","video");
	obj.href = '../../../local/jsp/common/review.html';
}
//分享跳转页面
function go_share_tvDemand(){
	var tvDemandDetails_videoId = window.sessionStorage.getItem('tvDemand_videoId');
	window.sessionStorage.setItem("share_programId",tvDemandDetails_videoId);
	window.sessionStorage.setItem("share_programType","video");
	window.sessionStorage.setItem("programName",document.getElementById("tvDemandDetailsName").innerText);
	common_shareProgram();
}
/**
 * tvDemand_Details.html
 */

/**
 * bdDemand_List.html
 */
//所有频道参数
var bdDemandList_paramsChannelList = {
					"cls" : "ProgramType_list",
					"parentCode" : "audio_pin_dao",
					
				};
//所有栏目内容列表
var bdDemandList_paramsPartList = {
		"cls" : "ProgramType_audioProgramTypelist",
		"channelId" : "",
		"totalCount" : 0,
		"beginNum" : 0,
		"step" : 10,
		"sort" : "playTime",
		"dir" : "desc"
	};

//内容加载
function bdDemandList_inIt(){
	//加载所有栏目列表
	selectChanndl_bdDemand("", "");
	common_channelList(bdDemandList_paramsChannelList, $("#bdDemand_List"), selectChanndl_bdDemand);
}
////调用公共浮动层
//function bdDemandList_floatingOpen(obj,condiv){
//	float_popLayer('pop-divbdDemand',obj,'bdDemand_List',bdDemandList_paramsChannelList,bdDemandList_floatBack,condiv,1);
//}
//function bdDemandList_floatBack(ajaxObj){
//	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
//		var objs = ajaxObj.objs;
//		var name = document.getElementById("bdDemand_List_title").innerText;
//		if(name=="广播点播"){
//			var div  = float_creatHtml("bdDemandList_float","全部","全部","pop-divbdDemand","selectPindao_bdDemand_List");
//			div.onclick = function() {
//				selectChanndl_bdDemand("all","广播点播");
//			}
//		}else{
//			var div  = float_creatHtml("bdDemandList_float","全部",null,"pop-divbdDemand","selectPindao_bdDemand_List");
//			div.onclick = function() {
//				selectChanndl_bdDemand("all","广播点播");
//			}
//		}
//		$(objs).each(function(){
//			var programTypeId = this.get("programTypeId");
//			var itemsName= this.get("itemsName");
//			var div  = float_creatHtml("bdDemandList_float",itemsName,name,"pop-divbdDemand","selectPindao_bdDemand_List");
//			div.onclick = function() {
//				selectChanndl_bdDemand(programTypeId,itemsName);
//			}
//		})
//	}
//};
//选择某个频道
function selectChanndl_bdDemand(id,name){
	bdDemandList_paramsPartList.channelId=id;
	bdDemandList_paramsPartList.beginNum = 0;
	bdDemandList_paramsPartList.totalCount = 0;
	var divlist = document.getElementById("partList_bdDemand");
	divlist.innerHTML="";
	new $sdmtv_ajax(bdDemandList_paramsPartList, bdDemand_PartList);
	var titleName = document.getElementById("bdDemand_List_title");
	titleName.innerHTML=name||"广播点播";
}
//获得所有栏目列表函数
function bdDemand_PartList(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		//如果totalCount查询结果为0,隐藏掉加载更多按钮
		if(objs.length == 0){
			hideLoadMore("loadmore_bdDemand_List");
			bdDemandList_noContent();
		}else{
			$(objs).each(function(){
				var programTypeId = this.get("programTypeId");
				var itemsName= this.get("itemsName");
				var flagImg = this.get("flagImg");
				var programName = this.get("programName");
				var programUrl  = this.get("programUrl");
				var playTime = this.get("playTime");
				var programId = this.get("programId");//最新节目的ID
				var param = {
						"elementId" : "partList_bdDemand",
						"type":"microblog",
						"mode":"modeDemand2",
						"middleContentTop":itemsName,
						"middleContent":"最新节目："+programName,
						"middleContentBottom":"更新时间："+playTime,
						"imgUrl":flagImg
				};
				var function_param = {
						"CTPId_bdDemand" :programTypeId,
						"CTPIdName_bdDemand":itemsName,
						"programId":programId
				};
				list_generateList(param,ChannelToPart_bdDemand,function_param);
			})
			// 判断是否显示加载更多按钮
			checkLoadMore(bdDemandList_paramsPartList,bdDemand_PartList,"loadmore_bdDemand_List");
			window.sessionStorage.setItem("IsToChannldList_bdDemand","false");
			//添加广告
			initTntAd();
		}
	}else{
		handErrorMsg(ajaxObj.message);
	}
};

function bdDemandList_noContent(){
	$("#partList_bdDemand").append("<div class='ListOrContent_nofound'>当前还没有内容</div>");
};

//频道进入详情页
function ChannelToPart_bdDemand(param,obj){
	window.sessionStorage.setItem('CTPId_bdDemand',param.CTPId_bdDemand);
	window.sessionStorage.setItem('CTPIdName_bdDemand',param.CTPIdName_bdDemand);
	window.sessionStorage.setItem("programId",param.programId);
	obj.href="bdDemand_Details.html";
}
//function backSelect_bdDemand(){
//	//获得选择频道的ID和name
//	var istrue_bdDemand = window.sessionStorage.getItem('IsToChannldList_bdDemand');
//	var selectChannldId_bdDemand = window.sessionStorage.getItem('ChannldId_bdDemand');
//	var selectChannldName_bdDemand = window.sessionStorage.getItem('ChannldName_bdDemand');
//	if(istrue_bdDemand!=null&&istrue_bdDemand=="true"){
//		var divlist = document.getElementById("partList_bdDemand");
//		divlist.innerHTML="";
//		if(selectChannldId_bdDemand!=null){
//			var divlist = document.getElementById("partList_bdDemand");
//			divlist.innerHTML="";
//			if(selectChannldId_bdDemand=="all"){
//				bdDemandList_paramsPartList.beginNum = 0;
//				bdDemandList_paramsPartList.channelId="";
//				bdDemandList_paramsPartList.totalCount = 0;
//				new $sdmtv_ajax(bdDemandList_paramsPartList, bdDemand_PartList);
//				document.getElementById("bdDemand_List_title").innerHTML=selectChannldName_bdDemand;
//			}else{
//				bdDemandList_paramsPartList.channelId = selectChannldId_bdDemand;
//				bdDemandList_paramsPartList.beginNum = 0;
//				bdDemandList_paramsPartList.totalCount = 0;
//				new $sdmtv_ajax(bdDemandList_paramsPartList, bdDemand_PartList);
//				document.getElementById("bdDemand_List_title").innerHTML=selectChannldName_bdDemand;
//			}
//		}
//	}
//}
function gobackbdDemand(){
//	var isGoTuijain = window.sessionStorage.getItem("tuijianmore");
	bdDemandList_paramsPartList.beginNum = 0;
	bdDemandList_paramsPartList.totalCount = 0;
//	float_hideLayer("pop-divbdDemand",document.getElementById("selectPindao_bdDemand_List"));
	history.back();
//	if(isGoTuijain!=null&&isGoTuijain=="1"){
//		menuGoTuijian();
//	}
}
/**
 * bdDemand_List.html
 */

/**
 * addApp.html
 */
//function addApp_inIt(){
//	document.getElementById("bottomMenuIndex").style.display="block"; //显示底部菜单
//	// 获取应用列表
//		var params_man_App = {
//			"cls" : "IndexProgram_privateList"
//		};
//	new $sdmtv_ajax(params_man_App, Get_privateAppList);
//}
//// 获取用户应用列表
//function Get_privateAppList(ajaxObj) {
//	var i = 0;
//	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
//		var objs = ajaxObj.objs;
//		var listcont = document.getElementById("listcont");
//		$(objs)
//				.each(
//						function() {
//							var indexProgramId = this.get("indexProgramId");
//							var title = this.get("title");
//							var img = this.get("thumbnail");
//							var indexSettingsId = this.get("indexSettingsId");
//							var indexProgramId = this.get("indexProgramId");
//							i++;
//							var li = document.createElement("li");
//							li.className = "ui-li ui-li-static ui-body-a ui-corner-top";
//							li.id = "app" + i;
//							var temp = "<table cellpadding='0' cellspacing='0' width='100%'>"
//									+ "<tr>"
//									+ "<td width='30px'><img style='vertical-align: middle' src='"
//									+ sdmtv.IMG_BASEPATH+img
//									+ "' width='25px' height='25px'/></td>"
//									+ "<td style='vertical-align: middle;padding-left:10px;font-family: 黑体;'>"
//									+ title + "</td>" + "<td align='right'>";
//							var isChooseHTML="<img src='../../img/index/addon.png' width='73px' onclick='javascript:deleteApp("
//											+ indexSettingsId
//											+ ",this,"
//											+ indexProgramId
//											+ ")' />" + "</td></tr></table>";
//							var isnoChooseHTML="<img src='../../img/index/addoff.png' width='73px' onclick='javascript:addApp("
//											+ indexProgramId
//											+ ",this)' />" + "</td></tr></table>";
//							if (indexSettingsId != "-1") {
//								temp = temp + isChooseHTML;
//							} else {
//								temp = temp + isnoChooseHTML;
//							}
//							li.innerHTML = temp;
//							var div  = document.createElement("div");
//							div.className = "dividing_line";
//							listcont.appendChild(li);
//							listcont.appendChild(div);
//						})
//		if (i >= 4) {
//			for ( var j = 2; j <= i - 1; j++) {
//				var app = document.getElementById("app" + j);
//				app.className = "ui-li ui-li-static ui-body-a";
//			}
//			var app = document.getElementById("app" + i);
//			$("#app"+i).css({"border": 0});
//			$("#listcont div:last-child").remove();
//			app.className = "ui-li ui-li-static ui-body-a ui-corner-bottom";
//		}
//		$("#listcont").trigger("create");// 重新渲染页面
//	} else {
//		handErrorMsg(ajaxObj.message);
//	}
//}
// 添加
//function addApp(indexProgramId, obj) {
//	var params_add_App = {
//		"cls" : "IndexProgram_add",
//		"indexProgramId" : indexProgramId,
//		
//	};
//	var appParam={
//			"selectObj" :obj,
//			"appNum":indexProgramId
//	}
//	new $sdmtv_ajax(params_add_App, addAppList,appParam);
//}
//function addAppList(ajaxObj,appParam) {
//	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
//		var objs = ajaxObj.objs;
//		var indexSettingsId = null;
//		$(objs).each(function() {
//			indexSettingsId = this.get("indexSettingsId");
//		})
//		appParam.selectObj.src="../../img/index/addon.png";
//		appParam.selectObj.onclick = function() {
//			deleteApp(indexSettingsId, this, appParam.appNum);
//		};
//		window.sessionStorage.setItem('changeApp', "1");
//	} else {
//		handErrorMsg(ajaxObj.message);
//	}
//}
//// 删除应用
//
//function deleteApp(id, obj, appNum) {
//	var params_delete_App = {
//		"cls" : "IndexProgram_delete",
//		"indexSettingsIds" : id,
//		
//	};
//	var appParam={
//			"selectObj" :obj,
//			"appNum":appNum
//	}
//	new $sdmtv_ajax(params_delete_App, deleteAppList,appParam);
//}
//function deleteAppList(ajaxObj,appParam) {
//	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
//		var objs = ajaxObj.objs;
//		appParam.selectObj.src="../../img/index/addoff.png";
//		appParam.selectObj.onclick = function() {
//			addApp(appParam.appNum, this);
//		};
//		window.sessionStorage.setItem('changeApp', "1");
//	} else {
//		handErrorMsg(ajaxObj.message);
//	}
//}

/**
 * addApp.html
 */

var SHARE_WEIBO_KEY = "sdmp";
// /////////====================个人设置，分享绑定
/**
 * 获取绑定信息。 weiboShareId -1 未绑定 >0 则绑定
 */
function share_getWeiboShareBindInfo() {
	var params = {
		cls : "Weibo_queryBindInfo",
		weiboKey : SHARE_WEIBO_KEY
	};
	new $sdmtv_ajax(params, function(ajaxObj) {
				if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
					var objs = ajaxObj.objs;
					$(objs).each(function() {
						var weiboType = this.get("weiboType");
						var isBind = this.get("isBind");
						var weiboShareId = this.get("weiboShareId");
						var buttonType;
						
							if (isBind == "false") {// 未绑定，显示绑定按钮
								buttonType = 0;
							} else {
								buttonType = 1;
							}
						var buttonHtml = share_getHtmlButton(weiboType,
								weiboShareId, buttonType);
						if (buttonHtml != "") {
							$("#" + weiboType).html(buttonHtml);
						}
					})
				} else {
					alert(ajaxObj.message);
				}
			});
}

/**
 * 显示相应按钮
 * 
 * @param {}
 *            weiboType
 * @param {}
 *            weiboShareId
 * @param {}
 *            buttonType 0 绑定按钮 1 取消绑定 2 分享按钮
 * @return {}
 */
function share_getHtmlButton(weiboType, weiboShareId, buttonType) {
	switch (buttonType) {
		case 0 :
			return tempBind = "<label class='new_button_label' style='color: #4f3505;padding-left:10px;'  onclick='share_popWeibo(\""
					+ weiboType + "\")' > 绑   定 </label>";// 绑定
		case 1 :
			return  "<label class='new_button_label' style='color: #4f3505;padding-left:10px;'   onclick='share_unbindAccount("
					+ weiboShareId + ",\"" + weiboType + "\")' >解除绑定</label>";; // 取消绑定
		default :
			return "";
	}
}

/**
 * 取消绑定账号
 * 
 * @param {}
 *            weiboShareId
 * @param {}
 *            weiboType
 */
function share_unbindAccount(weiboShareId, weiboType) {
	if (confirm("确定解除绑定？")) {
		var renrenParams = {
			cls : "Weibo_unbindAccount",
			weiboShareId : weiboShareId
		};
		new $sdmtv_ajax(renrenParams, function(ajaxObj) {
			if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
				alert("解除绑定成功");
				var buttonHtml = share_getHtmlButton(weiboType, weiboShareId, 0);
				if (buttonHtml != "") {
					$("#" + weiboType).html(buttonHtml);
				}
			} else {
				alert("解除绑定失败")
			}
		});
	}
}

/**
 * 调用原生接口
 * @param {} type
 */
function share_popWeibo(type) {
	var customerId = window.sessionStorage.getItem("customerId");	
	sdmtv.popWeibo(type,customerId,"","","","");
}

/**
 * addApp.html
 */

/**
 * site/home.html
 */
var siteHome_objs ;
//反馈结果
function siteHome_wapList(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		siteHome_objs = ajaxObj.objs;
		var tp = "";
		var cont = "<table style='width:100%;'><tr>";
		var begin = "<table style='width:100%;padding-left:3px;' cellpadding='0' cellspacing='0'><tr>";
		var end = "</tr></table><div class='site_btm'></div>";
		var space = "";
		var step = 1;
		var i = 0;
		var type;
		var type_;
		$(siteHome_objs).each(function () {
			var wapMenuId = this.get("wapMenuId");
			type = this.get("type");
			var typeName = this.get("typeName");
			var websitName = this.get("websitName");
			var websitUrl = this.get("websitUrl");
			var phoneSystem = this.get("phoneSystem");
			var websitType = this.get("websitType");
			var tempname = websitName;
			var link = "<td style='text-align:left;padding-left:8px;'>"+space+"<a href='javascript:void(0);' class='wap_cont_ext' onclick=\"sdmtv.popURL('" + websitUrl + "')\">" + tempname + "</a></td>";
			if (type != tp) {
				cont = cont + (tp==""?"":siteHome_getjt(type_)) + end  + (tp==""?"":siteHome_getlist(type_)) + begin + "<td width='50px' align='center' onclick=\"siteHome_chk('"+type+"')\"><span class='wap_cont'>" + typeName + "</span> | </td>" + link;
				tp = type;
				step = 1;
			} else {
				if(step <= 5)
					cont = cont + link;
			}
			step = step + 1;
			i = i + 1;
			type_ = type;
			if(i == siteHome_objs.length)
				cont = cont + siteHome_getjt(type) + end + siteHome_getlist(type) ;
		});
		$("#cont").html(cont);
	} else {
		handErrorMsg(ajaxObj.message);
	}
}

// 初始化
function siteHome_inIt(){
	var siteHome_param = {"cls":"WapMenu_list"};
	new $sdmtv_ajax(siteHome_param, siteHome_wapList);
}

function siteHome_getlist(id){
	var cnt="";
	var step = 0;
	var hh = 0;
	$(siteHome_objs).each(function () {
		var type = this.get("type");
		var websitName = this.get("websitName");
		var websitUrl = this.get("websitUrl");
		var space = "&nbsp;&nbsp;&nbsp;";
		if(id == type){
			step = step + 1;
			if(step > 5){
				hh = hh + 1;
				cnt = cnt + space + "<a href='javascript:void(0);' class='wap_cont_ext' onclick=\"sdmtv.popURL('" + websitUrl + "')\">" + websitName + " &nbsp;|</a>" + (hh%6==0?"<br/>":"");
			}
		}
	});
	return "<div id='d_"+id+"' style='display:none'><div class='list'>"+(cnt==""?"&nbsp;&nbsp;&nbsp;该分类下暂无更多网站信息":cnt)+"</div></div>";
}

function siteHome_getjt(id){
	return "<td width='30px' align='center' onclick=\"siteHome_chk('"+id+"')\"><img id='i_"+id+"' src='images/close.png' class='jt'></td>";
}

var siteHome_checkClick = 0;

function siteHome_chk(id){
	var nowTime = new Date().getTime();
	if(nowTime - siteHome_checkClick <= 500){
		siteHome_checkClick = new Date().getTime();  
		return;
	}
	siteHome_checkClick = new Date().getTime();
	if($("#d_"+id).css("display")=="none"){
		$("#d_"+id).css("display","block");
		$("#i_"+id).get(0).src = "images/open.png";
	}
	else{
		$("#d_"+id).css("display","none");
		$("#i_"+id).get(0).src = "images/close.png";
	}
}

/**
 * site/home.html
 */
/*
 * 公告详情页
 */
var noticeID = window.sessionStorage.getItem('Look_Notice_Id');
//获取公告详细信息
function Get_Notice_Con(ajaxObj) {
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		var noticeTitle = document.getElementById("title");
		var noticeTime = document.getElementById("time");
		var noticeContent = document.getElementById("ann_content");
		$(objs).each(function(){
			var noticeID = this.get("announcementId");
			var title  = this.get("title");
			noticeTitle.innerHTML=title;
			var createTime = this.get("createTime");
			noticeTime.innerHTML="发布时间："+createTime;
			var content = this.get("content");
			noticeContent.innerHTML=content;
			// 对公告内容中的图片进行处理  网络图片不处理
			$("#ann_content img").each(function() {
				var src = $(this).attr("src");
				$(this).removeAttr("style");
				$(this).removeAttr("height");
				$(this).removeAttr("width");
				$(this).css("max-width","320px");
				if (src!=undefined
						&& /\/uploadFile\/attached/.test(src)) {
					$(this).attr("src", sdmtv.IMG_BASEPATH + src);
				}
			});
			// 找出第一张图片  放于页面顶部中间位置
//			var firstImg = $("#ann_content img").attr("src");
//			if(firstImg==undefined){
//				$("#announcement_Img").hide();
//			}else {
//				document.getElementById("announcement_Img").src=firstImg;
//				$("#ann_content img").removeAttr("style");
//			};
			$("#ann_content").find("a").each(function() {
				// href跳转类型为电话或email时，不替换
				var type = $(this).attr("href").split(":")[0].toLowerCase();
				if (type == "http") {
					$(this).bind("click",function(){
						sdmtv.popURL(this.href);
						return false;
					});
				}else if(type == "tel"){
					$(this).bind("click",function(){
						sdmtv.phoneCall(this.href);
						return false;
					});
				} else{
					this.href = "javascript:void(0)";
				}
				$(this).css("color", "#f39c12");
			});
		})
	}else{
		handErrorMsg(ajaxObj.message);
	}
}

/**
 * microblog_List.html
 */
//所有第一视听内容列表
var microblogList_params = {
		"cls" : "Microblogging_list",
		"totalCount" : 0,
		"status" : "publish",
		"beginNum" : 0,
		"step" : 10,
		"sort" : "createTime",
		"dir" : "desc"
		};
//第一视听频道参数
var microblogList_paramsChannelList = {
					"cls" : "ProgramType_list",
					"parentCode" : "wbfl",
					
				};
function microblogList_inIt(){
	//获取第一视听内容列表
	microblogList_selectChanndl("", "");
	// 获取微博分类
	common_channelList(microblogList_paramsChannelList, $("#microblogList"), microblogList_selectChanndl);
}
/**
 * 点击分类查询
 * @param programTypeId
 * @param itemsName
 * @return
 */
function microblogList_selectChanndl(programTypeId,itemsName){
	microblogList_params.channelId = programTypeId;
	microblogList_params.totalCount = 0;
	microblogList_params.beginNum = 0;
	document.getElementById("microblogList_conList").innerHTML="";
	window.sessionStorage.setItem('microblogChannelId', programTypeId);
	new $sdmtv_ajax(microblogList_params, microblogList_callBackList);
	$("#microblogList_title").html(itemsName || "第一视听");
}
//循环获得结果
function microblogList_callBackList(ajaxObj) {
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		if(objs.length == 0){
			microblogList_noContent();
		} else {
			$(objs).each(function(){
				var microblogId = this.get("microblogId");
				var microblogName = this.get("microblogName");
				var microblogType = this.get("microblogType");
				var createTime = this.get("createTime");
				var microblogContent = common_htmlFlagFilter(this.get("microblogContent")).substring(0, 40);
				var flagImgBak = this.get("flagImgBak");
				var param = {
						"elementId" : "microblogList_conList",
						"type":"microblog",
						"mode":"modeDemand5",
						"middleContentTop":microblogName,
						"middleContent":microblogContent,
						"imgUrl":flagImgBak
				};
				var function_param = {
						"microblogId" :microblogId,
						"microblogName" :microblogName,
						"createTime":createTime
				};
				list_generateList(param,JumpToMicroblogDetails,function_param);
			})
		}
		// 判断是否显示加载更多按钮
		checkLoadMore(microblogList_params,microblogList_callBackList,"loadmore_microblogList");
		initTntAd();
	}
};
// 当前分类下没有内容
function microblogList_noContent(){
	$("#microblogList_conList").append("<div class='ListOrContent_nofound'>当前还没有内容</div>");
};

/**
 * 进入第一视听详情页
 * @param param
 * @param obj
 * @return
 */
function JumpToMicroblogDetails(param,obj){
	window.sessionStorage.setItem('microblogId', param.microblogId);
	window.sessionStorage.setItem('microblogName', param.microblogName);
	window.sessionStorage.setItem('microblogCreateTime',param.createTime);
	obj.href="microblog_Details.html";
}
/**
 * 微博列表返回按钮
 * @return
 */
function microblogList_gobackIndex(){
//	var isGoTuijain = window.sessionStorage.getItem("tuijianmore");
//	float_hideLayer("popDiv_microblogList",document.getElementById("selectPindao_microblogList"),2);
	history.back();
//	if(isGoTuijain!=null&&isGoTuijain=="1"){
//		menuGoTuijian();
//	}
}
/**
 * @param obj
 * @param condiv
 * @return
 */
//function microblogList_floatingOpen(obj,condiv){
//	float_popLayer('popDiv_microblogList',obj,'microblogList',microblogList_paramsChannelList,microblogList_floatBack,condiv,2);
//}
//function microblogList_floatBack(ajaxObj){
//	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
//		var objs = ajaxObj.objs;
//		var div  = float_creatHtml("microblogList_float","全部","全部","popDiv_microblogList","selectPindao_microblogList");
//		div.onclick = function() {
//			microblogList_selectChanndl("","第一视听");
//		}
//		$(objs).each(function(){
//			var programTypeId = this.get("programTypeId");
//			var itemsName= this.get("itemsName");
//			var div  = float_creatHtml("microblogList_float",itemsName,name,"popDiv_microblogList","selectPindao_microblogList");
//			div.onclick = function() {
//				microblogList_selectChanndl(programTypeId,itemsName);
//			}
//		})
//	}
//};


/**
 * microblog_List.html
 */

/**
 * microblog_Details.html begin
 */
//获取详情内容
var microblogDetails_param = {
		"cls" : "Microblogging_view"
}
//获取当前列表下的最新5条
var microblogDetails_lastFive = {
		"cls" : "Microblogging_lastList",
		"beginNum" : 0,
		"step" : 5,
		"channelId" :"",
		"sort" : "createTime",
		"dir" : "desc"
}
//查看是否有上一个和下一个微博内容
var microblogDetails_getNext = {
		"cls" : "Microblogging_viewNext",
		"beginNum" : 0,
		"step" : 1,
		"channelId" :"",
		"sort" : "createTime",
		"dir" : "desc"
}
//上一个和下一个内容
var microblogDetails_oldAndNext = {
		"oldId":"",
		"oldCreateTime":"",
		"nextId":"",
		"nextCreateTime":""
}
/**
 * 初始化第一视听详情页
 * @return
 */
function microblogDetails_inIt(){
	var microblogId = window.localStorage.getItem('microblogId');
	//var channelId = window.sessionStorage.getItem('microblogChannelId');
	microblogDetails_param.microblogId = microblogId;
	
	microblogDetails_lastFive.microblogId = microblogId;
	
	var createTime = window.localStorage.getItem('microblogCreateTime');
	microblogDetails_getNext.microblogId = microblogId;
	microblogDetails_getNext.createTime = createTime;
	
	//if(channelId!=null&&channelId!=""){
		//microblogDetails_lastFive.channelId = channelId;
		//microblogDetails_getNext.channelId = channelId;
	//}
	//初始化可以滑动
	if(window.isAndroid){
		microblog_slideInit();
	}
	//获取第一视听内容、获取5条最新微博内容
	new $sdmtv_ajax(microblogDetails_param, microblogDetails_callBackList);
}
//循环获得结果
function microblogDetails_callBackList(ajaxObj) {
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		var microblogType  = null;
		var microblogId = null;
		$(objs).each(function(){
			microblogId = this.get("microblogId");
			var microblogName = this.get("microblogName");
			microblogType = this.get("microblogType");
			var createTime = this.get("createTime");
			var microblogContent = this.get("microblogContent");
			var flagImgBak = this.get("flagImgBak");
			var itemsName = this.get("itemsName");
			microblogDetails_viewHtml(microblogId,microblogName,microblogType,createTime,microblogContent,flagImgBak);
			
			microblogDetails_lastFive.channelId = microblogType;
			microblogDetails_getNext.channelId = microblogType;
			
			microblogDetails_getNext.microblogId = microblogId;
			microblogDetails_getNext.createTime = createTime;
			new $multipleSdmtvAjax([microblogDetails_lastFive,microblogDetails_getNext], 
					[microblogDetails_callBackFive,microblogDetails_callBackIsNext]);
			
			//document.getElementById("microblogDetails_itemsName").innerHTML = itemsName;
			var last = document.getElementById("microblogDetails_last");
			last.innerHTML="<img src='../../images/micIconPreviousPageN.png'/>上一条";
			var old = document.getElementById("microblogDetails_next");
			old.innerHTML ="下一条<img src='../../images/micIconNextpageN.png'/>";
		})
		//添加观看记录
		var broadcastParams = {
				"cls" : "CustomerVisit_add",
				"visitType" : "microblog",
				"channelId" : microblogType,
				"visitValue":microblogId,
				
			};
		new $sdmtv_ajax(broadcastParams);
	}
};
/**
 * 添加页面内容
 * @return
 */
function microblogDetails_viewHtml(microblogId,microblogName,microblogType,createTime,microblogContent,flagImgBak){
	//添加标题
	document.getElementById("microblogDetails_Title").innerHTML = microblogName;
	//添加时间
	document.getElementById("microblogDetails_Time").innerHTML = createTime;
	//添加内容
	document.getElementById("microblogDetails_Content").innerHTML = microblogContent;
	//给内容中的图片加上前缀  网络图片不处理 
	$("#microblogDetails_Content img").each(function() {
		var src = $(this).attr("src");
		$(this).removeAttr("style");
		$(this).removeAttr("height");
		$(this).removeAttr("width");
		$(this).css("max-width","320px");
		if (src!=undefined && /\/uploadFile\/attached/.test(src)) {
			$(this).attr("src", sdmtv.IMG_BASEPATH + src);
		}
	});
	$("#microblogDetails_Content").find("a").bind("touchstart",function(){
		this.href="javascript:void(0)";
		sdmtv.popURL($(this).html());
	});
	//添加图片
	//document.getElementById("microblogDetails_Img").src = sdmtv.IMG_BASEPATH + flagImgBak;
}

/**
 * 获取最新5条记录
 * @param ajaxObj
 * @return
 */
function microblogDetails_callBackFive(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		//清楚速递相关的内容
		document.getElementById("microblogDetails_Ul").innerHTML="";;
		$(objs).each(function(){
			var microblogId = this.get("microblogId");
			var microblogName = this.get("microblogName");
			//转为html
			microblogDetails_five2Html(microblogId,microblogName);
		})
		document.body.scrollTop=0;
		common_iscrollTop();
	}
}

/**
 * 最新5条记录转为html
 * @param microblogId
 * @param microblogName
 * @return
 */
function microblogDetails_five2Html(microblogId,microblogName){
	var ul = document.getElementById("microblogDetails_Ul");
	ul.innerHTML =ul.innerHTML+ "<li>"
				  +"<table>"
				  +"<tr>"
				  +"<td align='left' class='microblogDetails_td'><img class='microblogDetails_Icon' src='../../images/microblogDetails_Icon.png'></td>"
				  +"<td nowrap class='microblogDetails_tdCon' onclick='microblogDetails_viewLast(\""+microblogId+"\");'>"+microblogName+"</td>"
				  +"<td align='right' class='microblogDetails_tdRight'><img class='microblogDetails_IconRight' src='../../images/microblogDetails_More.png'/></td>"
				  +"</tr>"
				  +"</table>"
				  +"</li>"
				  +"<div class='List_Cont_microblog_div'></div>"
}

function microblogDetails_viewLast(microblogId){
	microblogDetails_param.microblogId = microblogId;
	microblogDetails_lastFive.microblogId = microblogId;
	microblogDetails_lastFive.beginNum = 0;
	//获取第一视听内容、获取5条最新微博内容
	new $multipleSdmtvAjax([microblogDetails_param,microblogDetails_lastFive], 
			[microblogDetails_callBackList,microblogDetails_callBackFive]);
}

function microblogDetails_callBackIsNext(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$(objs).each(function(i){
			var microblogId = this.get("microblogId");
			var microblogName = this.get("microblogName");
			var createTime = this.get("createTime");
			if(i==0){
				microblogDetails_oldAndNext.nextId = microblogId;
				microblogDetails_oldAndNext.nextCreateTime = createTime;
			}else if(i==1){
				microblogDetails_oldAndNext.oldId = microblogId;
				microblogDetails_oldAndNext.oldCreateTime = createTime;
			}
		})
		//初始化上一个/下一个
		microblog_clickInit();
	}
}
function microblog_clickInit(){
	//下一条记录
	if(microblogDetails_oldAndNext.nextId!=""){
		var next = document.getElementById("microblogDetails_next");
		next.style.color="#cecece";
		next.querySelectorAll("img")[0].src='../../images/micIconNextpageL.png';
		next.onclick = function(){
			microblogDetails_right();
		}
	}else{
		var next = document.getElementById("microblogDetails_next");
		next.style.color="#717171";
		next.querySelectorAll("img")[0].src='../../images/micIconNextpageN.png';
		next.onclick = function(){
		}
	}
	
	//上一个
	if(microblogDetails_oldAndNext.oldId!=""){
		var last = document.getElementById("microblogDetails_last");
		last.style.color="#cecece";
		last.querySelectorAll("img")[0].src='../../images/micIconPreviousPageL.png';
		last.onclick = function(){
			microblogDetails_left();
		}
	}else{
		var last = document.getElementById("microblogDetails_last");
		last.style.color="#717171";
		last.querySelectorAll("img")[0].src='../../images/micIconPreviousPageN.png';
		last.onclick = function(){
		}
	}
	
}
/**
 * 返回微博列表
 * @return
 */
function goMicroblogList(){
	history.back();
}
var srartX = 0;
var endX = 0;
function microblog_slideInit(){
	
	$("#microblogDetails_con").wipetouch( {
		preventDefault: false,
		tapToClick : true, // if user taps the screen,
							// triggers a click
		// event
		wipeLeft : function(result) {
			var moveX = result.x;
			var moveY = result.y;
			//检查用户向左滑动角度是否小于30度
			var angle = Math.atan(moveY/moveX)/Math.PI*180;
			if(angle<30){
				if(result.x>60){
					microblogDetails_right();
				}
			}
		},
		wipeRight : function(result) {
			var moveX = result.x;
			var moveY = result.y;
			//检查用户向左滑动角度是否小于30度
			var angle = Math.atan(moveY/moveX)/Math.PI*180;
			if(angle<30){
				if(result.x>60){
					microblogDetails_left();
				}
			}
		},
		wipeUp : function(result) {
			return true;
		},
		wipeDown : function(result) {
			return true;
		}
	});
}

/**
 * 向右滑动
 * @return
 */
function microblogDetails_right() {
	//left
	if(microblogDetails_oldAndNext.nextId!=""){
		document.body.scrollTop=0;
		msgPopup.alertLoad(0);
		window.sessionStorage.setItem('microblogId',microblogDetails_oldAndNext.nextId);
		window.sessionStorage.setItem('microblogCreateTime',microblogDetails_oldAndNext.nextCreateTime);

		var channelId = window.sessionStorage.getItem('microblogChannelId');
		microblogDetails_param.microblogId = microblogDetails_oldAndNext.nextId;
		microblogDetails_lastFive.microblogId = microblogDetails_oldAndNext.nextId;
		microblogDetails_getNext.microblogId = microblogDetails_oldAndNext.nextId;
		microblogDetails_getNext.createTime = microblogDetails_oldAndNext.nextCreateTime;
		if(channelId!=null&&channelId!=""){
			microblogDetails_lastFive.channelId = channelId;
			microblogDetails_getNext.channelId = channelId;
		}
		//获取第一视听内容、获取5条最新微博内容
		new $multipleSdmtvAjax([microblogDetails_param,microblogDetails_lastFive,microblogDetails_getNext], 
				[microblogDetails_callBackList,microblogDetails_callBackFive,microblogDetails_callBackIsNext]);
	}else{
		alert("当前为末条");
	}
}

/**
 * 向左滑动
 * @return
 */
function microblogDetails_left() {
	//right
	if(microblogDetails_oldAndNext.oldId!=""){
		document.body.scrollTop=0;
		msgPopup.alertLoad(0);
		window.sessionStorage.setItem('microblogId',microblogDetails_oldAndNext.oldId);
		window.sessionStorage.setItem('microblogCreateTime',microblogDetails_oldAndNext.oldCreateTime);
		
		var channelId = window.sessionStorage.getItem('microblogChannelId');
		microblogDetails_param.microblogId = microblogDetails_oldAndNext.oldId;
		microblogDetails_lastFive.microblogId = microblogDetails_oldAndNext.oldId;
		microblogDetails_getNext.microblogId = microblogDetails_oldAndNext.oldId;
		microblogDetails_getNext.createTime = microblogDetails_oldAndNext.oldCreateTime;
		if(channelId!=null&&channelId!=""){
			microblogDetails_lastFive.channelId = channelId;
			microblogDetails_getNext.channelId = channelId;
		}
		//获取第一视听内容、获取5条最新微博内容
		new $multipleSdmtvAjax([microblogDetails_param,microblogDetails_lastFive,microblogDetails_getNext], 
				[microblogDetails_callBackList,microblogDetails_callBackFive,microblogDetails_callBackIsNext]);
	}else{
		alert("当前为首条");
	}
}

//分享跳转页面
function go_share_microblog(){
	var microblogId = window.localStorage.getItem('microblogId');
	window.sessionStorage.setItem("share_programId",microblogId);
	window.sessionStorage.setItem("share_programType","microblog");
	window.sessionStorage.setItem("programName",document.getElementById("microblogDetails_Title").innerText);
	common_shareProgram();
}
/**
 * microblog_Details.html end
 */
/**
 * bdDemand_Details.html begin
 */
var bdDemandDetails_param = {
		"cls":"Audio_view",
		"audioId":""
}
var bdDemandDetails_programParam = {
		"cls":"Audio_programList",
		"sonType":"",
		"programType":"audio",
		"totalCount" : 0,
		"beginNum" : 0,
		"step" : 10,
		"sort" : "playTime",
		"dir" : "desc"
}
var bdDemandDetails_monthProgramParam = {
		"cls":"Audio_queryDetailListByTime",
		"sonType":"",
		"status":"publish",
		"programType":"audio",
		"demandPeriod":"",
		"sort" : "playTime",
		"dir" : "desc"
}
var bdDemandDetails_timeList={
		"cls":"Audio_timeList",
		"programId":"",
		"sort" : "playTime",
		"dir" : "desc"
}
var bdDemandDetails_isShowByMounth = 0;
var bdDemandDetails_timeArray = null;
function bdDemandDetails_inIn(){
	/*//栏目的ID
	var CTPId_bdDemand = window.sessionStorage.getItem('CTPId_bdDemand');
	//栏目名称
	var CTPIdName_bdDemand = window.sessionStorage.getItem('CTPIdName_bdDemand');*/
	//节目的id
	var programId = window.sessionStorage.getItem("programId");
	bdDemandDetails_param.audioId = programId;
	
	bdDemandDetails_programParam.beginNum = 0;
	
	new $sdmtv_ajax(bdDemandDetails_param, bdDemandDetails_callBackList);
	/*new $multipleSdmtvAjax([bdDemandDetails_param,bdDemandDetails_programParam], 
			[bdDemandDetails_callBackList,bdDemandDetails_callBackProgramList]);*/
}

/**
 * 查询内容返回
 * @param ajaxObj
 * @return
 */
function bdDemandDetails_callBackList(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		bdDemandDetails_timeArray = new Array();
		$(objs).each(function(){
			var audioId = this.get("audioId");
			var audioName = this.get("audioName");
			var audioImg = this.get("audioImg");
			var audioUrl = this.get("audioUrl");
			var audioLong = this.get("audioLong");
			var createTime = this.get("createTime");
			var playTime = this.get("playTime");
			var customerCollectionId = this.get("customerCollectionId");
			var belongType = this.get("belongType");
			var belongTypeString = this.get('belongTypeString');
			var sonType = this.get("sonType");
			var sonTypeString = this.get("sonTypeString");
			var isMounth = this.get("isMounth");
			bdDemandDetails_setTitle(sonTypeString);//设置标题
			//详情页面转html
			bdDemandDetails_view2Html(audioId,audioName,audioImg,audioUrl,audioLong,createTime,customerCollectionId,playTime,belongType,sonType);
			//是否按月份分组
			if(isMounth==1){
				//获取往期节目月份列表
				bdDemandDetails_timeList.programId = sonType;
				new $sdmtv_ajax(bdDemandDetails_timeList, bdDemandDetails_timeListCallBack);
				//加载往期节目
				bdDemandDetails_monthProgramParam.sonType = sonType;
			}else{
				bdDemandDetails_programParam.sonType = sonType;
				bdDemandDetails_programParam.totalCount = 0;
				new $sdmtv_ajax(bdDemandDetails_programParam, bdDemandDetails_callBackProgramList);
			}
		})
	}
}
function CheckCollection_bdDemandDetails(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$(objs).each(function() {
			var audioId = this.get("audioId");
			var customerCollectionId = this.get("customerCollectionId");
			var CollectedText = document.getElementById("bdDemand_isskull");
			collectionReset(CollectedText, "audio", audioId, customerCollectionId);
				})
	}
}
/**
 * 详情页转化为html
 * @param audioId
 * @param audioName
 * @param audioImg
 * @param audioUrl
 * @param audioLong
 * @param createTime
 * @param customerCollectionId
 * @return
 */
function bdDemandDetails_view2Html(audioId,audioName,audioImg,audioUrl,audioLong,createTime,customerCollectionId,playTime,belongType,sonType){
	//设置图片
	document.getElementById("bdDemandDetailsImg").src=sdmtv.IMG_BASEPATH + audioImg;
	//设置名称
	document.getElementById("bdDemandDetailsName").innerText = audioName;
	//设置收藏信息
	var CollectedText = document.getElementById("bdDemand_isskull");
	collectionReset(CollectedText, "audio", audioId, customerCollectionId);
	//设置更新时间
	document.getElementById("bdDemandDetailsTime").innerText = "更新时间："+playTime;
	//设置播放按钮 
	var playButton = document.getElementById("bdDemandDetails_playbutton");
	playButton.onclick = function() {
		if (chk_to_page()) {
				// 节目播放
				var broadcast_param = {
						"type" :"audio",
						"id" :audioId,
						"name" :audioName,
						"m3u8" :audioUrl,
						"rtsp" :audioUrl,
						"channel":belongType,
						"program":sonType,
						"customerCollectionId" :customerCollectionId
				};
				broadcast_unifiedPlayer(broadcast_param);
			}
	}
}

/**
 * 获取所有月份列表
 * @param ajaxObj
 * @return
 */
function bdDemandDetails_timeListCallBack(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		var totalCount = ajaxObj.params.totalCount;
		$(objs).each(function(){
			var playTime = this.get("playTime");
			bdDemandDetails_timeArray.push(playTime);
		})
		bdDemandDetails_showMonthList();
	}
}

/**
 * 获取月份列表内容
 * @return
 */
function bdDemandDetails_showMonthList(){
	if(bdDemandDetails_timeArray.length>0){
		bdDemandDetails_monthProgramParam.demandPeriod = bdDemandDetails_timeArray[0];
		new $sdmtv_ajax(bdDemandDetails_monthProgramParam, bdDemandDetails_callBackProgramListMounth);
		bdDemandDetails_timeArray.shift();
	}
	console.log(bdDemandDetails_timeArray);
	if(bdDemandDetails_timeArray.length>0){
		var moreDiv = document.getElementById("bdDemandDetails_loadMore");
		moreDiv.innerHTML="<div href='javascript:void(0)' class='load_more_button'>加载更多</div>";
		moreDiv.firstChild.onclick = function() {
			bdDemandDetails_showMonthList();
		}
	}else{
		var moreDiv = document.getElementById("bdDemandDetails_loadMore");
		moreDiv.innerHTML="";
	}
}

/**
 * 节目列表返回 非按月份分组
 * @param ajaxObj
 * @return
 */
function bdDemandDetails_callBackProgramList(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$(objs).each(function(i){
			var audioId = this.get("audioId");
			var audioName = this.get("audioName");
			var belongType = this.get("belongType"); //所属频道ID
			var sonType = this.get("sonType"); //所属栏目的ID
			var audioUrl = this.get("audioUrl");
			var createTime = this.get("createTime");
			var playTime = this.get("playTime");
			var sonTypeString = this.get("sonTypeString"); //所属栏目的名称
			bdDemandDetails_isShowByMounth = this.get("isMounth");//展示类型是否为月份1是，0否
			var customerCollectionId = this.get("customerCollectionId");
			var mounth = this.get("mounth"); //所属月份
			
			bdDemandDetails_program2Html(audioId,audioName,belongType,sonType,audioUrl,
					createTime,playTime,sonTypeString,customerCollectionId,mounth);
		})
		// 判断是否显示加载更多按钮
		checkLoadMore(bdDemandDetails_programParam,bdDemandDetails_callBackProgramList,"bdDemandDetails_loadMore");
	}
}
/**
 * 节目列表返回 按月份分组
 * @param ajaxObj
 * @return
 */
function bdDemandDetails_callBackProgramListMounth(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		var totalCount = ajaxObj.params.totalCount;
		$(objs).each(function(i){
			var audioId = this.get("audioId");
			var audioName = this.get("audioName");
			var belongType = this.get("belongType"); //所属频道ID
			var sonType = this.get("sonType"); //所属栏目的ID
			var audioUrl = this.get("audioUrl");
			var createTime = this.get("createTime");
			var playTime = this.get("playTime");
			var sonTypeString = this.get("sonTypeString"); //所属栏目的名称
			bdDemandDetails_isShowByMounth = this.get("isMounth");//展示类型是否为月份1是，0否
			var customerCollectionId = this.get("customerCollectionId");
			var mounth = this.get("mounth"); //所属月份
			bdDemandDetails_program2Html(audioId,audioName,belongType,sonType,audioUrl,
					createTime,playTime,sonTypeString,customerCollectionId,mounth);
		})
		$("#bdDemandDetails_pList").trigger("create");// 重新渲染页面
	}
}



/**
 * 节目列表HTML化
 * @param audioId
 * @param audioName
 * @param belongType
 * @param sonType
 * @param audioUrl
 * @param createTime
 * @param playTime
 * @param sonTypeString
 * @param customerCollectionId
 * @return
 */
function bdDemandDetails_program2Html(audioId,audioName,belongType,sonType,audioUrl,
		createTime,playTime,sonTypeString,customerCollectionId,mounth){
	var paramId = window.sessionStorage.getItem("programId");//详情页节目的ID
	var div = document.getElementById("bdDemandDetails_pList");
	playTime = playTime.substring(5);
	var con = null;
	if(bdDemandDetails_isShowByMounth==1&&document.getElementById('bdDemandDetails_'+mounth)==null){
		con = div.innerHTML + "<div id='bdDemandDetails_"+mounth+"' style='margin: auto;' onclick='bdDemandDetails_fold(\""+mounth+"\",this);'> " +
			  "<table id='titletable+"+mounth+"' class='bdDemandDetails_mounth'>" +
			  "<tr>" +
			  "<td class='bdDemandDetails_mounthTd'>"+mounth+"</td>" +
			  "<td class='bdDemandDetails_mounthImg'><img id='img+"+mounth+"' src='../../images/videoIconOpen.png'></td>" +
			  "</tr>" +
			  "</table>" +
			  "</div>";
		div.innerHTML = con;
	}
	if(document.getElementById(mounth)==null){
		var con1 = "<div id="+mounth+" class='bdDemandDetails_pListCon'>" +
				   "<table class='table"+mounth+"'>";
		var con2 = "<tr onclick='bdDemandDetails_clickOne(\""+audioId+"\",\""+sonType+"\",\""+sonTypeString+"\",\""+customerCollectionId+"\",\""+audioName+"\",\""+audioUrl+"\",this,\""+belongType+"\")'>" +
				   "<td nowrap class='bdDemandDetails_ConTd1'>"+audioName+"</td>" +
				   "<td class='bdDemandDetails_ConTd'>"+playTime+"</td>" +
				   "</tr>";
		var con3 = "<tr onclick='bdDemandDetails_clickOne(\""+audioId+"\",\""+sonType+"\",\""+sonTypeString+"\",\""+customerCollectionId+"\",\""+audioName+"\",\""+audioUrl+"\",this,\""+belongType+"\")'>" +
				   "<td nowrap class='bdDemandDetails_ConTd3'>"+audioName+"</td>" +
				   "<td class='bdDemandDetails_ConTd2'>"+playTime+"</td>" +
				   "</tr>";
		var con4 = "</table>" +
					"</div>"
		if(paramId==audioId){
			con = div.innerHTML+con1+con3+con4;
		}else{
			con = div.innerHTML+con1+con2+con4;
		}
		div.innerHTML = con;
	}else if(document.getElementById(mounth)!=null){
		var divs = document.getElementById(mounth);
		var Table = divs.firstChild.firstChild;
		var con5 = "<tr onclick='bdDemandDetails_clickOne(\""+audioId+"\",\""+sonType+"\",\""+sonTypeString+"\",\""+customerCollectionId+"\",\""+audioName+"\",\""+audioUrl+"\",this,\""+belongType+"\")'>" +
					"<td nowrap class='bdDemandDetails_ConTd1'>"+audioName+"</td>" +
					"<td class='bdDemandDetails_ConTd' >"+playTime+"</td>" +
					"</tr>"
		var con6 = "<tr onclick='bdDemandDetails_clickOne(\""+audioId+"\",\""+sonType+"\",\""+sonTypeString+"\",\""+customerCollectionId+"\",\""+audioName+"\",\""+audioUrl+"\",this,\""+belongType+"\")'>" +
					"<td nowrap class='bdDemandDetails_ConTd3'>"+audioName+"</td>" +
					"<td class='bdDemandDetails_ConTd2'>"+playTime+"</td>" +
				   "</tr>";
		if(paramId==audioId){
			Table.innerHTML = Table.innerHTML+con6;
		}else{
			Table.innerHTML = Table.innerHTML+con5;
		}
	}
	if(bdDemandDetails_isShowByMounth==1){
		bdDemandDetails_foldArrayOpen(mounth);
	}
}
//分享
function bdDemandDetails_share(){
	var programId = window.sessionStorage.getItem("programId");
	window.sessionStorage.setItem("share_programId",programId);
	window.sessionStorage.setItem("share_programType","audio");
	window.sessionStorage.setItem("programName",document.getElementById("bdDemandDetailsName").innerText);
	common_shareProgram();
}
/**
 * 设置标题
 * @param titleName
 * @return
 */
function bdDemandDetails_setTitle(titleName){
	document.getElementById("bdDemandDetails_title").innerHTML = titleName;
}

/**
 * 返回广播点播列表
 * @param obj
 * @return
 */
function bdDemandDetails_gohistory(){
	history.back();
}


/**
 * 将数组中的内容全部打开
 * @return
 */
function bdDemandDetails_foldArrayOpen(mounth){
	//打开从加载的所有月份
	var divmounth = document.getElementById(""+mounth+"");
	divmounth.style.display = "block";
	var img = document.getElementById("img+"+mounth+"");
	img.src = "../../images/videoIconOpen.png";
	var titletable = document.getElementById("titletable+"+mounth+"")
	titletable.style.background = 'url(../../images/videoProgramBgOpen.png)';
}
/**
 * 关闭折叠层
 * @param mounth
 * @return
 */
function bdDemandDetails_fold(mounth,obj){
	var div = document.getElementById(""+mounth+"");
	if(div.style.display=='block'){
		div.style.display = "none";
		var img = document.getElementById("img+"+mounth+"");
		img.src = "../../images/videoIconClose.png";
		var titletable = document.getElementById("titletable+"+mounth+"")
		titletable.style.background = 'url(../../images/videoProgramBgClose.png)';
	}else if(div.style.display=="none"){
		var div = document.getElementById(""+mounth+"");
		div.style.display = "block";
		var img = document.getElementById("img+"+mounth+"");
		img.src = "../../images/videoIconOpen.png";
		var titletable = document.getElementById("titletable+"+mounth+"")
		titletable.style.background = 'url(../../images/videoProgramBgOpen.png)';
	}
}


/**
 * 选择某一个
 * @param audioId
 * @param sonType
 * @param sonTypeString
 * @param customerCollectionId
 * @param audioName
 * @param audioUrl
 * @return
 */
function bdDemandDetails_clickOne(audioId,sonType,sonTypeString,customerCollectionId,audioName,audioUrl,obj,belongType){
	//取消上一个高亮
	var oldtd1 = document.getElementById("bdDemandDetails_pList").querySelectorAll(".bdDemandDetails_ConTd3")[0];
	var oldtd2 = document.getElementById("bdDemandDetails_pList").querySelectorAll(".bdDemandDetails_ConTd2")[0];
	oldtd1.className = "bdDemandDetails_ConTd1";
	oldtd2.className = "bdDemandDetails_ConTd";
	//设置新点击的高亮
	var td = obj.getElementsByTagName("td");
	td[0].className = "bdDemandDetails_ConTd3";
	td[1].className = "bdDemandDetails_ConTd2";
	window.sessionStorage.setItem('CTPId_bdDemand',sonType);
	window.sessionStorage.setItem('CTPIdName_bdDemand',sonTypeString);
	window.sessionStorage.setItem("programId",audioId);
	bdDemandDetails_param.audioId = audioId;
	new $sdmtv_ajax(bdDemandDetails_param, bdDemandDetails_callBackListOne);
	if (chk_to_page()) {
		// 节目播放
		var broadcast_param = {
				"type" :"audio",
				"id" :audioId,
				"name" :audioName,
				"m3u8" :audioUrl,
				"rtsp" :audioUrl,
				"channel":belongType,
				"program":sonType,
				"customerCollectionId" :customerCollectionId
		};
		broadcast_unifiedPlayer(broadcast_param);
	}
}
/**
 * 查询内容返回
 * @param ajaxObj
 * @return
 */
function bdDemandDetails_callBackListOne(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$(objs).each(function(){
			var audioId = this.get("audioId");
			var audioName = this.get("audioName");
			var audioImg = this.get("audioImg");
			var audioUrl = this.get("audioUrl");
			var audioLong = this.get("audioLong");
			var createTime = this.get("createTime");
			var playTime = this.get("playTime");
			var customerCollectionId = this.get("customerCollectionId");
			var belongType = this.get("belongType");
			var belongTypeString = this.get('belongTypeString');
			var sonType = this.get("sonType");
			var sonTypeString = this.get("sonTypeString");
			bdDemandDetails_setTitle(sonTypeString);//设置标题
			
			//详情页面转html
			bdDemandDetails_view2Html(audioId,audioName,audioImg,audioUrl,audioLong,createTime,customerCollectionId,playTime);
		})
	}
}
/**
 * bdDemand_Details.html end
 */

//四期添加内容 开始


/**
 * gameApp_List.html begin
 */
var gameAppList_paramshotgame = {
		"cls" : "App_hotList02",
		"appType" : 1,
		"status": "publish",
		"totalCount" : 0,
		"beginNum":0,
		"step":10,
		"os_type":(isIDevice?"ios":"android")
	};
var gameAppList_paramshotapp = {
		"cls" : "App_hotList02",
		"appType" : 0,
		"status": "publish",
		"totalCount" : 0,
		"beginNum":0,
		"step":10,
		"os_type":(isIDevice?"ios":"android")
	};
var gameAppList_params = {
		"appType" : 1,
		"os_type":(isIDevice?"ios":"android")
};
function gameAppList_inIt(){
	addGameAppListTab();
	gameAppList_params.appType = 1;
	gameAppList_paramshotgame.beginNum =0;
	gameAppList_paramshotgame.totalCount = 0;
	new $sdmtv_ajax(gameAppList_paramshotgame,gameAppListCallBack);
}
//加载标签
function addGameAppListTab(){
	var tab = "<div class='tab' style='width: 94%;'>"+"<div id='gameApp_gameTag' class='tag_down'  style='width:48.5%;border: black solid 1px;padding-left:4px;' " +
				"onclick='javascript:tvDemandDetails_tag(0);changeGameAppList(\"hotGame_gameAppList\");'>热门游戏</div>"+
			  "<div  id='gameApp_appTag' class='tag_up' style='width:48.5%;border: black solid 1px;' onclick='javascript:tvDemandDetails_tag(1);" +
			  "changeGameAppList(\"hotApp_gameAppList\");' >热门应用</div>"+
			  "</div>";
	$("#gameAppListTab").html(tab);
}
function hotGameList_noContent(){
	$("#hotGame_gameAppList").html("<div class='ListOrContent_nofound'>当前还没有内容</div>");
};
function hotAppList_noContent(){
	$("#hotApp_gameAppList").html("<div class='ListOrContent_nofound'>当前还没有内容</div>");
};
function gameAppListCallBack(ajaxObj){
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		var totalCount = ajaxObj.params.totalCount;
		if(gameAppList_params.appType==1){
			gameAppList_paramshotgame.totalCount = totalCount;
		}else if(gameAppList_params.appType ==0){
			gameAppList_paramshotapp.totalCount = totalCount;
		}
		if(totalCount==0){
			if(gameAppList_params.appType==1){
				hotGameList_noContent();
			}else if(gameAppList_params.appType ==0){
				hotAppList_noContent();
			}
		}else{
			$(objs).each(function() {
				var appId = this.get("appId");
				var appImage = this.get("appImage");
				var appUrl = this.get("appUrl");
				var appSize = this.get("appSize");
				var appPrice = this.get("appPrice");
				if(appPrice == 0 ){
					appPrice = "免费 ";
				}
				var sortId = this.get("sortId");
				var appName = this.get("appName");
					var param = {
						"elementId" : "hotGame_gameAppList_Con",
						"type":"game",
						"mode":"game",
						"middleContentTop":appName,
						"middleContent":appSize+"M<span style='margin-left: 16px'>"+appPrice+"</span>",
						"imgUrl":appImage
					};
					if(gameAppList_params.appType==1){
						param.elementId = "hotGame_gameAppList_Con";
					}else if(gameAppList_params.appType ==0){
						param.elementId = "hotApp_gameAppList_Con";
					}
					var function_param = {
							"appName" :appName,
							"appUrl":appUrl,
							"appId":appId,
							"appSize" :appSize
					};
					list_generateList(param,gameAppList_download,function_param,gameAppList_download,function_param);
			});
			// 判断是否显示加载更多按钮
			if(gameAppList_params.appType==1){
				checkLoadMore(gameAppList_paramshotgame,gameAppListCallBack,"loadmore_hotGame_gameAppList");
			}else if(gameAppList_params.appType ==0){
				checkLoadMore(gameAppList_paramshotapp,gameAppListCallBack,"loadmore_hotApp_gameAppList");
			}
			
		}
	} else {
		handErrorMsg(ajaxObj.message);
	}
}

//书签效果
function changeGameAppList(nameId) {
	var name = nameId;
	if (name == "hotGame_gameAppList") {
		document.getElementById("hotGame_gameAppList").style.display = "block";
		document.getElementById("hotApp_gameAppList").style.display = "none";
		var count = document.getElementById("hotGame_gameAppList").querySelectorAll(".ListOrContent_nofound");
		if(count.length>0){
			gameAppList_params.appType = 1;
			new $sdmtv_ajax(gameAppList_paramshotgame,gameAppListCallBack);
		}
	} else if (name == "hotApp_gameAppList") {
		document.getElementById("hotGame_gameAppList").style.display = "none";
		document.getElementById("hotApp_gameAppList").style.display = "block";
		var count = document.getElementById("hotApp_gameAppList").querySelectorAll(".ListOrContent_nofound");
		// count == 0 暂时没有内容
		if(count.length>0){
			gameAppList_params.appType = 0;
			new $sdmtv_ajax(gameAppList_paramshotapp,gameAppListCallBack);
		}else{
			gameAppList_params.appType = 0;
			$("#hotApp_gameAppList_Con").html("");
			gameAppList_paramshotapp.beginNum = 0;
			gameAppList_paramshotapp.totalCount = 0;
			new $sdmtv_ajax(gameAppList_paramshotapp,gameAppListCallBack);
		}
	}
}

// 返回主页 
function gameApp_backToIndex(){
//	gameAppList_paramshotapp.beginNum = 0;
//	gameAppList_paramshotapp.totalCount = 0;
	history.back();
}

/**
 * gameApp_List.html end
 */
//四期添加内容 结束


/**
 * 客户端返回按键 begin
 */
function click2Return(){
	var page = $.mobile.activePage;
	if(page[0].id=="tvLiveList"){//电视直播列表页返回
		goback();
		OtherPageBackGetAppList();
	}else if(page[0].id == "tvLiveDetalis"){//电视直播详情页返回
		gohistory();
	}else if(page[0].id == "tvDemand_List"){//电视点播列表页
		gobacktvDemand();
		OtherPageBackGetAppList();
	}else if(page[0].id == "tvDemand_PartList"){//电视点播2级列表
		tvDemandPartListHistory();
	}else if(page[0].id == "tvDemand_Details"){ //电视点播详情页
		gohistory();
	}else if(page[0].id == "bdLiveList"){ //广播直播列表页 
		gobackbdLive();
		OtherPageBackGetAppList();
	}else if(page[0].id == "bdLiveDetalis"){ //广播直播详情页
		gohistory();
	}else if(page[0].id == "bdDemand_List"){ //广播点播列表页
		gobackbdDemand();
		OtherPageBackGetAppList();
	}else if(page[0].id == "bdDemandDetails"){ //广播点播详情页
		bdDemandDetails_gohistory();
	}else if(page[0].id == "addApp"){//添加应用页面
		history.back();
		OtherPageBackGetAppList();
	}else if(page[0].id == "searchResult"){ //所有结果页
		searchResult_backToSearch();
	}else if(page[0].id == "more_home"){ //更多页面
		htmlCallBackExit.exit();
	}else if(page[0].id == "recommendPage"){ //推荐页面
		htmlCallBackExit.exit();
	}else if(page[0].id == "indexPage"){  //首页
		htmlCallBackExit.exit();
	}else if(page[0].id == "search"){ //搜索页面
		htmlCallBackExit.exit();
	}else if(page[0].id == "grgl_home"){//弹出登录框
		htmlCallBackExit.exit();
	}else if(page[0].id == "login_page"){
		$('.ui-dialog').dialog('close');
		reductionBottomMenu();
	}else if(page[0].id == "microblogDetalis"){ //第一视听详情页
		goMicroblogList();
	}else if(page[0].id == "microblogList"){	//第一视听列表页
		microblogList_gobackIndex();
	}else if(page[0].id == "subjectListPage"){ //专题列表主页
		gobackSubject();
	}else if(page[0].id == "bookMainList"){
		book_goBackBook();
	}else if(window.sessionStorage.getItem("isInBookReader")=="true"){
		if (typeof bookReader_quit == "function") {
			bookReader_quit();
		} else {
			history.back();
		}
	}else{
		history.back();
	}
}
/**
 * 客户端返回按键 end
 */

function control_bottomMenu(type,client){
	window.sessionStorage.setItem("fristlogin","0");
	resetTabbarItemHelper.push(type);
	switch (type) {
	case 1:
		$.mobile.changePage("../../jsp/recommend/recommend.html");
		break;
	case 2:
		$.mobile.changePage("../../jsp/search/search.html");
		break;
	case 3:
		$.mobile.changePage("../../jsp/index/index.html");
		break;
	case 4:
		window.sessionStorage.setItem("fristlogin","1");
		if (chk_to_page("../../jsp/grgl/home.html")) {
			window.sessionStorage.setItem("fristlogin","0");
			$.mobile.changePage("../../jsp/grgl/home.html");
		}
		break;
	case 5:
		$.mobile.changePage("../../jsp/more/home.html");
		break;
	case 6:
		$.mobile.changePage("../../jsp/error/netError.html");
		break;
	default:
		break;
	}
}
/**
 * 原生导航调用
 * @param index
 * @return
 */
function iphone_changePage(index){
	window.sessionStorage.setItem("fristlogin","0");
	resetTabbarItemHelper.push(index);
	if(index==1){
		$.mobile.changePage("../recommend/recommend.html");
	}else if(index==2){
		$.mobile.changePage("../../jsp/search/search.html");
	}else if(index==3){
		$.mobile.changePage("../../jsp/index/index.html");
	}else if(index==4){
		window.sessionStorage.setItem("fristlogin","1");
		if (chk_to_page("../../jsp/grgl/home.html")) {
			window.sessionStorage.setItem("fristlogin","0");
			$.mobile.changePage("../../jsp/grgl/home.html");
		}
	}else if(index==5){
		$.mobile.changePage("../../jsp/more/home.html");
	}else if (index==6){
        $.mobile.changePage("../../jsp/error/netError.html");
    }
}


/**
 * 初始化广告
 * @return
 */
function initTntAd(){
	// 页面的广告标签标志为div标签并且title属性为advertisment
	var pageName =  $.mobile.activePage;
	var advertisments = pageName[0].querySelectorAll("tntAd");
	// 获取id
	var advParamsArray = new Array();
	var advCallBackArray = new Array();
	var advCallBackParamArray = new Array();
	$.each(advertisments,function(i,advDiv){
		var paramAdv = {
			"cls" : "Advertisement_listById",
			"positions" : advDiv.id,
		};
		advParamsArray.push(paramAdv);
		advCallBackArray.push(adv_callBack);
		advCallBackParamArray.push(advDiv.id);
	});
	if(advParamsArray.length > 0){
		new $multipleSdmtvAjax(advParamsArray, advCallBackArray,advCallBackParamArray);
	}
}

/**
 * 广告的回调函数
 * @param {} ajaxObj 结果集对象
 * @param {} advId 广告标签的id
 */
function adv_callBack(ajaxObj,advId){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var ads = ajaxObj.objs;
		if(ads.length == 0){// 隐藏广告位
		}else if(ads.length == 1){
			// 单幅广告
			$(ads).each(function(){
				var	height = this.get("height");
				var	showTypeLimit = this.get("showTypeLimit");
				var adveUrl = this.get("adveUrl");
				var targetUrl = this.get("targetUrl");
				var targetType = this.get("targetType");
				var advName = this.get("advName");
				var positions = this.get("positions");
				var carouselAdv = this.get("carouselAdv");
				var width = this.get("width");
				var advertisementId = this.get("advertisementId");
				document.getElementById(advId).innerHTML = "<img width='100%' height='"+height+"' style='margin-top: 5px;' src='"+sdmtv.IMG_BASEPATH+targetUrl+"' onclick='goUrl(\""+adveUrl+"\",\""+targetType+"\",\""+advertisementId+"\",\""+positions+"\")'/>";
			})
		}else if(ads.length >1){
			// 多幅广告
			var height = 0 ;
			var showTypeLimit = 2;
			var box =new PPTBox();
			box.width = document.body.clientWidth; //宽度
			$(ads).each(function(i){
				if(i==0){
					height = this.get("height");
					showTypeLimit = this.get("showTypeLimit");
				}
				var adveUrl = this.get("adveUrl");
				var targetUrl = this.get("targetUrl");
				var targetType = this.get("targetType");
				var advName = this.get("advName");
				var positions = this.get("positions");
				var carouselAdv = this.get("carouselAdv");
				var width = this.get("width");
				var advertisementId = this.get("advertisementId");
				box.add({"url":sdmtv.IMG_BASEPATH+targetUrl,"href":"javascript:goUrl(\""+adveUrl+"\",\""+targetType+"\",\""+advertisementId+"\",\""+positions+"\")","title":"标题1"});
			})
		     var pageName =  $.mobile.activePage;
		     box.height = height;//高度
		     box.autoplayer = showTypeLimit;//自动播放间隔时间
			 box.posId = advId;//位置ID
			 box.page = pageName[0];
		     box.show();
		     
		  // 设置广告滑动事件
			 	$("#"+advId).wipetouch({
			 				tapToClick : false, // if user taps the screen, triggers a
			 				// click
			 				// event
			 				wipeLeft : function(result) {
			 					var e = document.createEvent('MouseEvent');
			 					e.initEvent('click', false, false);
			 					box._play();
			 				},
			 				wipeRight : function(result) {
			 					var e = document.createEvent('MouseEvent');
			 					e.initEvent('click', false, false);
			 					box._back();
			 				}
			 			});
		}
	}
}

/**
 * 客户端提示进入详情页 begin
 * @return
 */
function prompt2Details(type,id,subType,name){
	var promptA = document.getElementById("prompt2Details");
	//积分操作增加
	var programId = "";
	if(type=="liveVideo"){
		window.sessionStorage.setItem('liveVideoId',id);
		programId = window.sessionStorage.getItem('liveVideoId');
		$.mobile.changePage("../tvLive/tvLive_Details.html");
	}else if(type=="liveAudio"){
		window.sessionStorage.setItem('liveAudio',id);
		programId = window.sessionStorage.getItem('liveAudio');
		$.mobile.changePage("../bdLive/bdLive_Details.html");
	}else if(type=="video"){
		//window.sessionStorage.setItem('CTPIdName');
		window.sessionStorage.setItem('tvDemand_videoId',id);
		
		programId = window.sessionStorage.getItem('tvDemand_videoId');
		$.mobile.changePage("../tvDemand/tvDemand_Details.html");
	}else if(type=="audio"){
		//window.sessionStorage.setItem('CTPId_bdDemand');
		//window.sessionStorage.setItem('CTPIdName_bdDemand');
		window.sessionStorage.setItem("programId",id);
		
		programId = window.sessionStorage.getItem('programId');
		$.mobile.changePage("../bdDemand/bdDemand_Details.html");
	}else if(type=="microblog"){
		window.sessionStorage.setItem('microblogCreateTime');
		window.sessionStorage.setItem('microblogChannelId');
		
		programId = window.sessionStorage.getItem('microblogChannelId');
		$.mobile.changePage("../microblog/microblog_Details.html");
	}else if(type == "book"){
		window.sessionStorage.setItem('bookId',id);
		
		programId = window.sessionStorage.getItem('bookId',id);
		$.mobile.changePage("../book/bookContent.html");
	}else if(type == "subject"){
		window.sessionStorage.setItem('subjectId',id);
		window.sessionStorage.setItem('subjectType',subType);
		window.sessionStorage.setItem('subjectName',name);
		
		programId = window.sessionStorage.getItem('subjectId');
		$.mobile.changePage("../subject/subjectDetail.html");
	}
	
	//积分操作
	var param = {
			"cls" : "Integral_order",
			"programId" : programId
		};
	new $sdmtv_ajax(param, function(ajaxObj) {
			if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
				alert(ajaxObj.message);
			}
		});
}
/**
 * 客户端提示进入详情页 end
 * @return
 */

playerRefresh = function(){
	var page = $.mobile.activePage;
	if(page[0].id == "grgl_view"){
		new RecentView("view_List_Con", "clearRecentView").refresh();
	}
}

//四期添加的内容 开始
/**
 * netVideo_List.html begin
 */
//所有频道参数
var netVideoList_paramsChannelList = {
	"cls" : "ProgramType_list",
	"parentCode" : "netVideo",
	
};
//所有栏目内容列表
var netVideoList_paramsPartList = {
	"cls" : "Video_list",
	"contentType" : "netVideo",
	"program" : "",
	"totalCount" : 0,
	"beginNum" : 0,
	"step" : 10,
	"sort" : "playTime",
	"dir" : "desc"
};
function netVideoList_inIt(){
	// 查询全部网络视频
	selectChanndl_netVideo("", "");
	// 网络视频分类列表
	common_channelList(netVideoList_paramsChannelList, $("#netVideoList"), selectChanndl_netVideo);
}
//选择某个频道
function selectChanndl_netVideo(id,name){
	var divlist = document.getElementById("netVideo_List_Con");
	divlist.innerHTML="";
	netVideoList_paramsPartList.program=id;
	netVideoList_paramsPartList.beginNum = 0;
	netVideoList_paramsPartList.totalCount = 0;
	new $sdmtv_ajax(netVideoList_paramsPartList, netVideo_PartList);
	var titleName = document.getElementById("netVideo_classListTitle");
	titleName.innerHTML=name||"网络视频";
}
//获得所有栏目列表函数
function netVideo_PartList(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		//如果totalCount查询结果为0,隐藏掉加载更多按钮
		if(objs.length == 0){
			hideLoadMore("netVideo_classLoadmore");
			netVideoList_noContent();
		}else{
			$(objs).each(function(){
				var program = this.get("program");
				var programName= this.get("programName");
				var videoImg = this.get("videoImg");
				var videoName = this.get("videoName");
				var videoUrl  = this.get("videoUrl");
				var playTime = this.get("playTime");
				var videoId = this.get("videoId");//最新节目的ID
				var channel = this.get("channel");
				customerCollectionId = this.get("customerCollectionId");
				var param = {
						"elementId" : "netVideo_List_Con",
						"type":"tvDemand",
						"mode":"modeDemand3",
						"middleContentTop":videoName,
						"middleContent":"更新时间："+playTime,
						"imgUrl":videoImg
				};
				var function_param = {
						"CTPId" :program,
						"CTPIdName":programName,
						"programId":videoId
				};
				var broadcast_param = {
						"type" :"netVideo",
						"id" :videoId,
						"name" :videoName,
						"m3u8" :videoUrl,
						"rtsp" :videoUrl,
						"customerCollectionId" :customerCollectionId,
						"channel" :channel,
						"program" :program
				};
				list_generateList(param,netVideoCallBack,function_param,broadcast_unifiedPlayer,broadcast_param);
			})
			// 判断是否显示加载更多按钮
			checkLoadMore(netVideoList_paramsPartList,netVideo_PartList,"netVideo_classLoadmore");
			//添加广告
			initTntAd();
		}
	}else{
		handErrorMsg(ajaxObj.message);
	}
};
//列表回调函数
function netVideoCallBack(param){
	window.sessionStorage.setItem('CTPId_netVideo',param.CTPId_netVideo);
	window.sessionStorage.setItem('CTPIdName_netVideo',param.CTPIdName_netVideo);
	window.sessionStorage.setItem("programId",param.programId);
	
	$.mobile.changePage("../../jsp/netVideo/netVideo_Details.html");
}

function netVideoList_noContent(){
	$("#netVideo_List_Con").append("<div class='ListOrContent_nofound'>当前还没有内容</div>");
};

function netVideoGoback(){
//	var isGoTuijain = window.sessionStorage.getItem("tuijianmore");
	netVideoList_paramsPartList.totalCount=0;
	netVideoList_paramsPartList.beginNum=0;
//	float_hideLayer("netVideo_classListDiv",document.getElementById("netVideo_classListImg"),3);
	history.back();
//	if(isGoTuijain!=null&&isGoTuijain=="1"){
//		menuGoTuijian();
//	}
}
////打开右上角分类选择
//function netVideo_openPop(obj,condiv){
//	float_popLayer('netVideo_classListDiv',obj,'netVideoList',netVideoList_paramsChannelList,netVideoList_floatBack,condiv,2);
//}
////弹出层回调
//function netVideoList_floatBack(ajaxObj){
//	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
//		var objs = ajaxObj.objs;
//		var name = document.getElementById("netVideo_classListTitle").innerText;
//		if(name=="网络视频"){
//			var div  = float_creatHtml("netVideo_classList","全部","全部","netVideo_classListDiv","netVideo_classListImg");
//			div.onclick = function() {
//				//点击某个分类后调用函数
//				selectChanndl_netVideo("all","网络视频");
//			}
//		}else{
//			var div  = float_creatHtml("netVideo_classList","全部",null,"netVideo_classListDiv","netVideo_classListImg");
//			div.onclick = function() {
//				//点击某个分类后调用函数
//				selectChanndl_netVideo("all","网络视频");
//			}
//		}
//		$(objs).each(function(){
//			var programTypeId = this.get("programTypeId");
//			var itemsName= this.get("itemsName");
//			var div  = float_creatHtml("netVideo_classList",itemsName,name,"netVideo_classListDiv","netVideo_classListImg");
//			div.onclick = function() {
//				//点击某个分类后调用函数
//				selectChanndl_netVideo(programTypeId,itemsName);
//			}
//		})
//	}
//}


/**
 * netVideo_List.html end
 */

/**
 * netVideo_Details.html begin
 */
//节目名称
var programName_netVideo = null;
// 查询详细内容参数
var netVideoDetails_params = {
	"cls" : "Video_view",
	"videoId" : ""
};
// 获取用户点评信息的  点评参数
var netVideoDetails_pammDianpin = {
	"cls" : "Commit_list",
	"totalCount" : 0,
	"programId" : "",
	"programType" : "netVideo",
	"beginNum" : 0,
	"step" : 10,
	"sort" : "createTime",
	"dir" : "desc",
	
};
// 往期节目参数
var netVideoDetails_pammLast = {
	"cls" : "Video_thePeriodList",
	"videoId" : "",
	"totalCount" : 0,
	"beginNum" : 0,
	"step" : 10,
	"sort" : "playTime",
	"dir" : "desc"
};
//页面加载方法
function netVideoDetails_inIt(){
	var netVideoDetails_videoId = window.sessionStorage.getItem("programId");
	netVideoDetails_params.videoId = netVideoDetails_videoId;
	netVideoDetails_pammDianpin.programId = netVideoDetails_videoId;
	netVideoDetails_pammLast.videoId = netVideoDetails_videoId;
	
	addNetVideoDetailsTop();
	addNetVideoDetailsTab();
	new $sdmtv_ajax(netVideoDetails_params,netVideo_Details_view);
	// 加载往期节目
	new $sdmtv_ajax(netVideoDetails_pammLast, netVideo_Details_last);
}

//获得所有栏目列表函数
function netVideo_Details_view(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		$(objs).each(
			function() {
				var videoId = this.get("videoId");
				var videoName = this.get("videoName");
				var videoImg = this.get("videoImg");
				var videoUrl = this.get("videoUrl");
				var videoLong = this.get("videoLong");
				var playtime = this.get("playTime");
				var channel = this.get("channel");
				var program = this.get("program");
				var customerCollectionId = this.get("customerCollectionId");
				var channelName = this.get("channelName");
				var programName = this.get("programName");
				netVideoDetails_setTitle(programName); //设置标题
				netVideoDetailsviewToHtml(videoId, videoName, videoImg, videoUrl,
						videoLong, playtime, customerCollectionId,channel,channelName,program,programName);
			})		
	} else {
		handErrorMsg(ajaxObj.message);
	}
}

//详细内容转为HTML
function netVideoDetailsviewToHtml(videoId, videoName, videoImg, videoUrl, videoLong,
		playtime, customerCollectionId,channel,channelName,program,programName) {
	window.sessionStorage.setItem("netVideoBackId",videoId);
	document.getElementById("netVideoDetailsImg").src = sdmtv.IMG_BASEPATH + videoImg;
	var name = videoName;
	if(videoName.length>20){
		name = videoName.substring(0,18)+"..";
	}
	
	var programtemp = programName;
	if(programName.length>7){
		programtemp = programName.substring(0,5)+"..";
	}
	
	//document.getElementById("netVideo_Details_title").innerHTML = programtemp;
	document.getElementById("netVideoDetailsName").innerHTML = name;
	document.getElementById("netVideoDetailsTime").innerHTML = "更新时间：" + playtime;

	var CollectedText = document.getElementById("netVideo_DetailsSkull");
	collectionReset(CollectedText, "netVideo", videoId, customerCollectionId);
	var playButton = document.getElementById("netVideo_Details_playbutton");
	playButton.onclick = function() {
		if (chk_to_page()) {
		        var getCustomerCollectionId = window.localStorage.getItem("cusCollId");
			    if((""==getCustomerCollectionId) || (null==getCustomerCollectionId)){
			    }else{
			    	customerCollectionId = getCustomerCollectionId;
			    }
				// 节目播放
				var broadcast_param = {
					"type" :"netVideo",
					"id" :videoId,
					"name" :videoName,
					"m3u8" :videoUrl,
					"rtsp" :videoUrl,
					"customerCollectionId" :customerCollectionId,
					"channel" :channel,
					"program" :program
				};
				if (window.localStorage.getItem('cusCollId') != null) {
					broadcast_param.customerCollectionId = window.localStorage.getItem('cusCollId');;
				} else if(window.localStorage.getItem('cusCollId') == null){
					broadcast_param.customerCollectionId = customerCollectionId;
				}
				broadcast_unifiedPlayer(broadcast_param);
			}
	}
}
//加载内容头部
function addNetVideoDetailsTop(){
	var top = "<tr><td width='132px' align='left' style='vertical-align: top;'>"+
		  "<div align='center' style='vertical-align: middle;margin: 12px 20px 12px 20px;width:92px;height:62px;background-image: url(../tvLive/images/livebg.png)'>"+
		  "<img id='netVideoDetailsImg'   height='57px' width='87px' style='margin-top:2px;margin-left:-1px' />"+
		  "</div></td>"+"<td align='left' style='vertical-align: top; font-weight: bold;'>"+
		  "<table width='100%' border='0' cellpadding='0' cellspacing='0' style='margin: 12px 10px 12px 0;'>"+
		  "<tr><td style='font-size: 16px;color: #ffffff;font-family: 黑体'><div style='height:33px;width:180px;'><span id='netVideoDetailsName' style='color: #ffffff;'></span></div></td>"+
		  "</tr><tr>"+
		  "<td style='font-size: 13px;;color: #ffffff;font-family: 黑体;padding-top: 13px;'><span id='netVideoDetailsTime'></span></td>"+
		  "</tr></table></td></tr>";
	
	$("#topnetVideodetails").html(top);
}
//加载标签
function addNetVideoDetailsTab(){
	var tab = "<div class='tab' style='width: 94%;'>"+"<div class='tag_down'  style='width:48.5%;border: black solid 1px;padding-left:4px;' onclick='javascript:tvDemandDetails_tag(0);changeNetVideo(\"tvNotice_netVideo\");'>最近更新</div>"+
			  "<div class='tag_up' style='width:48.5%;border: black solid 1px;' onclick='javascript:tvDemandDetails_tag(1);changeNetVideo(\"tvDianpin_netVideo_wa\");' >网友点评</div>"+
			  "</div>";
	$("#netVideodetailstab").html(tab);
}
//书签效果  在加载标签addNetVideoDetailsTab()中用到了
function changeNetVideo(nameId) {
	var name = nameId;
	if (name == "tvNotice_netVideo") {
		document.getElementById("tvNotice_netVideo").style.display = "block";
		document.getElementById("tvDianpin_netVideo_wa").style.display = "none";
	} else if (name == "tvDianpin_netVideo_wa") {
		document.getElementById("tvNotice_netVideo").style.display = "none";
		document.getElementById("tvDianpin_netVideo_wa").style.display = "block";
		// 加载用户点评
		netVideoDetails_pammDianpin.programId = window.sessionStorage.getItem("programId");;
		var ul = document.getElementById("tvDianpin_netVideo");
		ul.innerHTML = "";
		new $sdmtv_ajax(netVideoDetails_pammDianpin, netVideo_DetailsCommentCont_dianping);
	}
}

//最近更新回调函数
function netVideo_Details_last(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		var ul = document.getElementById("tvDianpin_netVideo_last");
		ul.innerHTML="";
		var i=0;
		var netVideoDetails_videoId = window.sessionStorage.getItem("programId");
		if(objs.length==0){
			$("#tvDianpin_netVideo_last").html("<div class='ListOrContent_nofound'>暂无最近更新</div>");
		}else{
			$(objs).each(function() {
				var videoId = this.get("videoId");
				var videoName = this.get("videoName");
				var playTime = this.get("playTime");
				playTime = playTime.substring(5);
				var videoUrl = this.get("videoUrl");
				var channel=this.get("channel");
				var program=this.get("program");
				var customerCollectionId = this.get("customerCollectionId");
				if(i<=10&&videoId!=netVideoDetails_videoId){
					netVideo_Details_lastToHtml(videoId, videoName,playTime, videoUrl, customerCollectionId,channel,program);
				}
				i++;
			})
		}
	} else {
		handErrorMsg(ajaxObj.message);
	}
}
//最近更新转为HTML
function netVideo_Details_lastToHtml(videoId, videoName, playTime, videoUrl,
		customerCollectionId,channel,program) {
	
	var ul = document.getElementById("tvDianpin_netVideo_last");
	var table = document.createElement("table");
	table.className = "tvDianpin_tvDemandCont_last";
	var name = videoName;
	table.innerHTML = "<tr>" + "<td nowrap='nowrap' style='overflow:hidden; text-overflow: ellipsis;' align='left'>"
			+ name + "</td>" +"<td width='80px' align='right' style='font-size:12px'>" + playTime + "</td>" +  "</tr>";
	var div  = document.createElement("div");
	div.className = "List_Cont_recommend_div";
	ul.appendChild(table);
	$(table).click(function() {
		netVideoGoToLastOne(videoId, videoName, playTime, videoUrl,customerCollectionId,channel,program,this);
	});
	ul.appendChild(div);
}
//查看最近更新   点击最近更新中的节目
function netVideoGoToLastOne(videoId, videoName, playTime, videoUrl,customerCollectionId,channel,program,obj){
    //记录播放视频ID
    window.sessionStorage.setItem("netVideoBackId",videoId);
    //更改颜色
    var oldtd1 = document.getElementById("tvDianpin_netVideo_last").querySelectorAll(".tvDianpin_tvDemandCont_last_yellow")[0];
	if(null==oldtd1){
	}else{
		oldtd1.className = "tvDianpin_tvDemandCont_last";
	}
	//设置新点击的高亮
	obj.className = "tvDianpin_tvDemandCont_last_yellow";
	
	//更换题目信息
	//netVideoDetailsviewToHtml(videoId, videoName, videoImg, videoUrl, 
    	//videoLong,playtime, customerCollectionId,channel,channelName,program,programName);	
	//netVideoDetailsviewToHtml(videoId, videoName, "", videoUrl, 
		//"", playtime, customerCollectionId,channel,"",program,""); 
	netVideoDetails_params.videoId = videoId;
	new $sdmtv_ajax(netVideoDetails_params,netVideo_Details_view); 
 	
 	var broadcast_params = {
		"type" :"netVideo",
		"id" :videoId,
		"name" :videoName,
		"m3u8" :videoUrl,
		"rtsp" :videoUrl,
		"customerCollectionId" :customerCollectionId,
		"channel" :channel,
		"program" :program
	};
	broadcast_unifiedPlayer(broadcast_params);
}

//点击页面上“网友点评”  获得网友点评
function netVideo_DetailsCommentCont_dianping(ajaxObj) {
	if (ajaxObj.code == ajaxObj.constants.SUCCESS) {
		var objs = ajaxObj.objs;
		if(objs.length==0){
			reviewsNoComment("tvDianpin_netVideo");
		}else{
			$(objs).each(
				function() {
					var customerCommitId = this.get("customerCommitId");
					var customerName = this.get("customerName");
					var gradeName = this.get("gradeName");
					var createTime = this.get("createTime");
					var content = this.get("content");
					var sex = this.get("sex");
					var customerId = this.get("customerId");
					// 生成点评内容
					reviewsCompositionHTML({
						elementId : "tvDianpin_netVideo",
						customerName : customerName,
						gradeName:gradeName,
						createTime : createTime,
						content : content,
						sex: sex,
						clickParam : customerId
					});
				});
			// 绑定单击事件
			$("#tvDianpin_netVideo").on("click", "a[data-clickParam]", function() {
				var cId = $(this).attr("data-clickParam");
				if (cId == window.sessionStorage.getItem("customerId")) {
					window.sessionStorage.setItem("taCustomerId", -100);// 个人中心左上角图标改为返回按钮
					$.mobile.changePage("../../jsp/grgl/home.html");
				} else {
					window.sessionStorage.setItem("taCustomerId", cId);
					$.mobile.changePage("../../jsp/grgl/mainPage.html");
				}
			});
			// 判断是否显示加载更多按钮
			checkLoadMore(netVideoDetails_pammDianpin,
				netVideo_DetailsCommentCont_dianping,
				"loadmore_netVideo_Details_dianping");
		}
	} else {
		handErrorMsg(ajaxObj.message);
	}
}

// 用户点击 点评图标
function netVideo_Details_dianping(obj){
	var netVideoDetails_netVideoId = window.sessionStorage.getItem("programId");
	window.sessionStorage.setItem("reviewProgramId",netVideoDetails_netVideoId);
	window.sessionStorage.setItem("reviewProgramType","netVideo");
	obj.href = '../../../local/jsp/common/review.html';
}

// 用户点击 分享图标
function go_share_netVideo(){
	var netVideoDetails_netVideoId = window.sessionStorage.getItem("programId");
	window.sessionStorage.setItem("share_programId",netVideoDetails_netVideoId);
	window.sessionStorage.setItem("share_programType","netVideo");
	window.sessionStorage.setItem("programName",document.getElementById("netVideoDetailsName").innerText);
	common_shareProgram();
}

// 设置标题
function netVideoDetails_setTitle(titleName){
	document.getElementById("netVideoDetails_title").innerHTML = titleName;
}

// 返回网络视频列表
function netVideoDetails_gohistory(){
	history.back();
}
/**
 * netVideo_Details.html end
 */
 
//.............音乐列表页 开始.......................
/*
 * function gobackMusic()
 * 该方法用于音乐列表页(music_List.html)"返回"按钮使用
 * 相较于三期的返回按钮，其没有调用float_hideLayer()方法
 */
function gobackMusic(){
//	var isGoTuijain = window.sessionStorage.getItem("tuijianmore");
	musicList_paramsPartList.totalCount=0;
	musicList_paramsPartList.beginNum=0;
	history.back();
//	if(isGoTuijain!=null&&isGoTuijain=="1"){
//		menuGoTuijian();
//	}
}

//音乐页 获取所有栏目内容列表
var musicList_paramsPartList = {
	"cls" : "ProgramType_musicList02",
	"parentCode" : "music",
	"totalCount" : 0,
	"beginNum" : 0,
	"step" : 10,
	"sort" : "updateTime",
	"dir" : "desc"
};

/*
 * function musicList_inIt()
 * 该方法用于音乐列表页(music_List.html)获取音乐数据
 */
function musicList_inIt(){
	musicList_paramsPartList.channelId = ""
	new $sdmtv_ajax(musicList_paramsPartList, music_PartList);
}

/*
 * function music_PartList(ajaxObj)
 * 该方法用于音乐列表页(music_List.html)获取音乐数据请求返回后的回调函数
 */
function music_PartList(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		//如果totalCount查询结果为0,隐藏掉加载更多按钮
		if(objs.length == 0){
			hideLoadMore("loadmore_music_List");
			music_noContent();
		}else{
			$(objs).each(function(){
				var programTypeId = this.get("programTypeId");
				var itemsName= this.get("itemsName");
				var description = this.get("description");
				var flagImg = this.get("flagImg");
				var updateTime = this.get("playTime");
				var customerCollectionId = this.get("customerCollectionId");
				
				var param = {
						"elementId" : "partList_music",
						"type":"microblog",
						"mode":"modeDemand2",
						"middleContentTop":itemsName,
						"middleContent":description,
						"middleContentBottom":"更新时间："+updateTime,
						"imgUrl":flagImg
				};
				var function_param = {
						"CTPId_music" :programTypeId
						//"CTPIdName_music":itemsName,
						//"CTPIdTime_music":updateTime,
						//"CTPIdImg_music":flagImg,
						//"CTPIdDes_music":description,
						//"CTPIdCollectionId_music":customerCollectionId
				};
				list_generateList(param,ChannelToPart_music,function_param);
			})
			// 判断是否显示加载更多按钮
			checkLoadMore(musicList_paramsPartList,music_PartList,"loadmore_music_List");
			window.sessionStorage.setItem("IsToChannldList_music","false");
			//添加广告
			initTntAd();
		}
	}else{
		handErrorMsg(ajaxObj.message);
	}
}

/*
 * function music_noContent()
 * 该方法用于音乐列表页(music_List.html)获取音乐数据为空时，显示提示信息
 */
function music_noContent(){
	$("#partList_music").append("<div class='ListOrContent_nofound'>当前还没有内容</div>");
}

/*
 * function ChannelToPart_music(param,obj)
 * 该方法用于音乐列表页(music_List.html)获取音乐数据后，进入详情页
 */
function ChannelToPart_music(param,obj){
    window.sessionStorage.setItem('CTPId_music',param.CTPId_music);
	obj.href='../music/music_Details.html';
}
//.............音乐列表页 结束.......................

//.............音乐详情页 开始.......................
//音乐详情信息数组  月份划分中用到
//var musicDetails_timeArray = null;

//音乐详情信息常量  月份划分中用到
//var musicDetails_isShowByMounth = 0;

//音乐详情页获取信息
var musicDetails_param = {
		"cls":"Audio_musicView12",
		"programTypeId":""
}

//音乐详情页获取信息使用
var musicDetails_programParam = {
		"cls":"Audio_programList",
		"sonType":"",
		"programType":"music",
		"totalCount" : 0,
		"beginNum" : 0,
		"step" : 10,
		"sort" : "playTime",
		"dir" : "desc"
}

/**
 * function musicDetails_gohistory()
 * 该方法用于音乐详情页(music_Details.html) 返回广播点播列表
 */
function musicDetails_gohistory(){
	history.back();
}

/*
 * function musicDetails_inIn()
 * 该方法用于音乐详情页(music_Details.html)获取数据使用
 * 相较于三期的返回按钮，其没有调用float_hideLayer()方法
 */
function musicDetails_inIn(){
	//栏目的ID
	var CTPId_music = window.sessionStorage.getItem("CTPId_music");
	//栏目名称
	//var CTPIdName_music = window.sessionStorage.getItem("CTPIdName_music");
	//更新时间
	//var CTPIdTime_music = window.sessionStorage.getItem("CTPIdTime_music");
	//专题图片
	//var CTPIdImg_music = window.sessionStorage.getItem("CTPIdImg_music");
	//备注信息  
	//var CTPIdDes_music = window.sessionStorage.getItem("CTPIdDes_music");
	//收藏ID
	//var CTPIdCollectionId_music = window.sessionStorage.getItem("CTPIdCollectionId_music");
	
	musicDetails_param.programTypeId = CTPId_music;
	musicDetails_programParam.beginNum = 0;
	
	//调用方法
	new $sdmtv_ajax(musicDetails_param, musicDetails_callBackList);
	/*new $multipleSdmtvAjax([musicDetails_param,musicDetails_programParam], 
			[musicDetails_callBackList,musicDetails_callBackProgramList]);*/
}

/**
 * function musicDetails_callBackList(ajaxObj)
 * 该方法用于音乐详情页(music_Details.html)获取具体信息数据
 */
function musicDetails_callBackList(ajaxObj){

	//栏目的ID
	var CTPId_music = window.sessionStorage.getItem("CTPId_music");
	//栏目名称
	//var CTPIdName_music = window.sessionStorage.getItem("CTPIdName_music");
	//更新时间
	//var CTPIdTime_music = window.sessionStorage.getItem("CTPIdTime_music");
	//专题图片
	//var CTPIdImg_music = window.sessionStorage.getItem("CTPIdImg_music");
	//备注信息  
	//var CTPIdDes_music = window.sessionStorage.getItem("CTPIdDes_music");
	//收藏ID
	//var CTPIdCollectionId_music = window.sessionStorage.getItem("CTPIdCollectionId_music");
	
	//音乐ID
	var audioId = "";
	//栏目名称
	var sonTypeString = "";
	//更新时间
	var playTime = "";
	//专题图片
	var audioImg = "";
	//备注信息  
	var description = "";
	//音乐名称
	var audioName = "";
	//收藏ID
	var customerCollectionId = "";
	//音乐地址
	var audioUrl = ""; 
	//专题的Id 相当于programTypeId 
	var sonType = "";  

	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		//musicDetails_timeArray = new Array();
		
		$(objs).each(function(){
			audioId = this.get("audioId");  //音乐Id
			audioName = this.get("audioName");  //音乐名称
			audioUrl = this.get("audioUrl");  //音乐地址
			sonType = this.get("sonType");  //专题的Id 相当于programTypeId
			
			sonTypeString = this.get("sonTypeString");  //专题名称相当于itemsName
			customerCollectionId = this.get("customerCollectionId");  //专题收藏Id
			audioImg = this.get("audioImg");  //专题图片
			description = this.get("description");  //专题简介
			playTime = this.get("playTime");  //专题中最后一个音乐的更新时间
			
			//详情页面转html
			//musicDetails_view2Html_playButton(audioId,audioName,audioUrl,customerCollectionId,belongType,sonType);
			//musicDetails_view2Html_playButton(audioId,audioName,audioUrl,customerCollectionId,"",sonType);
		})
		window.sessionStorage.setItem("musicBackImg",audioImg);
		//设置专题信息	
		musicDetails_view2Html_items(playTime,CTPId_music,sonTypeString,audioImg,
			audioName,customerCollectionId,audioId,audioUrl,sonType);
		//设置标题
		musicDetails_setTitle(sonTypeString);
			
		//无月份的划分 获取歌曲列表
		musicDetails_programParam.sonType = CTPId_music;
		musicDetails_programParam.totalCount = 0;
		new $sdmtv_ajax(musicDetails_programParam, musicDetails_callBackProgramList);
	}
}

/**
 * function musicDetails_setTitle(titleName)
 * 该方法用于音乐详情页(music_Details.html) 设置标题 
 */
function musicDetails_setTitle(titleName){
	document.getElementById("musicDetails_title").innerHTML = titleName;
}

/**
 * musicDetails_view2Html_items(...)
 * 该方法用于音乐详情页(music_Details.html) 详情页转化为html 专题部分 
 */
function musicDetails_view2Html_items(CTPIdTime_music,CTPId_music,CTPIdName_music,
		CTPIdImg_music,audioName,CTPIdCollectionId_music,audioId,audioUrl,sonType){

    //节目信息
	window.sessionStorage.setItem("musicBackProgramId",audioId);
	window.sessionStorage.setItem("musicBackAudioName",audioName);
	window.sessionStorage.setItem("musicBackSonType",sonType);
	window.sessionStorage.setItem("musicBackAudioUrl",audioUrl);
	window.sessionStorage.setItem("musicBackSonTypeString",CTPIdName_music);
	window.sessionStorage.setItem("musicBackContentType","");
	
	//设置图片
	document.getElementById("musicDetailsImg").src=sdmtv.IMG_BASEPATH + CTPIdImg_music;
	//设置名称
	if(audioName.length>20){
		audioName = audioName.substr(0,18)+"...";
	}
	document.getElementById("musicDetailsName").innerText = audioName;
	//设置收藏信息
	var CollectedText = document.getElementById("music_isskull");
	collectionReset(CollectedText, "music", audioId, CTPIdCollectionId_music);
	//设置更新时间
	document.getElementById("musicDetailsTime").innerText = "更新时间："+CTPIdTime_music;	
	
	//设置播放按钮 
	var playButton = document.getElementById("musicDetails_playbutton");
	playButton.onclick = function() {
	    var getCustomerCollectionId = window.localStorage.getItem("cusCollId");
	    if((""==getCustomerCollectionId) || (null==getCustomerCollectionId)){
	    }else{
	    	customerCollectionId = getCustomerCollectionId;
	    }
	    
		if (chk_to_page()) {
			// 节目播放
			var broadcast_param = {
					"type" :"music",
					"id" :audioId,
					"name" :audioName,
					"m3u8" :audioUrl,
					"rtsp" :audioUrl,
					"channel":"",
					"program":sonType,
					"customerCollectionId" :customerCollectionId
			};
			broadcast_unifiedPlayer(broadcast_param);
		}
	}	
}

/**
 * function musicDetails_callBackProgramList(ajaxObj)
 * 该方法用于音乐详情页(music_Details.html) 节目列表返回 非按月份分组
 */ 
function musicDetails_callBackProgramList(ajaxObj){
	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;

		if(objs.length==0){
			$("#musicDetails_pList").html("<div class='ListOrContent_nofound'>暂无歌曲列表</div>");
		}else{
			$(objs).each(function(i){
				var audioId = this.get("audioId");
				var audioName = this.get("audioName");
				var audioUrl = this.get("audioUrl");
				var singer = this.get("singer");
				
				var customerCollectionId = this.get("customerCollectionId"); //歌曲收藏ID
				var sonTypeString = this.get("sonTypeString"); //所属栏目名称
				var sonType = this.get("sonType"); //所属栏目的ID
				var contentType = this.get("contentType"); //所属类型
				
				//生成列表
				//musicDetails_program2Html(audioId,audioName,belongType,sonType,audioUrl,customerCollectionId,singer);
				musicDetails_program2Html(audioId,audioName,"",sonType,audioUrl,customerCollectionId,singer,sonTypeString,contentType);
			})
		}
		
		//让第一个成为黄色
		var ul = document.getElementById("musicDetails_pList");	
		var table = ul.firstChild;
		var tr = table.firstChild;
		var td = tr.childNodes;
		var td0 = td[0];
		td0.className = "music_musicCont_tr_yellow";
		
		// 判断是否显示加载更多按钮 
		checkLoadMore(musicDetails_programParam,musicDetails_callBackProgramList,"musicDetails_loadMore");
	}
}

/**
 * function musicDetails_program2Html(...)
 * 该方法用于音乐详情页(music_Details.html) 节目列表HTML化
 */
function musicDetails_program2Html(audioId,audioName,belongType,sonType,audioUrl,customerCollectionId,
singer,sonTypeString,contentType){
	var ul = document.getElementById("musicDetails_pList");	
	var table = document.createElement("table");
	table.className = "music_musicCont_last";
	
	if((""==singer) || (null==singer)){
		singer = "--";
	}	

    // 显示列表的内容                 
    table.innerHTML = "<tr onclick='musicDetails_clickOne(\""+audioId+"\",\""+sonType+"\",\""+customerCollectionId+"\",\""+audioName+"\",\""+audioUrl+"\",this,\""+belongType+"\",\""+sonTypeString+"\",\""+contentType+"\")'>"
		            	+ "<td nowrap='nowrap' style='overflow:hidden; text-overflow: ellipsis;' align='left'>" + audioName + "</td>" 
		            	+ "<td width='40px' align='right' style='font-size:12px;' >" + singer + "</td>" 
		            + "</tr>";
    
    // 增加一个图片
    var div  = document.createElement("div");
	div.className = "List_Cont_recommend_div";
	
	// 将增加的列表 和 图片 放到已有的标签中
	ul.appendChild(table);
	ul.appendChild(div);
}

/**
 * function musicDetails_clickOne(...)
 * 该方法用于音乐详情页(music_Details.html) 选择某一个  播放的同时 显示点击的音乐 信息
 */
function musicDetails_clickOne(audioId,sonType,customerCollectionId,audioName,audioUrl,obj,belongType,sonTypeString,contentType){

	//更改标题，调用接口获得点播音乐信息 取消上一个高亮
	var oldtd1 = document.getElementById("musicDetails_pList").querySelectorAll(".music_musicCont_tr_yellow")[0];
	oldtd1.className = "music_musicCont_tr";
	//设置新点击的高亮
	obj.className = "music_musicCont_tr_yellow";
	//设置专题信息	 节目的id
	window.sessionStorage.setItem("musicBackProgramId",audioId);
	window.sessionStorage.setItem("musicBackAudioName",audioName);
	window.sessionStorage.setItem("musicBackSonType",sonType);
	window.sessionStorage.setItem("musicBackAudioUrl",audioUrl);
	window.sessionStorage.setItem("musicBackSonTypeString",sonTypeString);
	window.sessionStorage.setItem("musicBackContentType",contentType);
	
	//musicDetails_view2Html_items("",sonType,sonTypeString,"",
		//audioName,customerCollectionId,audioId,audioUrl,sonType);
	//设置标题
	//musicDetails_setTitle(sonTypeString);
	var musicBack_param = {
		"cls":"Audio_view",
		"audioId":""
	}
	//节目的id
	musicBack_param.audioId = audioId;
	new $sdmtv_ajax(musicBack_param, musicBack_param_function);

	//调用播放器
    var broadcast_param = {
		"type" :"music",
		"id" :audioId,
		"name" :audioName,
		"m3u8" :audioUrl,
		"rtsp" :audioUrl,
		"channel":belongType,
		"program":sonType,
		"customerCollectionId" :customerCollectionId
	};
	broadcast_unifiedPlayer(broadcast_param);
}

/**
 * musicDetails_share()
 * 该方法用于音乐详情页(music_Details.html) 用于分享
 */
function musicDetails_share(){
	var programId = window.sessionStorage.getItem("CTPId_music");
	window.sessionStorage.setItem("share_programId",programId);
	window.sessionStorage.setItem("share_programType","music");
	window.sessionStorage.setItem("programName",document.getElementById("musicDetailsName").innerText);
	common_shareProgram();
}

/**
 * musicBack_param_function()
 * 该方法用于音乐详情页(music_Details.html) 点击播放后查询详情页显示
 */
function musicBack_param_function(ajaxObj){

		var audioId = "";
		var audioName = "";
		var audioImg = "";
		var audioUrl = "";
		var audioLong = "";
		var createTime = "";
		var playTime = "";
		var customerCollectionId = "";
		var belongType = "";
		var belongTypeString = "";
		var sonType = "";
		var sonTypeString = "";

    	if(ajaxObj.code == ajaxObj.constants.SUCCESS){
		var objs = ajaxObj.objs;
		$(objs).each(function(){
			audioId = this.get("audioId");
			audioName = this.get("audioName");
			audioImg = this.get("audioImg");
			audioUrl = this.get("audioUrl");
			audioLong = this.get("audioLong");
			createTime = this.get("createTime");
			playTime = this.get("playTime");
			customerCollectionId = this.get("customerCollectionId");
			belongType = this.get("belongType");
			belongTypeString = this.get('belongTypeString');
			sonType = this.get("sonType");
			sonTypeString = this.get("sonTypeString");
		})
	}
	
	audioId = window.sessionStorage.getItem("musicBackProgramId");
	audioName = window.sessionStorage.getItem("musicBackAudioName");
	sonType = window.sessionStorage.getItem("musicBackSonType");
	audioUrl = window.sessionStorage.getItem("musicBackAudioUrl");
	sonTypeString = window.sessionStorage.getItem("musicBackSonTypeString");
	var contentType = window.sessionStorage.getItem("musicBackContentType");
    var sonImg = window.sessionStorage.getItem("musicBackImg");
	//musicDetails_view2Html_items(playTime,CTPId_music,sonTypeString,audioImg,
		//audioName,customerCollectionId,audioId,audioUrl,sonType);
	musicDetails_view2Html_items(playTime,sonType,sonTypeString,sonImg,
		audioName,customerCollectionId,audioId,audioUrl,sonType);
	//设置标题
	musicDetails_setTitle(sonTypeString);
}
//.............音乐详情页 结束.......................
//四期添加的内容 结束